/**
 * tdesign v1.13.1
 * (c) 2025 tdesign
 * @license MIT
 */

'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var slicedToArray = require('../_chunks/dep-3012da29.js');
var React = require('react');
require('../_chunks/dep-7e3b8125.js');

var useScroll = function useScroll(props) {
  var target = props.target;
  var _useState = React.useState(0),
    _useState2 = slicedToArray._slicedToArray(_useState, 2),
    scrollLeft = _useState2[0],
    setScrollLeft = _useState2[1];
  var _useState3 = React.useState(0),
    _useState4 = slicedToArray._slicedToArray(_useState3, 2),
    scrollTop = _useState4[0],
    setScrollTop = _useState4[1];
  React.useEffect(function () {
    if (!target) return;
    var setPosition = function setPosition() {
      if (target === document) {
        setScrollLeft(target.documentElement.scrollLeft);
        setScrollTop(target.documentElement.scrollTop);
      } else {
        setScrollLeft(target.scrollLeft);
        setScrollTop(target.scrollTop);
      }
    };
    target.addEventListener("scroll", setPosition);
    return function () {
      target.removeEventListener("scroll", setPosition);
    };
  }, [target]);
  return {
    scrollLeft: scrollLeft,
    scrollTop: scrollTop
  };
};

exports["default"] = useScroll;
//# sourceMappingURL=useScroll.js.map
