/**
 * tdesign v1.13.1
 * (c) 2025 tdesign
 * @license MIT
 */

'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var defineProperty = require('../_chunks/dep-7a6528ec.js');
var slicedToArray = require('../_chunks/dep-3012da29.js');
var objectWithoutProperties = require('../_chunks/dep-e358a1dc.js');
var React = require('react');
var classNames = require('classnames');
var tdesignIconsReact = require('tdesign-icons-react');
var hooks_useConfig = require('../hooks/useConfig.js');
var hooks_useGlobalIcon = require('../hooks/useGlobalIcon.js');
var hooks_useCommonClassName = require('../hooks/useCommonClassName.js');
var breadcrumb_BreadcrumbContext = require('./BreadcrumbContext.js');
var _util_parseTNode = require('../_util/parseTNode.js');
var breadcrumb_defaultProps = require('./defaultProps.js');
var tooltip_index = require('../tooltip/index.js');
var hooks_useDefaultProps = require('../hooks/useDefaultProps.js');
var _util_scroll = require('../_util/scroll.js');
var isFunction = require('../_chunks/dep-e2240b05.js');
require('../_chunks/dep-c83f28a0.js');
require('../_chunks/dep-7e3b8125.js');
require('../config-provider/ConfigContext.js');
require('../_chunks/dep-1debbc3e.js');
require('../_chunks/dep-b4e78a42.js');
require('dayjs');
require('../_chunks/dep-fdd584c5.js');
require('../_chunks/dep-84fd1465.js');
require('../_chunks/dep-023db433.js');
require('../_chunks/dep-912bd8a2.js');
require('../_chunks/dep-0fccdcfb.js');
require('../_chunks/dep-78e8fc97.js');
require('../_chunks/dep-77879fb6.js');
require('../_chunks/dep-356859aa.js');
require('../_chunks/dep-413bc6a7.js');
require('../_chunks/dep-84d18206.js');
require('../_chunks/dep-5e1fc2cd.js');
require('../_chunks/dep-0be4d457.js');
require('../_chunks/dep-837f0312.js');
require('../_chunks/dep-6058edb6.js');
require('../_chunks/dep-cfe601e8.js');
require('../_chunks/dep-6c342676.js');
require('../_chunks/dep-8bd04901.js');
require('../_chunks/dep-2f3e85f6.js');
require('../_chunks/dep-3cfcca89.js');
require('../_chunks/dep-64afded1.js');
require('../_chunks/dep-a1d853fb.js');
require('../_chunks/dep-cc4e3925.js');
require('../tooltip/Tooltip.js');
require('../popup/index.js');
require('../popup/Popup.js');
require('react-transition-group');
require('../_util/ref.js');
require('react-is');
require('../_util/isFragment.js');
require('../_chunks/dep-68db2ca6.js');
require('../_chunks/dep-6e448b65.js');
require('../common/Portal.js');
require('react-dom');
require('../hooks/useLayoutEffect.js');
require('../hooks/useAnimation.js');
require('../hooks/useAttach.js');
require('../hooks/useControlled.js');
require('../_util/noop.js');
require('../_chunks/dep-00e10ad8.js');
require('../_chunks/dep-5d5d7b13.js');
require('../_chunks/dep-ba207e81.js');
require('../_chunks/dep-ed0d1cf9.js');
require('../_chunks/dep-665eea2b.js');
require('../hooks/useMutationObserver.js');
require('../hooks/useLatest.js');
require('../_chunks/dep-c73e0aa5.js');
require('../_chunks/dep-becc25b2.js');
require('../_chunks/dep-ba79870d.js');
require('../_chunks/dep-680d1e3e.js');
require('../_chunks/dep-a3962a45.js');
require('../_chunks/dep-b6bde0bc.js');
require('../_chunks/dep-f90d944e.js');
require('../_chunks/dep-46616204.js');
require('../_chunks/dep-7bb447f9.js');
require('../_chunks/dep-5941343f.js');
require('../hooks/usePopper.js');
require('../_chunks/dep-210ce7c8.js');
require('@popperjs/core');
require('react-fast-compare');
require('../hooks/useWindowSize.js');
require('../popup/defaultProps.js');
require('../popup/hooks/useTrigger.js');
require('../_util/composeRefs.js');
require('../_util/listener.js');
require('../popup/utils/transition.js');
require('../popup/PopupPlugin.js');
require('../_chunks/dep-608840a8.js');
require('../_util/react-render.js');
require('../common/PluginContainer.js');
require('../config-provider/ConfigProvider.js');
require('../_chunks/dep-34def105.js');
require('../_chunks/dep-cc2fe55a.js');
require('../tooltip/defaultProps.js');
require('../tooltip/TooltipLite.js');
require('../hooks/useSwitch.js');
require('../hooks/usePersistFn.js');
require('../_chunks/dep-8c89cfa8.js');
require('raf');
require('../_util/easing.js');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

var React__default = /*#__PURE__*/_interopDefaultLegacy(React);
var classNames__default = /*#__PURE__*/_interopDefaultLegacy(classNames);

var _excluded = ["children", "separator", "disabled", "maxItemWidth", "maxWidth", "icon", "href", "to", "target", "router", "replace", "className", "content", "onClick", "tooltipProps", "readOnly"];
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { defineProperty._defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
var BreadcrumbItem = /*#__PURE__*/React.forwardRef(function (props, ref) {
  var _useConfig = hooks_useConfig["default"](),
    classPrefix = _useConfig.classPrefix;
  var commonClassNames = hooks_useCommonClassName["default"]();
  var _useGlobalIcon = hooks_useGlobalIcon["default"]({
      ChevronRightIcon: tdesignIconsReact.ChevronRightIcon
    }),
    ChevronRightIcon = _useGlobalIcon.ChevronRightIcon;
  var _useDefaultProps = hooks_useDefaultProps["default"](props, breadcrumb_defaultProps.breadcrumbItemDefaultProps),
    children = _useDefaultProps.children,
    separator = _useDefaultProps.separator,
    disabled = _useDefaultProps.disabled,
    maxItemWidth = _useDefaultProps.maxItemWidth,
    maxWidth = _useDefaultProps.maxWidth,
    icon = _useDefaultProps.icon,
    href = _useDefaultProps.href,
    to = _useDefaultProps.to,
    target = _useDefaultProps.target,
    router = _useDefaultProps.router,
    replace = _useDefaultProps.replace,
    className = _useDefaultProps.className,
    content = _useDefaultProps.content,
    onClick = _useDefaultProps.onClick,
    tooltipProps = _useDefaultProps.tooltipProps,
    readonly = _useDefaultProps.readOnly,
    restProps = objectWithoutProperties._objectWithoutProperties(_useDefaultProps, _excluded);
  var _useContext = React.useContext(breadcrumb_BreadcrumbContext.BreadcrumbContext),
    maxItemWidthInContext = _useContext.maxItemWidthInContext,
    separatorInContext = _useContext.separator;
  var breadcrumbText = React.useRef(null);
  var _useState = React.useState(false),
    _useState2 = slicedToArray._slicedToArray(_useState, 2),
    isCutOff = _useState2[0],
    setIsCutOff = _useState2[1];
  var breadcrumbItemClassNames = classNames__default["default"]("".concat(classPrefix, "-breadcrumb__item"));
  var textWrapperClassName = "".concat(classPrefix, "-breadcrumb__inner");
  var textClassName = "".concat(classPrefix, "-breadcrumb__inner-text");
  var textClassNames = classNames__default["default"](defineProperty._defineProperty(defineProperty._defineProperty({}, "".concat(classPrefix, "-breadcrumb--text-overflow"), !readonly), commonClassNames.STATUS.disabled, disabled));
  var separatorClassName = "".concat(classPrefix, "-breadcrumb__separator");
  var linkClassName = "".concat(classPrefix, "-link");
  var maxWidthForItem = React.useMemo(function () {
    return {
      maxWidth: maxWidth || maxItemWidth || maxItemWidthInContext || "120px"
    };
  }, [maxItemWidth, maxWidth, maxItemWidthInContext]);
  React.useEffect(function () {
    if (!breadcrumbText.current) return;
    return setIsCutOff(_util_scroll.isNodeOverflow(breadcrumbText.current));
  }, [breadcrumbText]);
  var textContent = /* @__PURE__ */React__default["default"].createElement("span", {
    className: textWrapperClassName,
    style: maxWidthForItem
  }, isFunction.isFunction(icon) ? icon() : icon, /* @__PURE__ */React__default["default"].createElement("span", {
    ref: breadcrumbText,
    className: textClassName
  }, children || content));
  var itemContent = /* @__PURE__ */React__default["default"].createElement("span", {
    className: textClassNames
  }, textContent);
  if ((href || to) && !disabled) {
    var handleRouting = function handleRouting() {
      if (href || !router) return;
      replace ? router.replace(to) : router.push(to);
    };
    itemContent = /* @__PURE__ */React__default["default"].createElement("a", {
      className: classNames__default["default"](textClassNames, linkClassName),
      href: href,
      target: target,
      onClick: handleRouting
    }, textContent);
  }
  var separatorInProps = _util_parseTNode["default"](separator);
  var separatorContent = separatorInProps || separatorInContext || /* @__PURE__ */React__default["default"].createElement(ChevronRightIcon, {
    style: {
      opacity: ".5"
    }
  });
  var handleClick = function handleClick(e) {
    if (disabled) return;
    onClick === null || onClick === void 0 || onClick(e);
  };
  return /* @__PURE__ */React__default["default"].createElement("div", _objectSpread({
    className: classNames__default["default"](breadcrumbItemClassNames, className),
    ref: ref,
    onClick: handleClick
  }, restProps), isCutOff ? /* @__PURE__ */React__default["default"].createElement(tooltip_index.TooltipLite, _objectSpread({
    content: children || content
  }, tooltipProps), itemContent) : itemContent, /* @__PURE__ */React__default["default"].createElement("span", {
    className: separatorClassName
  }, separatorContent));
});
BreadcrumbItem.displayName = "BreadcrumbItem";

exports["default"] = BreadcrumbItem;
//# sourceMappingURL=BreadcrumbItem.js.map
