/**
 * tdesign v1.13.1
 * (c) 2025 tdesign
 * @license MIT
 */

'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var defineProperty = require('../_chunks/dep-7a6528ec.js');
var React = require('react');
var classNames = require('classnames');
var loading_index = require('../loading/index.js');
var hooks_useConfig = require('../hooks/useConfig.js');
var hooks_useCommonClassName = require('../hooks/useCommonClassName.js');
var card_defaultProps = require('./defaultProps.js');
var hooks_useDefaultProps = require('../hooks/useDefaultProps.js');
require('../_chunks/dep-c83f28a0.js');
require('../loading/Loading.js');
require('../_chunks/dep-3012da29.js');
require('../_chunks/dep-7e3b8125.js');
require('../_chunks/dep-68db2ca6.js');
require('../_chunks/dep-6e448b65.js');
require('../_chunks/dep-912bd8a2.js');
require('../_chunks/dep-78e8fc97.js');
require('../_chunks/dep-0fccdcfb.js');
require('../common/Portal.js');
require('react-dom');
require('../hooks/useLayoutEffect.js');
require('../loading/gradient.js');
require('../_chunks/dep-8593a497.js');
require('../_chunks/dep-f34d3a30.js');
require('../_chunks/dep-210ce7c8.js');
require('../_chunks/dep-b47ed304.js');
require('../hooks/useDomRefCallback.js');
require('../loading/defaultProps.js');
require('../config-provider/ConfigContext.js');
require('../_chunks/dep-1debbc3e.js');
require('../_chunks/dep-b4e78a42.js');
require('dayjs');
require('../_chunks/dep-fdd584c5.js');
require('../_chunks/dep-84fd1465.js');
require('../_chunks/dep-023db433.js');
require('../_chunks/dep-77879fb6.js');
require('../_chunks/dep-356859aa.js');
require('../_chunks/dep-e2240b05.js');
require('../_chunks/dep-837f0312.js');
require('../_chunks/dep-413bc6a7.js');
require('../_chunks/dep-84d18206.js');
require('../_chunks/dep-5e1fc2cd.js');
require('../_chunks/dep-0be4d457.js');
require('../_chunks/dep-6058edb6.js');
require('../_chunks/dep-cfe601e8.js');
require('../_chunks/dep-6c342676.js');
require('../_chunks/dep-8bd04901.js');
require('../_chunks/dep-2f3e85f6.js');
require('../_chunks/dep-3cfcca89.js');
require('../_chunks/dep-64afded1.js');
require('../_chunks/dep-a1d853fb.js');
require('../loading/plugin.js');
require('../_util/react-render.js');
require('../_chunks/dep-608840a8.js');
require('../common/PluginContainer.js');
require('../config-provider/ConfigProvider.js');
require('../_chunks/dep-34def105.js');
require('../_chunks/dep-cc2fe55a.js');
require('../_chunks/dep-680d1e3e.js');
require('../_chunks/dep-a3962a45.js');
require('../_chunks/dep-b6bde0bc.js');
require('../_chunks/dep-f90d944e.js');
require('../_chunks/dep-46616204.js');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

var React__default = /*#__PURE__*/_interopDefaultLegacy(React);
var classNames__default = /*#__PURE__*/_interopDefaultLegacy(classNames);

function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { defineProperty._defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
var Card = /*#__PURE__*/React.forwardRef(function (props, ref) {
  var _props$children;
  var _useDefaultProps = hooks_useDefaultProps["default"](props, card_defaultProps.cardDefaultProps),
    actions = _useDefaultProps.actions,
    avatar = _useDefaultProps.avatar,
    bordered = _useDefaultProps.bordered,
    className = _useDefaultProps.className,
    cover = _useDefaultProps.cover,
    description = _useDefaultProps.description,
    footer = _useDefaultProps.footer,
    header = _useDefaultProps.header,
    headerBordered = _useDefaultProps.headerBordered,
    hoverShadow = _useDefaultProps.hoverShadow,
    loading = _useDefaultProps.loading,
    shadow = _useDefaultProps.shadow,
    size = _useDefaultProps.size,
    style = _useDefaultProps.style,
    subtitle = _useDefaultProps.subtitle,
    title = _useDefaultProps.title,
    theme = _useDefaultProps.theme,
    status = _useDefaultProps.status,
    loadingProps = _useDefaultProps.loadingProps;
  var children = (_props$children = props.children) !== null && _props$children !== void 0 ? _props$children : props.content;
  var _useConfig = hooks_useConfig["default"](),
    classPrefix = _useConfig.classPrefix;
  var commonClassNames = hooks_useCommonClassName["default"]();
  var isPoster2 = theme === "poster2";
  var cardClass = classNames__default["default"]("".concat(classPrefix, "-card"), className, defineProperty._defineProperty(defineProperty._defineProperty(defineProperty._defineProperty(defineProperty._defineProperty({}, commonClassNames.SIZE.small, size === "small"), "".concat(classPrefix, "-card--bordered"), bordered), "".concat(classPrefix, "-card--shadow"), shadow), "".concat(classPrefix, "-card--shadow-hover"), hoverShadow));
  var showHeader = header || title || subtitle || description || avatar || actions && !isPoster2 || status && isPoster2;
  var headerClass = classNames__default["default"](defineProperty._defineProperty(defineProperty._defineProperty({}, "".concat(classPrefix, "-card__header"), showHeader), "".concat(classPrefix, "-card__title--bordered"), headerBordered));
  var titleClass = classNames__default["default"](defineProperty._defineProperty({}, "".concat(classPrefix, "-card__title"), title));
  var subtitleClass = classNames__default["default"](defineProperty._defineProperty({}, "".concat(classPrefix, "-card__subtitle"), subtitle));
  var actionClass = classNames__default["default"](defineProperty._defineProperty({}, "".concat(classPrefix, "-card__actions"), actions));
  var footerClass = classNames__default["default"](defineProperty._defineProperty({}, "".concat(classPrefix, "-card__footer"), footer));
  var coverClass = classNames__default["default"](defineProperty._defineProperty({}, "".concat(classPrefix, "-card__cover"), cover));
  var avatarClass = classNames__default["default"](defineProperty._defineProperty({}, "".concat(classPrefix, "-card__avatar"), avatar));
  var bodyClass = classNames__default["default"](defineProperty._defineProperty({}, "".concat(classPrefix, "-card__body"), children));
  var descriptionClass = classNames__default["default"](defineProperty._defineProperty({}, "".concat(classPrefix, "-card__description"), description));
  var renderTitle = title ? /* @__PURE__ */React__default["default"].createElement("div", {
    className: titleClass
  }, title) : null;
  var renderSubtitle = subtitle ? /* @__PURE__ */React__default["default"].createElement("div", {
    className: subtitleClass
  }, subtitle) : null;
  var renderDescription = description ? /* @__PURE__ */React__default["default"].createElement("p", {
    className: descriptionClass
  }, description) : null;
  var renderAvatar = avatar && /* @__PURE__ */React__default["default"].createElement("div", {
    className: avatarClass
  }, avatar);
  var renderHeaderActions = actions && !isPoster2 && /* @__PURE__ */React__default["default"].createElement("div", {
    className: actionClass
  }, actions);
  var renderFooterActions = actions && isPoster2 && /* @__PURE__ */React__default["default"].createElement("div", {
    className: actionClass
  }, actions);
  var renderStatus = status && isPoster2 && /* @__PURE__ */React__default["default"].createElement("div", {
    className: actionClass
  }, status);
  var renderHeader = function renderHeader() {
    if (header) {
      return /* @__PURE__ */React__default["default"].createElement("div", {
        className: headerClass
      }, header);
    }
    return /* @__PURE__ */React__default["default"].createElement("div", {
      className: headerClass
    }, /* @__PURE__ */React__default["default"].createElement("div", {
      className: "".concat(classPrefix, "-card__header-wrapper")
    }, renderAvatar, /* @__PURE__ */React__default["default"].createElement("div", null, renderTitle, renderSubtitle, renderDescription)), renderHeaderActions, renderStatus);
  };
  var renderCover = cover ? /* @__PURE__ */React__default["default"].createElement("div", {
    className: coverClass
  }, typeof cover === "string" ? /* @__PURE__ */React__default["default"].createElement("img", {
    src: cover,
    alt: ""
  }) : cover) : null;
  var renderChildren = children && /* @__PURE__ */React__default["default"].createElement("div", {
    className: bodyClass
  }, children);
  var renderFooter = footer && /* @__PURE__ */React__default["default"].createElement("div", {
    className: footerClass
  }, /* @__PURE__ */React__default["default"].createElement("div", {
    className: "".concat(classPrefix, "-card__footer-wrapper")
  }, footer), renderFooterActions);
  var card = /* @__PURE__ */React__default["default"].createElement(React__default["default"].Fragment, null, showHeader ? renderHeader() : null, renderCover, renderChildren, renderFooter);
  var childrenNode = null;
  if (!Reflect.has(props, "loading")) {
    childrenNode = card;
  } else if (/*#__PURE__*/React__default["default"].isValidElement(loading)) {
    childrenNode = /*#__PURE__*/React__default["default"].cloneElement(loading, null, card);
  } else {
    childrenNode = /* @__PURE__ */React__default["default"].createElement(loading_index.Loading, _objectSpread(_objectSpread({}, loadingProps), {}, {
      loading: !!loading
    }), card);
  }
  return /* @__PURE__ */React__default["default"].createElement("div", {
    ref: ref,
    className: cardClass,
    style: style
  }, childrenNode);
});
Card.displayName = "Card";

exports["default"] = Card;
//# sourceMappingURL=Card.js.map
