/**
 * tdesign v1.13.1
 * (c) 2025 tdesign
 * @license MIT
 */

'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var defineProperty = require('../_chunks/dep-7a6528ec.js');
var slicedToArray = require('../_chunks/dep-3012da29.js');
var React = require('react');
var classNames = require('classnames');
var cascader_components_Panel = require('./components/Panel.js');
var selectInput_index = require('../select-input/index.js');
var common_FakeArrow = require('../common/FakeArrow.js');
var hooks_useConfig = require('../hooks/useConfig.js');
var hooks_useCommonClassName = require('../hooks/useCommonClassName.js');
var locale_LocalReceiver = require('../locale/LocalReceiver.js');
var cascader_core_effect = require('./core/effect.js');
var cascader_core_helper = require('./core/helper.js');
var cascader_core_className = require('./core/className.js');
var cascader_hooks = require('./hooks.js');
var cascader_defaultProps = require('./defaultProps.js');
var hooks_useDefaultProps = require('../hooks/useDefaultProps.js');
var _util_parseTNode = require('../_util/parseTNode.js');
var pick = require('../_chunks/dep-52a009fb.js');
var omit = require('../_chunks/dep-f4d31431.js');
require('../_chunks/dep-c83f28a0.js');
require('../_chunks/dep-7e3b8125.js');
require('./components/Item.js');
require('tdesign-icons-react');
require('../loading/index.js');
require('../loading/Loading.js');
require('../_chunks/dep-68db2ca6.js');
require('../_chunks/dep-6e448b65.js');
require('../_chunks/dep-912bd8a2.js');
require('../_chunks/dep-78e8fc97.js');
require('../_chunks/dep-0fccdcfb.js');
require('../common/Portal.js');
require('react-dom');
require('../hooks/useLayoutEffect.js');
require('../loading/gradient.js');
require('../_chunks/dep-8593a497.js');
require('../_chunks/dep-f34d3a30.js');
require('../_chunks/dep-210ce7c8.js');
require('../_chunks/dep-b47ed304.js');
require('../hooks/useDomRefCallback.js');
require('../loading/defaultProps.js');
require('../config-provider/ConfigContext.js');
require('../_chunks/dep-1debbc3e.js');
require('../_chunks/dep-b4e78a42.js');
require('dayjs');
require('../_chunks/dep-fdd584c5.js');
require('../_chunks/dep-84fd1465.js');
require('../_chunks/dep-023db433.js');
require('../_chunks/dep-77879fb6.js');
require('../_chunks/dep-356859aa.js');
require('../_chunks/dep-e2240b05.js');
require('../_chunks/dep-837f0312.js');
require('../_chunks/dep-413bc6a7.js');
require('../_chunks/dep-84d18206.js');
require('../_chunks/dep-5e1fc2cd.js');
require('../_chunks/dep-0be4d457.js');
require('../_chunks/dep-6058edb6.js');
require('../_chunks/dep-cfe601e8.js');
require('../_chunks/dep-6c342676.js');
require('../_chunks/dep-8bd04901.js');
require('../_chunks/dep-2f3e85f6.js');
require('../_chunks/dep-3cfcca89.js');
require('../_chunks/dep-64afded1.js');
require('../_chunks/dep-a1d853fb.js');
require('../loading/plugin.js');
require('../_util/react-render.js');
require('../_chunks/dep-608840a8.js');
require('../common/PluginContainer.js');
require('../config-provider/ConfigProvider.js');
require('../_chunks/dep-34def105.js');
require('../_chunks/dep-cc2fe55a.js');
require('../_chunks/dep-680d1e3e.js');
require('../_chunks/dep-a3962a45.js');
require('../_chunks/dep-b6bde0bc.js');
require('../_chunks/dep-f90d944e.js');
require('../_chunks/dep-46616204.js');
require('../checkbox/index.js');
require('../_chunks/dep-fef35254.js');
require('../_util/forwardRefWithStatics.js');
require('hoist-non-react-statics');
require('../common/Check.js');
require('../_chunks/dep-e358a1dc.js');
require('../_util/helper.js');
require('../_chunks/dep-1819e167.js');
require('../_chunks/dep-ed0d1cf9.js');
require('../_chunks/dep-665eea2b.js');
require('../_chunks/dep-00e10ad8.js');
require('../_chunks/dep-5d5d7b13.js');
require('../_chunks/dep-ba207e81.js');
require('../hooks/useControlled.js');
require('../_util/noop.js');
require('../_chunks/dep-69751dfb.js');
require('../checkbox/defaultProps.js');
require('../hooks/useGlobalIcon.js');
require('../select-input/SelectInput.js');
require('../popup/index.js');
require('../popup/Popup.js');
require('react-transition-group');
require('../_util/ref.js');
require('react-is');
require('../_util/isFragment.js');
require('../hooks/useAnimation.js');
require('../hooks/useAttach.js');
require('../hooks/useMutationObserver.js');
require('../hooks/useLatest.js');
require('../_chunks/dep-c73e0aa5.js');
require('../_chunks/dep-becc25b2.js');
require('../_chunks/dep-ba79870d.js');
require('../_chunks/dep-7bb447f9.js');
require('../_chunks/dep-5941343f.js');
require('../hooks/usePopper.js');
require('@popperjs/core');
require('react-fast-compare');
require('../hooks/useWindowSize.js');
require('../popup/defaultProps.js');
require('../popup/hooks/useTrigger.js');
require('../_util/composeRefs.js');
require('../_util/listener.js');
require('../popup/utils/transition.js');
require('../popup/PopupPlugin.js');
require('../select-input/useSingle.js');
require('../input/index.js');
require('../input/Input.js');
require('../input/InputGroup.js');
require('../input/defaultProps.js');
require('../input/useLengthLimit.js');
require('../_chunks/dep-cc4e3925.js');
require('../select-input/useMultiple.js');
require('../tag-input/index.js');
require('../tag-input/TagInput.js');
require('../hooks/useDragSorter.js');
require('../hooks/useEventCallback.js');
require('../tag-input/useTagScroll.js');
require('../tag-input/useTagList.js');
require('../tag/index.js');
require('../tag/Tag.js');
require('tinycolor2');
require('../tag/defaultProps.js');
require('../tag/CheckTag.js');
require('../_chunks/dep-59a9c125.js');
require('../tag/CheckTagGroup.js');
require('../tag-input/useHover.js');
require('../tag-input/defaultProps.js');
require('../select-input/useOverlayInnerStyle.js');
require('../select-input/defaultProps.js');
require('../_chunks/dep-8529ce07.js');
require('../_chunks/dep-962f011a.js');
require('../_chunks/dep-58cddfe4.js');
require('../_chunks/dep-c29b655c.js');
require('../_chunks/dep-d843946a.js');
require('../_chunks/dep-f0441248.js');
require('../_chunks/dep-b571b0e0.js');
require('../_chunks/dep-560c14c5.js');
require('mitt');
require('../_chunks/dep-8ee4aae7.js');
require('../_chunks/dep-dfe5fb78.js');
require('../_chunks/dep-8a28dfd9.js');
require('../_chunks/dep-d9f53773.js');
require('../_chunks/dep-c1986661.js');
require('../_chunks/dep-bb56a94e.js');
require('../_chunks/dep-2545fc22.js');
require('../_chunks/dep-a09b28f5.js');
require('../_chunks/dep-be9040ff.js');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

var React__default = /*#__PURE__*/_interopDefaultLegacy(React);
var classNames__default = /*#__PURE__*/_interopDefaultLegacy(classNames);

function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { defineProperty._defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
var Cascader = function Cascader(originalProps) {
  var _props$popupProps;
  var props = hooks_useDefaultProps["default"](originalProps, cascader_defaultProps.cascaderDefaultProps);
  var _useConfig = hooks_useConfig["default"](),
    classPrefix = _useConfig.classPrefix;
  var _useCommonClassName = hooks_useCommonClassName["default"](),
    STATUS = _useCommonClassName.STATUS;
  var _useLocaleReceiver = locale_LocalReceiver.useLocaleReceiver("cascader"),
    _useLocaleReceiver2 = slicedToArray._slicedToArray(_useLocaleReceiver, 1),
    global = _useLocaleReceiver2[0];
  var COMPONENT_NAME = "".concat(classPrefix, "-cascader");
  var _useCascaderContext = cascader_hooks.useCascaderContext(props),
    cascaderContext = _useCascaderContext.cascaderContext,
    isFilterable = _useCascaderContext.isFilterable,
    innerValue = _useCascaderContext.innerValue,
    getCascaderItems = _useCascaderContext.getCascaderItems;
  var displayValue = React.useMemo(function () {
    return props.multiple ? cascader_core_helper.getMultipleContent(cascaderContext) : cascader_core_helper.getSingleContent(cascaderContext);
  }, [props.multiple, cascaderContext]);
  var panels = React.useMemo(function () {
    return cascader_core_helper.getPanels(cascaderContext.treeNodes);
  }, [cascaderContext]);
  var inputPlaceholder = React.useMemo(function () {
    var _props$placeholder;
    return cascaderContext.visible && !props.multiple && cascader_core_helper.getSingleContent(cascaderContext) || ((_props$placeholder = props.placeholder) !== null && _props$placeholder !== void 0 ? _props$placeholder : global.placeholder);
  }, [props.placeholder, cascaderContext, props.multiple, global.placeholder]);
  var renderSuffixIcon = function renderSuffixIcon() {
    if (props.suffixIcon) {
      return props.suffixIcon;
    }
    var visible2 = cascaderContext.visible,
      disabled = cascaderContext.disabled;
    return /* @__PURE__ */React__default["default"].createElement(common_FakeArrow["default"], {
      className: cascader_core_className.getFakeArrowIconClass(classPrefix, STATUS, cascaderContext),
      isActive: visible2,
      disabled: disabled
    });
  };
  var renderLabel = function renderLabel() {
    var label = _util_parseTNode["default"](props.label);
    if (props.multiple) return label;
    if (!label) return null;
    return /* @__PURE__ */React__default["default"].createElement("div", {
      className: "".concat(classPrefix, "-tag-input__prefix")
    }, label);
  };
  var valueDisplayParams = React.useMemo(function () {
    var arrayValue = innerValue instanceof Array ? innerValue : [innerValue];
    var displayValue2 = props.multiple && props.minCollapsedNum ? arrayValue.slice(0, props.minCollapsedNum) : innerValue;
    var options = getCascaderItems(arrayValue);
    return {
      value: innerValue,
      selectedOptions: options,
      onClose: function onClose(index) {
        cascader_core_effect.handleRemoveTagEffect(cascaderContext, index, props.onRemove);
      },
      displayValue: displayValue2
    };
  }, [cascaderContext, innerValue, props.multiple, props.minCollapsedNum, props.onRemove, getCascaderItems]);
  var renderValueDisplay = function renderValueDisplay() {
    return _util_parseTNode.parseContentTNode(props.valueDisplay, valueDisplayParams);
  };
  var setVisible = cascaderContext.setVisible,
    visible = cascaderContext.visible,
    inputVal = cascaderContext.inputVal,
    setInputVal = cascaderContext.setInputVal;
  var updateScrollTop = function updateScrollTop(content) {
    var cascaderMenuList = content.querySelectorAll(".".concat(COMPONENT_NAME, "__menu"));
    requestAnimationFrame(function () {
      cascaderMenuList.forEach(function (menu) {
        var firstSelectedNode = (menu === null || menu === void 0 ? void 0 : menu.querySelector(".".concat(classPrefix, "-is-selected"))) || (menu === null || menu === void 0 ? void 0 : menu.querySelector(".".concat(classPrefix, "-is-expanded")));
        if (!firstSelectedNode || !menu) return;
        var _getComputedStyle = getComputedStyle(firstSelectedNode),
          paddingBottom = _getComputedStyle.paddingBottom;
        var _getComputedStyle2 = getComputedStyle(menu),
          marginBottom = _getComputedStyle2.marginBottom;
        var elementBottomHeight = parseInt(paddingBottom, 10) + parseInt(marginBottom, 10);
        var updateValue = firstSelectedNode.offsetTop - menu.offsetTop - (menu.clientHeight - firstSelectedNode.clientHeight) + elementBottomHeight;
        menu.scrollTop = updateValue;
      });
    });
  };
  return /* @__PURE__ */React__default["default"].createElement(selectInput_index.SelectInput, _objectSpread(_objectSpread({
    className: classNames__default["default"](COMPONENT_NAME, props.className),
    style: props.style,
    value: displayValue,
    borderless: props.borderless,
    inputValue: visible ? inputVal : "",
    popupVisible: visible,
    allowInput: isFilterable,
    minCollapsedNum: props.minCollapsedNum,
    collapsedItems: props.collapsedItems,
    readonly: props.readonly,
    clearable: props.clearable,
    placeholder: inputPlaceholder,
    multiple: props.multiple,
    loading: props.loading,
    disabled: props.disabled,
    status: props.status,
    tips: props.tips,
    label: renderLabel(),
    valueDisplay: renderValueDisplay(),
    suffix: props.suffix,
    suffixIcon: renderSuffixIcon(),
    updateScrollTop: updateScrollTop,
    popupProps: _objectSpread(_objectSpread({}, props.popupProps), {}, {
      overlayInnerStyle: panels.length && !props.loading ? {
        width: "auto"
      } : {},
      overlayClassName: ["".concat(classPrefix, "-cascader__popup"), (_props$popupProps = props.popupProps) === null || _props$popupProps === void 0 ? void 0 : _props$popupProps.overlayClassName]
    }),
    inputProps: _objectSpread({
      size: props.size
    }, props.inputProps),
    tagInputProps: _objectSpread({
      size: props.size
    }, props.tagInputProps),
    tagProps: _objectSpread({}, props.tagProps),
    onInputChange: function onInputChange(value, ctx) {
      var _props$selectInputPro, _props$selectInputPro2;
      if (!visible || (ctx === null || ctx === void 0 ? void 0 : ctx.trigger) === "clear") {
        return;
      }
      setInputVal("".concat(value));
      props === null || props === void 0 || (_props$selectInputPro = props.selectInputProps) === null || _props$selectInputPro === void 0 || (_props$selectInputPro2 = _props$selectInputPro.onInputChange) === null || _props$selectInputPro2 === void 0 || _props$selectInputPro2.call(_props$selectInputPro, value, ctx);
    },
    onTagChange: function onTagChange(val, ctx) {
      var _props$selectInputPro3, _props$selectInputPro4;
      if (ctx.trigger === "enter" || ctx.trigger === "clear") {
        return;
      }
      cascader_core_effect.handleRemoveTagEffect(cascaderContext, ctx.index, props.onRemove);
      props === null || props === void 0 || (_props$selectInputPro3 = props.selectInputProps) === null || _props$selectInputPro3 === void 0 || (_props$selectInputPro4 = _props$selectInputPro3.onTagChange) === null || _props$selectInputPro4 === void 0 || _props$selectInputPro4.call(_props$selectInputPro3, val, ctx);
    },
    onPopupVisibleChange: function onPopupVisibleChange(val, context) {
      var _props$selectInputPro5, _props$selectInputPro6;
      if (props.disabled) {
        return;
      }
      setVisible(val, context);
      props === null || props === void 0 || (_props$selectInputPro5 = props.selectInputProps) === null || _props$selectInputPro5 === void 0 || (_props$selectInputPro6 = _props$selectInputPro5.onPopupVisibleChange) === null || _props$selectInputPro6 === void 0 || _props$selectInputPro6.call(_props$selectInputPro5, val, context);
    },
    onBlur: function onBlur(val, context) {
      var _props$onBlur, _props$selectInputPro7, _props$selectInputPro8;
      (_props$onBlur = props.onBlur) === null || _props$onBlur === void 0 || _props$onBlur.call(props, {
        value: cascaderContext.value,
        e: context.e,
        inputValue: inputVal
      });
      props === null || props === void 0 || (_props$selectInputPro7 = props.selectInputProps) === null || _props$selectInputPro7 === void 0 || (_props$selectInputPro8 = _props$selectInputPro7.onBlur) === null || _props$selectInputPro8 === void 0 || _props$selectInputPro8.call(_props$selectInputPro7, val, context);
    },
    onFocus: function onFocus(val, context) {
      var _props$onFocus, _props$selectInputPro9, _props$selectInputPro0;
      (_props$onFocus = props.onFocus) === null || _props$onFocus === void 0 || _props$onFocus.call(props, {
        value: cascaderContext.value,
        e: context.e
      });
      props === null || props === void 0 || (_props$selectInputPro9 = props.selectInputProps) === null || _props$selectInputPro9 === void 0 || (_props$selectInputPro0 = _props$selectInputPro9.onFocus) === null || _props$selectInputPro0 === void 0 || _props$selectInputPro0.call(_props$selectInputPro9, val, context);
    },
    onClear: function onClear(context) {
      var _props$selectInputPro1, _props$selectInputPro10, _props$onClear;
      cascader_core_effect.closeIconClickEffect(cascaderContext);
      props === null || props === void 0 || (_props$selectInputPro1 = props.selectInputProps) === null || _props$selectInputPro1 === void 0 || (_props$selectInputPro10 = _props$selectInputPro1.onClear) === null || _props$selectInputPro10 === void 0 || _props$selectInputPro10.call(_props$selectInputPro1, context);
      (_props$onClear = props.onClear) === null || _props$onClear === void 0 || _props$onClear.call(props, context);
    }
  }, omit.omit(props.selectInputProps, ["onTagChange", "onInputChange", "onPopupVisibleChange", "onBlur", "onFocus", "onClear"])), {}, {
    panel: /* @__PURE__ */React__default["default"].createElement(React__default["default"].Fragment, null, props.panelTopContent && _util_parseTNode["default"](props.panelTopContent), /* @__PURE__ */React__default["default"].createElement(cascader_components_Panel["default"], _objectSpread({
      cascaderContext: cascaderContext
    }, pick.pick(props, ["trigger", "onChange", "empty", "loading", "loadingText", "option"]))), props.panelBottomContent && _util_parseTNode["default"](props.panelBottomContent))
  }));
};
Cascader.displayName = "Cascader";

exports["default"] = Cascader;
//# sourceMappingURL=Cascader.js.map
