/**
 * tdesign v1.13.1
 * (c) 2025 tdesign
 * @license MIT
 */

'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var defineProperty = require('../_chunks/dep-7a6528ec.js');
var React = require('react');
var classNames = require('classnames');
var cascader_components_Panel = require('./components/Panel.js');
var cascader_hooks = require('./hooks.js');
var cascader_defaultProps = require('./defaultProps.js');
var hooks_useDefaultProps = require('../hooks/useDefaultProps.js');
var pick = require('../_chunks/dep-52a009fb.js');
require('../_chunks/dep-c83f28a0.js');
require('../_chunks/dep-3012da29.js');
require('../_chunks/dep-7e3b8125.js');
require('./components/Item.js');
require('tdesign-icons-react');
require('../loading/index.js');
require('../loading/Loading.js');
require('../_chunks/dep-68db2ca6.js');
require('../_chunks/dep-6e448b65.js');
require('../_chunks/dep-912bd8a2.js');
require('../_chunks/dep-78e8fc97.js');
require('../_chunks/dep-0fccdcfb.js');
require('../hooks/useConfig.js');
require('../config-provider/ConfigContext.js');
require('../_chunks/dep-1debbc3e.js');
require('../_chunks/dep-b4e78a42.js');
require('dayjs');
require('../_chunks/dep-fdd584c5.js');
require('../_chunks/dep-84fd1465.js');
require('../_chunks/dep-023db433.js');
require('../_chunks/dep-77879fb6.js');
require('../_chunks/dep-356859aa.js');
require('../_chunks/dep-e2240b05.js');
require('../_chunks/dep-837f0312.js');
require('../_chunks/dep-413bc6a7.js');
require('../_chunks/dep-84d18206.js');
require('../_chunks/dep-5e1fc2cd.js');
require('../_chunks/dep-0be4d457.js');
require('../_chunks/dep-6058edb6.js');
require('../_chunks/dep-cfe601e8.js');
require('../_chunks/dep-6c342676.js');
require('../_chunks/dep-8bd04901.js');
require('../_chunks/dep-2f3e85f6.js');
require('../_chunks/dep-3cfcca89.js');
require('../_chunks/dep-64afded1.js');
require('../_chunks/dep-a1d853fb.js');
require('../common/Portal.js');
require('react-dom');
require('../hooks/useLayoutEffect.js');
require('../loading/gradient.js');
require('../_chunks/dep-8593a497.js');
require('../_chunks/dep-f34d3a30.js');
require('../_chunks/dep-210ce7c8.js');
require('../_chunks/dep-b47ed304.js');
require('../hooks/useDomRefCallback.js');
require('../loading/defaultProps.js');
require('../loading/plugin.js');
require('../_util/react-render.js');
require('../_chunks/dep-608840a8.js');
require('../common/PluginContainer.js');
require('../config-provider/ConfigProvider.js');
require('../_chunks/dep-34def105.js');
require('../_chunks/dep-cc2fe55a.js');
require('../_chunks/dep-680d1e3e.js');
require('../_chunks/dep-a3962a45.js');
require('../_chunks/dep-b6bde0bc.js');
require('../_chunks/dep-f90d944e.js');
require('../_chunks/dep-46616204.js');
require('../checkbox/index.js');
require('../_chunks/dep-fef35254.js');
require('../_util/forwardRefWithStatics.js');
require('hoist-non-react-statics');
require('../common/Check.js');
require('../_chunks/dep-e358a1dc.js');
require('../_util/helper.js');
require('../_chunks/dep-1819e167.js');
require('../_chunks/dep-ed0d1cf9.js');
require('../_chunks/dep-665eea2b.js');
require('../_chunks/dep-00e10ad8.js');
require('../_chunks/dep-5d5d7b13.js');
require('../_chunks/dep-ba207e81.js');
require('../hooks/useControlled.js');
require('../_util/noop.js');
require('../_chunks/dep-69751dfb.js');
require('../checkbox/defaultProps.js');
require('../hooks/useGlobalIcon.js');
require('../hooks/useCommonClassName.js');
require('./core/helper.js');
require('../_chunks/dep-f0441248.js');
require('./core/className.js');
require('../locale/LocalReceiver.js');
require('./core/effect.js');
require('../_util/parseTNode.js');
require('../_chunks/dep-cc4e3925.js');
require('../_chunks/dep-b571b0e0.js');
require('../_chunks/dep-560c14c5.js');
require('mitt');
require('../_chunks/dep-8ee4aae7.js');
require('../_chunks/dep-f4d31431.js');
require('../_chunks/dep-8529ce07.js');
require('../_chunks/dep-be9040ff.js');
require('../_chunks/dep-c29b655c.js');
require('../_chunks/dep-d843946a.js');
require('../_chunks/dep-dfe5fb78.js');
require('../_chunks/dep-8a28dfd9.js');
require('../_chunks/dep-d9f53773.js');
require('../_chunks/dep-c1986661.js');
require('../_chunks/dep-bb56a94e.js');
require('../_chunks/dep-2545fc22.js');
require('../_chunks/dep-becc25b2.js');
require('../_chunks/dep-a09b28f5.js');
require('../_chunks/dep-c73e0aa5.js');
require('../_chunks/dep-ba79870d.js');
require('../_chunks/dep-962f011a.js');
require('../_chunks/dep-58cddfe4.js');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

var React__default = /*#__PURE__*/_interopDefaultLegacy(React);
var classNames__default = /*#__PURE__*/_interopDefaultLegacy(classNames);

function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { defineProperty._defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
var CascaderPanel = function CascaderPanel(originalProps) {
  var props = hooks_useDefaultProps["default"](originalProps, cascader_defaultProps.cascaderDefaultProps);
  var _useCascaderContext = cascader_hooks.useCascaderContext(props),
    cascaderContext = _useCascaderContext.cascaderContext;
  return /* @__PURE__ */React__default["default"].createElement(cascader_components_Panel["default"], _objectSpread({
    className: classNames__default["default"](props.className),
    style: props.style,
    cascaderContext: cascaderContext
  }, pick.pick(props, ["trigger", "onChange", "empty", "option"])));
};
CascaderPanel.displayName = "CascaderPanel";

exports["default"] = CascaderPanel;
//# sourceMappingURL=CascaderPanel.js.map
