/**
 * tdesign v1.13.1
 * (c) 2025 tdesign
 * @license MIT
 */

'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var slicedToArray = require('../../../_chunks/dep-3012da29.js');
var React = require('react');
var constants = require('../../../_chunks/dep-4240569e.js');
var radio_index = require('../../../radio/index.js');
var locale_LocalReceiver = require('../../../locale/LocalReceiver.js');
require('../../../_chunks/dep-7e3b8125.js');
require('../../../_chunks/dep-271574af.js');
require('../../../_chunks/dep-7a6528ec.js');
require('../../../_chunks/dep-c83f28a0.js');
require('../../../_util/forwardRefWithStatics.js');
require('hoist-non-react-statics');
require('../../../common/Check.js');
require('../../../_chunks/dep-e358a1dc.js');
require('classnames');
require('../../../_util/helper.js');
require('../../../_chunks/dep-1819e167.js');
require('../../../_chunks/dep-ed0d1cf9.js');
require('../../../_chunks/dep-912bd8a2.js');
require('../../../_chunks/dep-78e8fc97.js');
require('../../../_chunks/dep-665eea2b.js');
require('../../../_chunks/dep-0fccdcfb.js');
require('../../../_chunks/dep-00e10ad8.js');
require('../../../_chunks/dep-5d5d7b13.js');
require('../../../_chunks/dep-ba207e81.js');
require('../../../hooks/useConfig.js');
require('../../../config-provider/ConfigContext.js');
require('../../../_chunks/dep-1debbc3e.js');
require('../../../_chunks/dep-b4e78a42.js');
require('dayjs');
require('../../../_chunks/dep-fdd584c5.js');
require('../../../_chunks/dep-84fd1465.js');
require('../../../_chunks/dep-023db433.js');
require('../../../_chunks/dep-77879fb6.js');
require('../../../_chunks/dep-356859aa.js');
require('../../../_chunks/dep-e2240b05.js');
require('../../../_chunks/dep-837f0312.js');
require('../../../_chunks/dep-413bc6a7.js');
require('../../../_chunks/dep-84d18206.js');
require('../../../_chunks/dep-5e1fc2cd.js');
require('../../../_chunks/dep-0be4d457.js');
require('../../../_chunks/dep-6058edb6.js');
require('../../../_chunks/dep-cfe601e8.js');
require('../../../_chunks/dep-6c342676.js');
require('../../../_chunks/dep-8bd04901.js');
require('../../../_chunks/dep-2f3e85f6.js');
require('../../../_chunks/dep-3cfcca89.js');
require('../../../_chunks/dep-64afded1.js');
require('../../../_chunks/dep-a1d853fb.js');
require('../../../hooks/useControlled.js');
require('../../../_util/noop.js');
require('../../../_chunks/dep-69751dfb.js');
require('../../../_chunks/dep-3905781f.js');
require('../../../hooks/useCommonClassName.js');
require('../../../radio/defaultProps.js');
require('../../../hooks/useDefaultProps.js');
require('../../../radio/useKeyboard.js');
require('../../../_chunks/dep-59a9c125.js');
require('../../../_util/listener.js');
require('../../../_chunks/dep-68db2ca6.js');
require('../../../_chunks/dep-6e448b65.js');
require('../../../config-provider/ConfigProvider.js');
require('../../../_chunks/dep-34def105.js');
require('../../../_chunks/dep-cc2fe55a.js');
require('../../../_chunks/dep-680d1e3e.js');
require('../../../_chunks/dep-a3962a45.js');
require('../../../_chunks/dep-b6bde0bc.js');
require('../../../_chunks/dep-f90d944e.js');
require('../../../_chunks/dep-46616204.js');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

var React__default = /*#__PURE__*/_interopDefaultLegacy(React);

var Header = function Header(props) {
  var _useLocaleReceiver = locale_LocalReceiver.useLocaleReceiver("colorPicker"),
    _useLocaleReceiver2 = slicedToArray._slicedToArray(_useLocaleReceiver, 2),
    local = _useLocaleReceiver2[0],
    t = _useLocaleReceiver2[1];
  var baseClassName = props.baseClassName,
    _props$mode = props.mode,
    mode = _props$mode === void 0 ? "monochrome" : _props$mode,
    colorModes = props.colorModes,
    onModeChange = props.onModeChange;
  var isSingleMode = (colorModes === null || colorModes === void 0 ? void 0 : colorModes.length) === 1;
  if (isSingleMode) {
    return null;
  }
  return /* @__PURE__ */React__default["default"].createElement("div", {
    className: "".concat(baseClassName, "__head")
  }, /* @__PURE__ */React__default["default"].createElement("div", {
    className: "".concat(baseClassName, "__mode")
  }, /* @__PURE__ */React__default["default"].createElement(radio_index.Radio.Group, {
    variant: "default-filled",
    size: "small",
    value: mode,
    onChange: onModeChange
  }, Object.keys(constants.COLOR_MODES).map(function (key) {
    return /* @__PURE__ */React__default["default"].createElement(radio_index.Radio.Button, {
      key: key,
      value: key
    }, t(local[constants.COLOR_MODES[key]]));
  }))));
};
var PanelHeader = /*#__PURE__*/React__default["default"].memo(Header);

exports["default"] = PanelHeader;
//# sourceMappingURL=header.js.map
