/**
 * tdesign v1.13.1
 * (c) 2025 tdesign
 * @license MIT
 */

'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var toConsumableArray = require('../../../_chunks/dep-210ce7c8.js');
var slicedToArray = require('../../../_chunks/dep-3012da29.js');
var React = require('react');
var classNames = require('classnames');
var color = require('../../../_chunks/dep-ef7d12a5.js');
var constants = require('../../../_chunks/dep-4240569e.js');
var hooks_useCommonClassName = require('../../../hooks/useCommonClassName.js');
var colorPicker_hooks_useClassNames = require('../../hooks/useClassNames.js');
var inputNumber_index = require('../../../input-number/index.js');
var cloneDeep = require('../../../_chunks/dep-34def105.js');
require('../../../_chunks/dep-7e3b8125.js');
require('../../../_chunks/dep-560c14c5.js');
require('../../../_chunks/dep-7a6528ec.js');
require('../../../_chunks/dep-c83f28a0.js');
require('tinycolor2');
require('../../../_chunks/dep-6e448b65.js');
require('../../../_chunks/dep-912bd8a2.js');
require('../../../_chunks/dep-78e8fc97.js');
require('../../../_chunks/dep-0fccdcfb.js');
require('../../../_chunks/dep-d9f53773.js');
require('../../../hooks/useConfig.js');
require('../../../config-provider/ConfigContext.js');
require('../../../_chunks/dep-1debbc3e.js');
require('../../../_chunks/dep-b4e78a42.js');
require('dayjs');
require('../../../_chunks/dep-fdd584c5.js');
require('../../../_chunks/dep-84fd1465.js');
require('../../../_chunks/dep-023db433.js');
require('../../../_chunks/dep-77879fb6.js');
require('../../../_chunks/dep-356859aa.js');
require('../../../_chunks/dep-e2240b05.js');
require('../../../_chunks/dep-837f0312.js');
require('../../../_chunks/dep-413bc6a7.js');
require('../../../_chunks/dep-84d18206.js');
require('../../../_chunks/dep-5e1fc2cd.js');
require('../../../_chunks/dep-0be4d457.js');
require('../../../_chunks/dep-6058edb6.js');
require('../../../_chunks/dep-cfe601e8.js');
require('../../../_chunks/dep-6c342676.js');
require('../../../_chunks/dep-8bd04901.js');
require('../../../_chunks/dep-2f3e85f6.js');
require('../../../_chunks/dep-3cfcca89.js');
require('../../../_chunks/dep-64afded1.js');
require('../../../_chunks/dep-a1d853fb.js');
require('../../../input-number/InputNumber.js');
require('tdesign-icons-react');
require('../../../input/index.js');
require('../../../input/Input.js');
require('../../../_chunks/dep-e358a1dc.js');
require('../../../hooks/useLayoutEffect.js');
require('../../../_chunks/dep-68db2ca6.js');
require('../../../_util/forwardRefWithStatics.js');
require('hoist-non-react-statics');
require('../../../hooks/useGlobalIcon.js');
require('../../../input/InputGroup.js');
require('../../../hooks/useControlled.js');
require('../../../_util/noop.js');
require('../../../_chunks/dep-00e10ad8.js');
require('../../../_chunks/dep-5d5d7b13.js');
require('../../../_chunks/dep-ba207e81.js');
require('../../../_chunks/dep-ed0d1cf9.js');
require('../../../_chunks/dep-665eea2b.js');
require('../../../locale/LocalReceiver.js');
require('../../../config-provider/ConfigProvider.js');
require('../../../_chunks/dep-cc2fe55a.js');
require('../../../_chunks/dep-680d1e3e.js');
require('../../../_chunks/dep-a3962a45.js');
require('../../../_chunks/dep-b6bde0bc.js');
require('../../../_chunks/dep-f90d944e.js');
require('../../../_chunks/dep-46616204.js');
require('../../../input/defaultProps.js');
require('../../../_util/parseTNode.js');
require('../../../_chunks/dep-cc4e3925.js');
require('../../../input/useLengthLimit.js');
require('../../../_chunks/dep-f34d3a30.js');
require('../../../_chunks/dep-b47ed304.js');
require('../../../hooks/useDefaultProps.js');
require('../../../button/index.js');
require('../../../button/Button.js');
require('../../../hooks/useDomRefCallback.js');
require('../../../hooks/useRipple.js');
require('../../../_chunks/dep-8593a497.js');
require('../../../hooks/useAnimation.js');
require('../../../loading/index.js');
require('../../../loading/Loading.js');
require('../../../common/Portal.js');
require('react-dom');
require('../../../loading/gradient.js');
require('../../../loading/defaultProps.js');
require('../../../loading/plugin.js');
require('../../../_util/react-render.js');
require('../../../_chunks/dep-608840a8.js');
require('../../../common/PluginContainer.js');
require('../../../button/defaultProps.js');
require('../../../input-number/useInputNumber.js');
require('../../../_chunks/dep-006cdaa7.js');
require('../../../_chunks/dep-dfe5fb78.js');
require('../../../input-number/defaultProps.js');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

var React__default = /*#__PURE__*/_interopDefaultLegacy(React);
var classNames__default = /*#__PURE__*/_interopDefaultLegacy(classNames);

var DELETE_KEYS = ["delete", "backspace"];
var LinearGradient = function LinearGradient(props) {
  var _allGradientColors$, _allGradientColors;
  var onChange = props.onChange,
    color$1 = props.color,
    disabled = props.disabled;
  var baseClassName = colorPicker_hooks_useClassNames["default"]();
  var _useCommonClassName = hooks_useCommonClassName["default"](),
    statusClassNames = _useCommonClassName.STATUS;
  var refSlider = React.useRef(null);
  var sliderRectRef = React.useRef({
    left: 0,
    width: constants.GRADIENT_SLIDER_DEFAULT_WIDTH
  });
  var isDragging = React.useRef(false);
  var isMoved = React.useRef(false);
  var degree = React.useRef(props.color.gradientDegree);
  var _useState = React.useState(props.color.gradientSelectedId),
    _useState2 = slicedToArray._slicedToArray(_useState, 2),
    selectedId = _useState2[0],
    setSelectedId = _useState2[1];
  var selectedRef = React.useRef(props.color.gradientSelectedId);
  var colors = React.useRef(cloneDeep.cloneDeep(color$1.gradientColors));
  var _useState3 = React.useState(colors.current),
    _useState4 = slicedToArray._slicedToArray(_useState3, 2),
    colorsState = _useState4[0],
    setColorsState = _useState4[1];
  React.useEffect(function () {
    degree.current = color$1 === null || color$1 === void 0 ? void 0 : color$1.gradientDegree;
    setSelectedId(color$1.gradientSelectedId);
    selectedRef.current = color$1.gradientSelectedId;
    colors.current = cloneDeep.cloneDeep(color$1.gradientColors);
    setColorsState(colors.current);
  }, [color$1.gradientColors, color$1 === null || color$1 === void 0 ? void 0 : color$1.gradientDegree, color$1.gradientSelectedId, color$1.value, color$1.saturation]);
  var updateSliderRect = function updateSliderRect() {
    var rect = refSlider.current.getBoundingClientRect();
    sliderRectRef.current = {
      left: rect.left,
      width: rect.width || constants.GRADIENT_SLIDER_DEFAULT_WIDTH
    };
  };
  var handleChange = React.useCallback(function (key, payload, addUsedColor) {
    if (disabled) {
      return;
    }
    onChange({
      key: key,
      payload: payload,
      addUsedColor: addUsedColor
    });
  }, [onChange, disabled]);
  var handleDegreeChange = function handleDegreeChange(value) {
    if (props.disabled || value === props.color.gradientDegree) {
      return;
    }
    degree.current = value;
    handleChange("degree", value, true);
  };
  var handleSelectedIdChange = function handleSelectedIdChange(value) {
    if (props.disabled) {
      return;
    }
    setSelectedId(value);
    selectedRef.current = value;
    handleChange("selectedId", value);
  };
  var handleColorsChange = React.useCallback(function (value, isEnded) {
    if (props.disabled) {
      return;
    }
    colors.current = value;
    setColorsState(value);
    handleChange("colors", value, isEnded);
  }, [props.disabled, handleChange]);
  var updateActiveThumbLeft = React.useCallback(function (left) {
    var index = colors.current.findIndex(function (c) {
      return c.id === selectedRef.current;
    });
    if (index === -1) {
      return;
    }
    var point = colors.current[index];
    var formatLeft = Math.max(0, Math.min(sliderRectRef.current.width, left));
    var percentLeft = formatLeft / sliderRectRef.current.width * 100;
    var newColors = colors.current.map(function (item, i) {
      return index !== i ? item : {
        color: point.color,
        left: percentLeft,
        id: point.id
      };
    });
    handleColorsChange(newColors);
  }, [handleColorsChange]);
  var handleStart = function handleStart(id, e) {
    if (isDragging.current || props.disabled) {
      return;
    }
    selectedRef.current = id;
    setSelectedId(id);
    isMoved.current = false;
    isDragging.current = true;
    e.preventDefault();
    e.stopPropagation();
    refSlider.current.focus();
  };
  var handleMove = React.useCallback(function (e) {
    if (!isDragging.current || disabled) {
      return;
    }
    var rect = refSlider.current.getBoundingClientRect();
    var left = e.clientX - rect.x;
    isMoved.current = true;
    updateActiveThumbLeft(left);
  }, [disabled, updateActiveThumbLeft]);
  var handleEnd = React.useCallback(function () {
    if (!isDragging.current) {
      return;
    }
    setTimeout(function () {
      isDragging.current = false;
    }, 0);
    if (isMoved.current) {
      handleColorsChange(colors.current, true);
      isMoved.current = false;
    }
  }, [handleColorsChange]);
  var handleKeyup = function handleKeyup(e) {
    if (props.disabled) {
      return;
    }
    var points = toConsumableArray._toConsumableArray(colors.current);
    var pos = points.findIndex(function (c) {
      return c.id === selectedRef.current;
    });
    var length = points.length;
    if (DELETE_KEYS.includes(e.key.toLocaleLowerCase()) && length > 2 && pos >= 0 && pos <= length - 1) {
      points.splice(pos, 1);
      if (!points[pos]) {
        pos = points[pos + 1] ? pos + 1 : points[pos - 1] ? pos - 1 : 0;
      }
      var current = points[pos];
      handleColorsChange(points, true);
      handleSelectedIdChange(current === null || current === void 0 ? void 0 : current.id);
    }
  };
  var handleThumbBarClick = function handleThumbBarClick(e) {
    if (props.disabled || !props.enableMultipleGradient) {
      return;
    }
    updateSliderRect();
    var left = e.clientX - sliderRectRef.current.left;
    left = Math.max(0, Math.min(sliderRectRef.current.width, left));
    var percentLeft = left / sliderRectRef.current.width * 100;
    var newPoint = color.genGradientPoint(percentLeft, props.color.rgba);
    var newColors = toConsumableArray._toConsumableArray(colors.current);
    newColors.push(newPoint);
    handleColorsChange(newColors, true);
    handleSelectedIdChange(newPoint.id);
  };
  React.useEffect(function () {
    updateSliderRect();
    window.addEventListener("mousemove", handleMove, false);
    window.addEventListener("mouseup", handleEnd, false);
    window.addEventListener("contextmenu", handleEnd, false);
    return function () {
      window.removeEventListener("mousemove", handleMove, false);
      window.removeEventListener("mouseup", handleEnd, false);
      window.removeEventListener("contextmenu", handleEnd, false);
    };
  }, []);
  var gradientColors = props.color.gradientColors;
  var thumbBackground = color.gradientColors2string({
    points: gradientColors,
    degree: 90
  });
  var handleClickThumb = function handleClickThumb(e, t) {
    handleSelectedIdChange(t.id);
    e.stopPropagation();
  };
  var allGradientColors = toConsumableArray._toConsumableArray(colorsState);
  var _genGradientPoint = color.genGradientPoint(0, (_allGradientColors$ = allGradientColors[0]) === null || _allGradientColors$ === void 0 ? void 0 : _allGradientColors$.color),
    leftColor = _genGradientPoint.color;
  var _genGradientPoint2 = color.genGradientPoint(100, (_allGradientColors = allGradientColors[allGradientColors.length - 1]) === null || _allGradientColors === void 0 ? void 0 : _allGradientColors.color),
    rightColor = _genGradientPoint2.color;
  return /* @__PURE__ */React__default["default"].createElement("div", {
    className: "".concat(baseClassName, "__gradient")
  }, /* @__PURE__ */React__default["default"].createElement("div", {
    className: "".concat(baseClassName, "__gradient-slider"),
    style: {
      background: "linear-gradient(90deg, ".concat(leftColor, " 0%, ").concat(leftColor, " 50%, ").concat(rightColor, " 50%, ").concat(rightColor, " 100%)")
    }
  }, /* @__PURE__ */React__default["default"].createElement("div", {
    className: classNames__default["default"]("".concat(baseClassName, "__slider"), "".concat(baseClassName, "--bg-alpha")),
    onKeyUp: handleKeyup,
    tabIndex: 0,
    ref: refSlider
  }, /* @__PURE__ */React__default["default"].createElement("ul", {
    className: "gradient-thumbs",
    onClick: handleThumbBarClick,
    style: {
      background: thumbBackground
    }
  }, colorsState.map(function (t) {
    var left = "".concat(Math.round(t.left * 100) / 100, "%");
    return /* @__PURE__ */React__default["default"].createElement("li", {
      className: classNames__default["default"](["".concat(baseClassName, "__thumb"), "gradient-thumbs__item", selectedId === t.id ? statusClassNames.active : ""]),
      key: t.id,
      title: "".concat(t.color, " ").concat(left),
      style: {
        color: t.color,
        left: left
      },
      onClick: function onClick(e) {
        return handleClickThumb(e, t);
      },
      onMouseDown: function onMouseDown(e) {
        return handleStart(t.id, e);
      }
    }, /* @__PURE__ */React__default["default"].createElement("span", {
      className: classNames__default["default"](["gradient-thumbs__item-inner", "".concat(baseClassName, "--bg-alpha")])
    }));
  })))), /* @__PURE__ */React__default["default"].createElement("div", {
    className: "".concat(baseClassName, "__gradient-degree"),
    title: "".concat(degree, "deg")
  }, /* @__PURE__ */React__default["default"].createElement(inputNumber_index.InputNumber, {
    theme: "normal",
    min: 0,
    max: 360,
    step: 1,
    size: "small",
    format: function format(value) {
      return "".concat(value, "\xB0");
    },
    value: degree.current,
    onBlur: handleDegreeChange,
    onEnter: handleDegreeChange,
    onChange: handleDegreeChange,
    disabled: props.disabled
  })));
};
var LinearGradient$1 = /*#__PURE__*/React__default["default"].memo(LinearGradient);

exports["default"] = LinearGradient$1;
//# sourceMappingURL=linear-gradient.js.map
