/**
 * tdesign v1.13.1
 * (c) 2025 tdesign
 * @license MIT
 */

'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var React = require('react');
var classNames = require('classnames');
var tdesignIconsReact = require('tdesign-icons-react');
var color = require('../../../_chunks/dep-ef7d12a5.js');
var hooks_useGlobalIcon = require('../../../hooks/useGlobalIcon.js');
var hooks_useCommonClassName = require('../../../hooks/useCommonClassName.js');
require('../../../_chunks/dep-3012da29.js');
require('../../../_chunks/dep-7e3b8125.js');
require('../../../_chunks/dep-560c14c5.js');
require('../../../_chunks/dep-7a6528ec.js');
require('../../../_chunks/dep-c83f28a0.js');
require('tinycolor2');
require('../../../_chunks/dep-4240569e.js');
require('../../../_chunks/dep-6e448b65.js');
require('../../../_chunks/dep-912bd8a2.js');
require('../../../_chunks/dep-78e8fc97.js');
require('../../../_chunks/dep-0fccdcfb.js');
require('../../../_chunks/dep-d9f53773.js');
require('../../../hooks/useConfig.js');
require('../../../config-provider/ConfigContext.js');
require('../../../_chunks/dep-1debbc3e.js');
require('../../../_chunks/dep-b4e78a42.js');
require('dayjs');
require('../../../_chunks/dep-fdd584c5.js');
require('../../../_chunks/dep-84fd1465.js');
require('../../../_chunks/dep-023db433.js');
require('../../../_chunks/dep-77879fb6.js');
require('../../../_chunks/dep-356859aa.js');
require('../../../_chunks/dep-e2240b05.js');
require('../../../_chunks/dep-837f0312.js');
require('../../../_chunks/dep-413bc6a7.js');
require('../../../_chunks/dep-84d18206.js');
require('../../../_chunks/dep-5e1fc2cd.js');
require('../../../_chunks/dep-0be4d457.js');
require('../../../_chunks/dep-6058edb6.js');
require('../../../_chunks/dep-cfe601e8.js');
require('../../../_chunks/dep-6c342676.js');
require('../../../_chunks/dep-8bd04901.js');
require('../../../_chunks/dep-2f3e85f6.js');
require('../../../_chunks/dep-3cfcca89.js');
require('../../../_chunks/dep-64afded1.js');
require('../../../_chunks/dep-a1d853fb.js');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

var React__default = /*#__PURE__*/_interopDefaultLegacy(React);
var classNames__default = /*#__PURE__*/_interopDefaultLegacy(classNames);

var Swatches = function Swatches(props) {
  var baseClassName = props.baseClassName,
    _props$colors = props.colors,
    colors = _props$colors === void 0 ? [] : _props$colors,
    _props$editable = props.editable,
    editable = _props$editable === void 0 ? false : _props$editable,
    title = props.title,
    onChange = props.onChange,
    disabled = props.disabled,
    onSetColor = props.onSetColor,
    handleAddColor = props.handleAddColor;
  var _useGlobalIcon = hooks_useGlobalIcon["default"]({
      DeleteIcon: tdesignIconsReact.DeleteIcon,
      AddIcon: tdesignIconsReact.AddIcon
    }),
    DeleteIcon = _useGlobalIcon.DeleteIcon,
    AddIcon = _useGlobalIcon.AddIcon;
  var swatchesClass = "".concat(baseClassName, "__swatches");
  var _useCommonClassName = hooks_useCommonClassName["default"](),
    statusClassNames = _useCommonClassName.STATUS;
  var isEqualCurrentColor = function isEqualCurrentColor(color$1) {
    return color.Color.compare(color$1, props.color.css);
  };
  var selectedColorIndex = function selectedColorIndex() {
    return colors.findIndex(function (color) {
      return isEqualCurrentColor(color);
    });
  };
  var handleRemoveColor = function handleRemoveColor() {
    var selectedIndex = selectedColorIndex();
    if (selectedIndex > -1) {
      var newColors = colors.filter(function (item, index) {
        return index !== selectedIndex;
      });
      onChange(newColors);
    }
  };
  var handleClick = function handleClick(color) {
    return onSetColor(color);
  };
  return /* @__PURE__ */React__default["default"].createElement("div", {
    className: swatchesClass
  }, title ? /* @__PURE__ */React__default["default"].createElement("h3", {
    className: "".concat(swatchesClass, "--title")
  }, /* @__PURE__ */React__default["default"].createElement("span", null, title), editable && /* @__PURE__ */React__default["default"].createElement("div", {
    className: "".concat(swatchesClass, "--actions")
  }, /* @__PURE__ */React__default["default"].createElement("span", {
    role: "button",
    className: "".concat(baseClassName, "__icon"),
    onClick: function onClick() {
      return handleAddColor();
    }
  }, /* @__PURE__ */React__default["default"].createElement(AddIcon, null)), colors.length > 0 ? /* @__PURE__ */React__default["default"].createElement("span", {
    role: "button",
    className: "".concat(baseClassName, "__icon"),
    onClick: function onClick() {
      return handleRemoveColor();
    }
  }, /* @__PURE__ */React__default["default"].createElement(DeleteIcon, null)) : null)) : /* @__PURE__ */React__default["default"].createElement(React__default["default"].Fragment, null), /* @__PURE__ */React__default["default"].createElement("ul", {
    className: classNames__default["default"]("".concat(swatchesClass, "--items"), "narrow-scrollbar")
  }, colors.map(function (color) {
    return /* @__PURE__ */React__default["default"].createElement("li", {
      className: classNames__default["default"]("".concat(swatchesClass, "--item"), isEqualCurrentColor(color) && editable ? statusClassNames.active : ""),
      key: color,
      onClick: function onClick() {
        if (disabled) {
          return;
        }
        handleClick(color);
      }
    }, /* @__PURE__ */React__default["default"].createElement("div", {
      className: classNames__default["default"]("".concat(swatchesClass, "--item__color"), "".concat(baseClassName, "--bg-alpha"))
    }, /* @__PURE__ */React__default["default"].createElement("span", {
      className: "".concat(swatchesClass, "--item__inner"),
      style: {
        background: color
      }
    })));
  })));
};
var SwatchesPanel = /*#__PURE__*/React__default["default"].memo(Swatches);

exports["default"] = SwatchesPanel;
//# sourceMappingURL=swatches.js.map
