/**
 * tdesign v1.13.1
 * (c) 2025 tdesign
 * @license MIT
 */

'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var defineProperty = require('../../_chunks/dep-7a6528ec.js');
var React = require('react');
var classNames = require('classnames');
var color = require('../../_chunks/dep-ef7d12a5.js');
var input_index = require('../../input/index.js');
var colorPicker_hooks_useClassNames = require('../hooks/useClassNames.js');
var _util_noop = require('../../_util/noop.js');
require('../../_chunks/dep-c83f28a0.js');
require('../../_chunks/dep-3012da29.js');
require('../../_chunks/dep-7e3b8125.js');
require('../../_chunks/dep-560c14c5.js');
require('tinycolor2');
require('../../_chunks/dep-4240569e.js');
require('../../_chunks/dep-6e448b65.js');
require('../../_chunks/dep-912bd8a2.js');
require('../../_chunks/dep-78e8fc97.js');
require('../../_chunks/dep-0fccdcfb.js');
require('../../_chunks/dep-d9f53773.js');
require('../../input/Input.js');
require('../../_chunks/dep-e358a1dc.js');
require('tdesign-icons-react');
require('../../hooks/useLayoutEffect.js');
require('../../_chunks/dep-68db2ca6.js');
require('../../_util/forwardRefWithStatics.js');
require('hoist-non-react-statics');
require('../../hooks/useConfig.js');
require('../../config-provider/ConfigContext.js');
require('../../_chunks/dep-1debbc3e.js');
require('../../_chunks/dep-b4e78a42.js');
require('dayjs');
require('../../_chunks/dep-fdd584c5.js');
require('../../_chunks/dep-84fd1465.js');
require('../../_chunks/dep-023db433.js');
require('../../_chunks/dep-77879fb6.js');
require('../../_chunks/dep-356859aa.js');
require('../../_chunks/dep-e2240b05.js');
require('../../_chunks/dep-837f0312.js');
require('../../_chunks/dep-413bc6a7.js');
require('../../_chunks/dep-84d18206.js');
require('../../_chunks/dep-5e1fc2cd.js');
require('../../_chunks/dep-0be4d457.js');
require('../../_chunks/dep-6058edb6.js');
require('../../_chunks/dep-cfe601e8.js');
require('../../_chunks/dep-6c342676.js');
require('../../_chunks/dep-8bd04901.js');
require('../../_chunks/dep-2f3e85f6.js');
require('../../_chunks/dep-3cfcca89.js');
require('../../_chunks/dep-64afded1.js');
require('../../_chunks/dep-a1d853fb.js');
require('../../hooks/useGlobalIcon.js');
require('../../input/InputGroup.js');
require('../../hooks/useControlled.js');
require('../../_chunks/dep-00e10ad8.js');
require('../../_chunks/dep-5d5d7b13.js');
require('../../_chunks/dep-ba207e81.js');
require('../../_chunks/dep-ed0d1cf9.js');
require('../../_chunks/dep-665eea2b.js');
require('../../locale/LocalReceiver.js');
require('../../config-provider/ConfigProvider.js');
require('../../_chunks/dep-34def105.js');
require('../../_chunks/dep-cc2fe55a.js');
require('../../_chunks/dep-680d1e3e.js');
require('../../_chunks/dep-a3962a45.js');
require('../../_chunks/dep-b6bde0bc.js');
require('../../_chunks/dep-f90d944e.js');
require('../../_chunks/dep-46616204.js');
require('../../input/defaultProps.js');
require('../../_util/parseTNode.js');
require('../../_chunks/dep-cc4e3925.js');
require('../../input/useLengthLimit.js');
require('../../_chunks/dep-f34d3a30.js');
require('../../_chunks/dep-210ce7c8.js');
require('../../_chunks/dep-b47ed304.js');
require('../../hooks/useDefaultProps.js');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

var React__default = /*#__PURE__*/_interopDefaultLegacy(React);
var classNames__default = /*#__PURE__*/_interopDefaultLegacy(classNames);

function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { defineProperty._defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
var ColorPickerTrigger = function ColorPickerTrigger(props) {
  var baseClassName = colorPicker_hooks_useClassNames["default"]();
  var _props$disabled = props.disabled,
    disabled = _props$disabled === void 0 ? false : _props$disabled,
    _props$borderless = props.borderless,
    borderless = _props$borderless === void 0 ? false : _props$borderless,
    _props$inputProps = props.inputProps,
    inputProps = _props$inputProps === void 0 ? {
      autoWidth: true
    } : _props$inputProps,
    clearable = props.clearable,
    onClear = props.onClear;
  var handleChange = function handleChange(input) {
    if (input !== props.value) {
      var _props$onChange;
      (_props$onChange = props.onChange) === null || _props$onChange === void 0 || _props$onChange.call(props, input, {
        color: color.getColorObject(new color.Color(input)),
        trigger: "input"
      });
    }
  };
  return /* @__PURE__ */React__default["default"].createElement("div", {
    className: "".concat(baseClassName, "__trigger--default")
  }, /* @__PURE__ */React__default["default"].createElement(input_index.Input, _objectSpread(_objectSpread({
    borderless: borderless,
    clearable: clearable
  }, inputProps), {}, {
    value: props.value,
    disabled: disabled,
    label: /* @__PURE__ */React__default["default"].createElement("div", {
      className: classNames__default["default"]("".concat(baseClassName, "__trigger--default__color"), "".concat(baseClassName, "--bg-alpha"))
    }, /* @__PURE__ */React__default["default"].createElement("span", {
      className: "color-inner",
      style: {
        background: props.value
      }
    })),
    onChange: handleChange,
    onClear: onClear || _util_noop["default"]
  })));
};
var ColorTrigger = /*#__PURE__*/React__default["default"].memo(ColorPickerTrigger);

exports["default"] = ColorTrigger;
//# sourceMappingURL=trigger.js.map
