/**
 * tdesign v1.13.1
 * (c) 2025 tdesign
 * @license MIT
 */

'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var defineProperty = require('../_chunks/dep-7a6528ec.js');
var slicedToArray = require('../_chunks/dep-3012da29.js');
var objectWithoutProperties = require('../_chunks/dep-e358a1dc.js');
var React = require('react');
var classNames = require('classnames');
var _util_helper = require('../_util/helper.js');
var hooks_useConfig = require('../hooks/useConfig.js');
var hooks_useControlled = require('../hooks/useControlled.js');
var isBoolean = require('../_chunks/dep-69751dfb.js');
require('../_chunks/dep-c83f28a0.js');
require('../_chunks/dep-7e3b8125.js');
require('../_chunks/dep-1819e167.js');
require('../_chunks/dep-ed0d1cf9.js');
require('../_chunks/dep-912bd8a2.js');
require('../_chunks/dep-78e8fc97.js');
require('../_chunks/dep-665eea2b.js');
require('../_chunks/dep-0fccdcfb.js');
require('../_chunks/dep-00e10ad8.js');
require('../_chunks/dep-5d5d7b13.js');
require('../_chunks/dep-ba207e81.js');
require('../config-provider/ConfigContext.js');
require('../_chunks/dep-1debbc3e.js');
require('../_chunks/dep-b4e78a42.js');
require('dayjs');
require('../_chunks/dep-fdd584c5.js');
require('../_chunks/dep-84fd1465.js');
require('../_chunks/dep-023db433.js');
require('../_chunks/dep-77879fb6.js');
require('../_chunks/dep-356859aa.js');
require('../_chunks/dep-e2240b05.js');
require('../_chunks/dep-837f0312.js');
require('../_chunks/dep-413bc6a7.js');
require('../_chunks/dep-84d18206.js');
require('../_chunks/dep-5e1fc2cd.js');
require('../_chunks/dep-0be4d457.js');
require('../_chunks/dep-6058edb6.js');
require('../_chunks/dep-cfe601e8.js');
require('../_chunks/dep-6c342676.js');
require('../_chunks/dep-8bd04901.js');
require('../_chunks/dep-2f3e85f6.js');
require('../_chunks/dep-3cfcca89.js');
require('../_chunks/dep-64afded1.js');
require('../_chunks/dep-a1d853fb.js');
require('../_util/noop.js');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

var React__default = /*#__PURE__*/_interopDefaultLegacy(React);
var classNames__default = /*#__PURE__*/_interopDefaultLegacy(classNames);

var _excluded = ["allowUncheck", "type", "disabled", "name", "value", "onChange", "indeterminate", "children", "label", "className", "style", "readonly", "onClick"];
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { defineProperty._defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
var CheckContext = /*#__PURE__*/React__default["default"].createContext(null);
var Check = /*#__PURE__*/React.forwardRef(function (_props, ref) {
  var context = React.useContext(CheckContext);
  var props = context ? context.inject(_props) : _props;
  var _props$allowUncheck = props.allowUncheck,
    allowUncheck = _props$allowUncheck === void 0 ? false : _props$allowUncheck,
    type = props.type,
    disabled = props.disabled,
    name = props.name,
    value = props.value,
    onChange = props.onChange,
    indeterminate = props.indeterminate,
    children = props.children,
    label = props.label,
    className = props.className,
    style = props.style,
    readonly = props.readonly,
    onClick = props.onClick,
    htmlProps = objectWithoutProperties._objectWithoutProperties(props, _excluded);
  var _useConfig = hooks_useConfig["default"](),
    classPrefix = _useConfig.classPrefix;
  var TOnChange = onChange;
  var _useControlled = hooks_useControlled["default"](props, "checked", TOnChange),
    _useControlled2 = slicedToArray._slicedToArray(_useControlled, 2),
    internalChecked = _useControlled2[0],
    setInternalChecked = _useControlled2[1];
  var labelClassName = classNames__default["default"]("".concat(classPrefix, "-").concat(type), className, defineProperty._defineProperty(defineProperty._defineProperty(defineProperty._defineProperty({}, "".concat(classPrefix, "-is-checked"), internalChecked), "".concat(classPrefix, "-is-disabled"), disabled), "".concat(classPrefix, "-is-indeterminate"), indeterminate));
  var isDisabled = disabled || readonly;
  var input = /* @__PURE__ */React__default["default"].createElement("input", {
    readOnly: readonly,
    type: type === "radio-button" ? "radio" : type,
    className: "".concat(classPrefix, "-").concat(type, "__former"),
    checked: internalChecked,
    disabled: disabled,
    name: name,
    tabIndex: -1,
    value: isBoolean.isBoolean(value) ? Number(value) : value,
    "data-value": typeof value === "string" ? "'".concat(value, "'") : value,
    "data-allow-uncheck": allowUncheck || void 0,
    onClick: function onClick(e) {
      e.stopPropagation();
      if ((type === "radio-button" || type === "radio") && allowUncheck && internalChecked) {
        setInternalChecked(!e.currentTarget.checked, {
          e: e
        });
      }
    },
    onChange: function onChange(e) {
      if (isDisabled) return;
      setInternalChecked(e.currentTarget.checked, {
        e: e
      });
    }
  });
  var showLabel = !!(children || label);
  var handleLabelClick = function handleLabelClick(event) {
    if (props.stopLabelTrigger) {
      event.preventDefault();
    }
  };
  var onInnerClick = function onInnerClick(e) {
    if (isDisabled) return;
    onClick === null || onClick === void 0 || onClick({
      e: e
    });
  };
  return /* @__PURE__ */React__default["default"].createElement("label", _objectSpread(_objectSpread({
    ref: ref,
    tabIndex: disabled ? void 0 : 0,
    className: labelClassName,
    title: props.title,
    style: style
  }, _util_helper.omit(htmlProps, ["checkAll", "stopLabelTrigger"])), {}, {
    onClick: onInnerClick
  }), input, /* @__PURE__ */React__default["default"].createElement("span", {
    className: "".concat(classPrefix, "-").concat(type, "__input")
  }), showLabel && /* @__PURE__ */React__default["default"].createElement("span", {
    key: "label",
    className: "".concat(classPrefix, "-").concat(type, "__label"),
    onClick: handleLabelClick
  }, children || label));
});
Check.displayName = "Check";

exports.CheckContext = CheckContext;
exports["default"] = Check;
//# sourceMappingURL=Check.js.map
