/**
 * tdesign v1.13.1
 * (c) 2025 tdesign
 * @license MIT
 */

'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var dayjs = require('dayjs');
var utils = require('../../_chunks/dep-59cc13ee.js');
var isObject = require('../../_chunks/dep-837f0312.js');
require('../../_chunks/dep-3012da29.js');
require('../../_chunks/dep-7e3b8125.js');
require('../../_chunks/dep-7a6528ec.js');
require('../../_chunks/dep-c83f28a0.js');
require('../../_chunks/dep-b4e78a42.js');
require('../../_chunks/dep-5b899485.js');
require('../../_chunks/dep-5941343f.js');
require('../../_chunks/dep-665eea2b.js');
require('../../_chunks/dep-912bd8a2.js');
require('../../_chunks/dep-0fccdcfb.js');
require('../../_chunks/dep-2c36bed6.js');
require('../../_chunks/dep-cc4e3925.js');
require('../../_chunks/dep-6e448b65.js');
require('../../_chunks/dep-78e8fc97.js');
require('../../_chunks/dep-e2240b05.js');
require('../../_chunks/dep-ba207e81.js');
require('../../_chunks/dep-a1d853fb.js');
require('../../_chunks/dep-6058edb6.js');
require('../../_chunks/dep-356859aa.js');
require('../../_chunks/dep-84d18206.js');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

var dayjs__default = /*#__PURE__*/_interopDefaultLegacy(dayjs);

function useDisableDate(props) {
  var _disableDate = props.disableDate,
    format = props.format,
    mode = props.mode,
    start = props.start,
    end = props.end;
  return {
    disableDate: function disableDate(value) {
      return !utils.isEnabledDate({
        disableDate: _disableDate,
        format: format,
        mode: mode,
        value: value
      });
    },
    minDate: isObject.isObject(_disableDate) && "before" in _disableDate ? new Date(dayjs__default["default"](_disableDate.before).startOf("day").format()) : start,
    maxDate: isObject.isObject(_disableDate) && "after" in _disableDate ? new Date(dayjs__default["default"](_disableDate.after).endOf("day").format()) : end
  };
}

exports["default"] = useDisableDate;
//# sourceMappingURL=useDisableDate.js.map
