/**
 * tdesign v1.13.1
 * (c) 2025 tdesign
 * @license MIT
 */

'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var defineProperty = require('../../_chunks/dep-7a6528ec.js');
var React = require('react');
var format = require('../../_chunks/dep-2c36bed6.js');
var datePicker_base_Header = require('../base/Header.js');
var datePicker_base_Table = require('../base/Table.js');
var timePicker_index = require('../../time-picker/index.js');
var hooks_useConfig = require('../../hooks/useConfig.js');
var hooks_useEventCallback = require('../../hooks/useEventCallback.js');
require('../../_chunks/dep-c83f28a0.js');
require('dayjs');
require('../../_chunks/dep-b4e78a42.js');
require('../../_chunks/dep-cc4e3925.js');
require('../../_chunks/dep-6e448b65.js');
require('../../_chunks/dep-912bd8a2.js');
require('../../_chunks/dep-78e8fc97.js');
require('../../_chunks/dep-0fccdcfb.js');
require('../../_chunks/dep-210ce7c8.js');
require('../../_chunks/dep-7e3b8125.js');
require('../../_chunks/dep-3012da29.js');
require('../../locale/LocalReceiver.js');
require('../../config-provider/ConfigProvider.js');
require('../../config-provider/ConfigContext.js');
require('../../_chunks/dep-1debbc3e.js');
require('../../_chunks/dep-fdd584c5.js');
require('../../_chunks/dep-84fd1465.js');
require('../../_chunks/dep-023db433.js');
require('../../_chunks/dep-77879fb6.js');
require('../../_chunks/dep-356859aa.js');
require('../../_chunks/dep-e2240b05.js');
require('../../_chunks/dep-837f0312.js');
require('../../_chunks/dep-413bc6a7.js');
require('../../_chunks/dep-84d18206.js');
require('../../_chunks/dep-5e1fc2cd.js');
require('../../_chunks/dep-0be4d457.js');
require('../../_chunks/dep-6058edb6.js');
require('../../_chunks/dep-cfe601e8.js');
require('../../_chunks/dep-6c342676.js');
require('../../_chunks/dep-8bd04901.js');
require('../../_chunks/dep-2f3e85f6.js');
require('../../_chunks/dep-3cfcca89.js');
require('../../_chunks/dep-64afded1.js');
require('../../_chunks/dep-a1d853fb.js');
require('../../_chunks/dep-34def105.js');
require('../../_chunks/dep-cc2fe55a.js');
require('../../_chunks/dep-680d1e3e.js');
require('../../_chunks/dep-a3962a45.js');
require('../../_chunks/dep-b6bde0bc.js');
require('../../_chunks/dep-f90d944e.js');
require('../../_chunks/dep-46616204.js');
require('../../select/index.js');
require('../../select/base/Select.js');
require('../../_chunks/dep-e358a1dc.js');
require('classnames');
require('../../_util/helper.js');
require('../../_chunks/dep-1819e167.js');
require('../../_chunks/dep-ed0d1cf9.js');
require('../../_chunks/dep-665eea2b.js');
require('../../_chunks/dep-00e10ad8.js');
require('../../_chunks/dep-5d5d7b13.js');
require('../../_chunks/dep-ba207e81.js');
require('../../hooks/useControlled.js');
require('../../_util/noop.js');
require('../../_util/forwardRefWithStatics.js');
require('hoist-non-react-statics');
require('../../_chunks/dep-6638dce8.js');
require('../../select/base/OptionGroup.js');
require('../../select/defaultProps.js');
require('../../hooks/useDefaultProps.js');
require('../../select/base/Option.js');
require('../../hooks/useDomRefCallback.js');
require('../../hooks/useRipple.js');
require('../../_chunks/dep-8593a497.js');
require('../../hooks/useAnimation.js');
require('../../_chunks/dep-68db2ca6.js');
require('../../_chunks/dep-b47ed304.js');
require('../../_chunks/dep-8a28dfd9.js');
require('../../_chunks/dep-8529ce07.js');
require('../../common/FakeArrow.js');
require('../../loading/index.js');
require('../../loading/Loading.js');
require('../../common/Portal.js');
require('react-dom');
require('../../hooks/useLayoutEffect.js');
require('../../loading/gradient.js');
require('../../_chunks/dep-f34d3a30.js');
require('../../loading/defaultProps.js');
require('../../loading/plugin.js');
require('../../_util/react-render.js');
require('../../_chunks/dep-608840a8.js');
require('../../common/PluginContainer.js');
require('../../select-input/index.js');
require('../../select-input/SelectInput.js');
require('../../popup/index.js');
require('../../popup/Popup.js');
require('react-transition-group');
require('../../_util/ref.js');
require('react-is');
require('../../_util/isFragment.js');
require('../../hooks/useAttach.js');
require('../../hooks/useMutationObserver.js');
require('../../hooks/useLatest.js');
require('../../_chunks/dep-c73e0aa5.js');
require('../../_chunks/dep-becc25b2.js');
require('../../_chunks/dep-ba79870d.js');
require('../../_chunks/dep-7bb447f9.js');
require('../../_chunks/dep-5941343f.js');
require('../../hooks/usePopper.js');
require('@popperjs/core');
require('react-fast-compare');
require('../../hooks/useWindowSize.js');
require('../../popup/defaultProps.js');
require('../../popup/hooks/useTrigger.js');
require('../../_util/composeRefs.js');
require('../../_util/listener.js');
require('../../popup/utils/transition.js');
require('../../popup/PopupPlugin.js');
require('../../select-input/useSingle.js');
require('../../input/index.js');
require('../../input/Input.js');
require('tdesign-icons-react');
require('../../hooks/useGlobalIcon.js');
require('../../input/InputGroup.js');
require('../../input/defaultProps.js');
require('../../_util/parseTNode.js');
require('../../input/useLengthLimit.js');
require('../../_chunks/dep-52a009fb.js');
require('../../_chunks/dep-962f011a.js');
require('../../_chunks/dep-58cddfe4.js');
require('../../_chunks/dep-c29b655c.js');
require('../../_chunks/dep-d843946a.js');
require('../../select-input/useMultiple.js');
require('../../tag-input/index.js');
require('../../tag-input/TagInput.js');
require('../../hooks/useDragSorter.js');
require('../../tag-input/useTagScroll.js');
require('../../tag-input/useTagList.js');
require('../../tag/index.js');
require('../../tag/Tag.js');
require('tinycolor2');
require('../../tag/defaultProps.js');
require('../../tag/CheckTag.js');
require('../../_chunks/dep-59a9c125.js');
require('../../tag/CheckTagGroup.js');
require('../../tag-input/useHover.js');
require('../../tag-input/defaultProps.js');
require('../../select-input/useOverlayInnerStyle.js');
require('../../select-input/defaultProps.js');
require('../../select/base/PopupContent.js');
require('../../select/hooks/usePanelVirtualScroll.js');
require('../../hooks/useVirtualScroll.js');
require('../../hooks/useResizeObserver.js');
require('../../pagination/index.js');
require('../../pagination/Pagination.js');
require('../../input-number/index.js');
require('../../input-number/InputNumber.js');
require('../../button/index.js');
require('../../button/Button.js');
require('../../button/defaultProps.js');
require('../../input-number/useInputNumber.js');
require('../../_chunks/dep-006cdaa7.js');
require('../../_chunks/dep-dfe5fb78.js');
require('../../hooks/useCommonClassName.js');
require('../../input-number/defaultProps.js');
require('../../input-adornment/InputAdornment.js');
require('../../pagination/hooks/useBoundaryJumper.js');
require('../../pagination/hooks/usePrevNextJumper.js');
require('../../pagination/hooks/usePageNumber.js');
require('../../pagination/hooks/useTotal.js');
require('../../pagination/validators.js');
require('../../pagination/defaultProps.js');
require('../../_chunks/dep-f4d31431.js');
require('../../_chunks/dep-be9040ff.js');
require('../../pagination/PaginationMini.js');
require('../base/Cell.js');
require('../../_chunks/dep-59cc13ee.js');
require('../../_chunks/dep-5b899485.js');
require('../../time-picker/TimePicker.js');
require('../../_chunks/dep-feb1fd45.js');
require('../../time-picker/hooks/useTimePickerTextConfig.js');
require('../../hooks/useDebounce.js');
require('../../hooks/usePersistFn.js');
require('../../hooks/usePropsRef.js');
require('../../time-picker/TimeRangePicker.js');
require('../../range-input/index.js');
require('../../range-input/RangeInput.js');
require('../../range-input/defaultProps.js');
require('../../range-input/RangeInputPopup.js');
require('../../time-picker/panel/TimePickerPanel.js');
require('../../time-picker/defaultProps.js');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

var React__default = /*#__PURE__*/_interopDefaultLegacy(React);

function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { defineProperty._defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
function PanelContent(props) {
  var _useConfig = hooks_useConfig["default"](),
    classPrefix = _useConfig.classPrefix;
  var panelName = "".concat(classPrefix, "-date-picker__panel");
  var value = props.value,
    year = props.year,
    month = props.month,
    mode = props.mode,
    format$1 = props.format,
    enableTimePicker = props.enableTimePicker,
    timePickerProps = props.timePickerProps,
    firstDayOfWeek = props.firstDayOfWeek,
    _props$partial = props.partial,
    partial = _props$partial === void 0 ? "start" : _props$partial,
    time = props.time,
    tableData = props.tableData,
    onJumperClick = props.onJumperClick,
    _onCellClick = props.onCellClick,
    _onCellMouseEnter = props.onCellMouseEnter,
    onCellMouseLeave = props.onCellMouseLeave,
    onTimePickerChange = props.onTimePickerChange;
  var onMonthChange = hooks_useEventCallback["default"](props.onMonthChange);
  var onYearChange = hooks_useEventCallback["default"](props.onYearChange);
  var _getDefaultFormat = format.getDefaultFormat({
      mode: mode,
      format: format$1,
      enableTimePicker: enableTimePicker
    }),
    timeFormat = _getDefaultFormat.timeFormat;
  var showTimePicker = enableTimePicker && mode === "date";
  var defaultTime = "00:00:00";
  var onMonthChangeInner = React.useCallback(function (val) {
    onMonthChange === null || onMonthChange === void 0 || onMonthChange(val, {
      partial: partial
    });
  }, [partial, onMonthChange]);
  var onYearChangeInner = React.useCallback(function (val) {
    onYearChange === null || onYearChange === void 0 || onYearChange(val, {
      partial: partial
    });
  }, [partial, onYearChange]);
  var onJumperClickInner = React.useCallback(function (_ref) {
    var trigger = _ref.trigger;
    onJumperClick === null || onJumperClick === void 0 || onJumperClick({
      trigger: trigger,
      partial: partial
    });
  }, [partial, onJumperClick]);
  return /* @__PURE__ */React__default["default"].createElement("div", {
    className: "".concat(panelName, "-content")
  }, /* @__PURE__ */React__default["default"].createElement("div", {
    className: "".concat(panelName, "-").concat(mode)
  }, /* @__PURE__ */React__default["default"].createElement(datePicker_base_Header["default"], {
    mode: mode,
    year: year,
    month: month,
    onMonthChange: onMonthChangeInner,
    onYearChange: onYearChangeInner,
    onJumperClick: onJumperClickInner
  }), /* @__PURE__ */React__default["default"].createElement(datePicker_base_Table["default"], {
    mode: mode,
    data: tableData,
    value: value,
    time: time,
    format: format$1,
    firstDayOfWeek: firstDayOfWeek,
    multiple: props.multiple,
    onCellClick: function onCellClick(date, _ref2) {
      var e = _ref2.e;
      return _onCellClick === null || _onCellClick === void 0 ? void 0 : _onCellClick(date, {
        e: e,
        partial: partial
      });
    },
    onCellMouseEnter: function onCellMouseEnter(date) {
      return _onCellMouseEnter === null || _onCellMouseEnter === void 0 ? void 0 : _onCellMouseEnter(date, {
        partial: partial
      });
    },
    onCellMouseLeave: onCellMouseLeave
  })), showTimePicker && /* @__PURE__ */React__default["default"].createElement("div", {
    className: "".concat(panelName, "-time")
  }, /* @__PURE__ */React__default["default"].createElement("div", {
    className: "".concat(panelName, "-time-viewer")
  }, time || defaultTime), /* @__PURE__ */React__default["default"].createElement(timePicker_index.TimePickerPanel, _objectSpread({
    key: partial,
    position: partial,
    format: timeFormat,
    value: time || defaultTime,
    onChange: onTimePickerChange,
    isShowPanel: props.popupVisible
  }, timePickerProps))));
}

exports["default"] = PanelContent;
//# sourceMappingURL=PanelContent.js.map
