/**
 * tdesign v1.13.1
 * (c) 2025 tdesign
 * @license MIT
 */

'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var defineProperty = require('../_chunks/dep-7a6528ec.js');
var React = require('react');
var log = require('../_chunks/dep-cc4e3925.js');
var _util_reactRender = require('../_util/react-render.js');
var drawer_Drawer = require('./Drawer.js');
var _util_style = require('../_chunks/dep-68db2ca6.js');
var configProvider_ConfigProvider = require('../config-provider/ConfigProvider.js');
require('../config-provider/ConfigContext.js');
var common_PluginContainer = require('../common/PluginContainer.js');
require('../_chunks/dep-c83f28a0.js');
require('../_chunks/dep-608840a8.js');
require('react-dom');
require('../_chunks/dep-e358a1dc.js');
require('../_chunks/dep-3012da29.js');
require('../_chunks/dep-7e3b8125.js');
require('classnames');
require('react-transition-group');
require('tdesign-icons-react');
require('../locale/LocalReceiver.js');
require('../_chunks/dep-6e448b65.js');
require('../_chunks/dep-912bd8a2.js');
require('../_chunks/dep-78e8fc97.js');
require('../_chunks/dep-0fccdcfb.js');
require('../button/index.js');
require('../button/Button.js');
require('../hooks/useConfig.js');
require('../hooks/useDomRefCallback.js');
require('../hooks/useRipple.js');
require('../_chunks/dep-8593a497.js');
require('../hooks/useAnimation.js');
require('../loading/index.js');
require('../loading/Loading.js');
require('../common/Portal.js');
require('../hooks/useLayoutEffect.js');
require('../loading/gradient.js');
require('../_chunks/dep-f34d3a30.js');
require('../_chunks/dep-210ce7c8.js');
require('../_chunks/dep-b47ed304.js');
require('../loading/defaultProps.js');
require('../hooks/useDefaultProps.js');
require('../_chunks/dep-1debbc3e.js');
require('../_chunks/dep-b4e78a42.js');
require('dayjs');
require('../_chunks/dep-fdd584c5.js');
require('../_chunks/dep-84fd1465.js');
require('../_chunks/dep-023db433.js');
require('../_chunks/dep-77879fb6.js');
require('../_chunks/dep-356859aa.js');
require('../_chunks/dep-e2240b05.js');
require('../_chunks/dep-837f0312.js');
require('../_chunks/dep-413bc6a7.js');
require('../_chunks/dep-84d18206.js');
require('../_chunks/dep-5e1fc2cd.js');
require('../_chunks/dep-0be4d457.js');
require('../_chunks/dep-6058edb6.js');
require('../_chunks/dep-cfe601e8.js');
require('../_chunks/dep-6c342676.js');
require('../_chunks/dep-8bd04901.js');
require('../_chunks/dep-2f3e85f6.js');
require('../_chunks/dep-3cfcca89.js');
require('../_chunks/dep-64afded1.js');
require('../_chunks/dep-a1d853fb.js');
require('../loading/plugin.js');
require('../_chunks/dep-34def105.js');
require('../_chunks/dep-cc2fe55a.js');
require('../_chunks/dep-680d1e3e.js');
require('../_chunks/dep-a3962a45.js');
require('../_chunks/dep-b6bde0bc.js');
require('../_chunks/dep-f90d944e.js');
require('../_chunks/dep-46616204.js');
require('../button/defaultProps.js');
require('../_util/parseTNode.js');
require('../hooks/useGlobalIcon.js');
require('./defaultProps.js');
require('./hooks/useDrag.js');
require('./hooks/useLockStyle.js');
require('../_chunks/dep-d9b4b0dc.js');
require('../_util/scroll.js');
require('raf');
require('../_util/easing.js');
require('../hooks/useAttach.js');
require('../hooks/useSetState.js');
require('../_chunks/dep-dfe5fb78.js');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

var React__default = /*#__PURE__*/_interopDefaultLegacy(React);

function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { defineProperty._defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
var createDrawer = function createDrawer(props) {
  var drawerRef = /*#__PURE__*/React__default["default"].createRef();
  var _props$visible = props.visible,
    visible = _props$visible === void 0 ? false : _props$visible;
  var fragment = document.createDocumentFragment();
  var dGlobalConfig = configProvider_ConfigProvider["default"].getGlobalConfig();
  _util_reactRender.render(/* @__PURE__ */React__default["default"].createElement(common_PluginContainer["default"], {
    globalConfig: dGlobalConfig
  }, /* @__PURE__ */React__default["default"].createElement(drawer_Drawer["default"], _objectSpread(_objectSpread({}, props), {}, {
    visible: visible,
    ref: drawerRef,
    isPlugin: true
  }))), fragment);
  var container = _util_style.getAttach(props.attach);
  if (container) {
    requestAnimationFrame(function () {
      var _drawerRef$current;
      (_drawerRef$current = drawerRef.current) === null || _drawerRef$current === void 0 || _drawerRef$current.show();
    });
    container.appendChild(fragment);
  } else {
    log.log.error("Drawer", "attach is not exist");
  }
  var drawerNode = {
    show: function show() {
      requestAnimationFrame(function () {
        var _drawerRef$current2;
        (_drawerRef$current2 = drawerRef.current) === null || _drawerRef$current2 === void 0 || _drawerRef$current2.show();
      });
    },
    hide: function hide() {
      requestAnimationFrame(function () {
        var _drawerRef$current3;
        (_drawerRef$current3 = drawerRef.current) === null || _drawerRef$current3 === void 0 || _drawerRef$current3.destroy();
      });
    },
    update: function update(updateOptions) {
      requestAnimationFrame(function () {
        var _drawerRef$current4;
        (_drawerRef$current4 = drawerRef.current) === null || _drawerRef$current4 === void 0 || _drawerRef$current4.update(updateOptions);
      });
    },
    destroy: function destroy() {
      requestAnimationFrame(function () {
        var _drawerRef$current5;
        (_drawerRef$current5 = drawerRef.current) === null || _drawerRef$current5 === void 0 || _drawerRef$current5.destroy();
      });
    }
  };
  return drawerNode;
};
var DrawerPlugin = createDrawer;

exports.DrawerPlugin = DrawerPlugin;
//# sourceMappingURL=plugin.js.map
