/**
 * tdesign v1.13.1
 * (c) 2025 tdesign
 * @license MIT
 */

'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var defineProperty = require('../../_chunks/dep-7a6528ec.js');
var React = require('react');
var dropdown_DropdownMenu = require('../DropdownMenu.js');
var dropdown_DropdownItem = require('../DropdownItem.js');
require('../../_chunks/dep-c83f28a0.js');
require('../../_chunks/dep-3012da29.js');
require('../../_chunks/dep-7e3b8125.js');
require('classnames');
require('tdesign-icons-react');
require('../../hooks/useConfig.js');
require('../../config-provider/ConfigContext.js');
require('../../_chunks/dep-1debbc3e.js');
require('../../_chunks/dep-b4e78a42.js');
require('dayjs');
require('../../_chunks/dep-fdd584c5.js');
require('../../_chunks/dep-84fd1465.js');
require('../../_chunks/dep-023db433.js');
require('../../_chunks/dep-912bd8a2.js');
require('../../_chunks/dep-0fccdcfb.js');
require('../../_chunks/dep-78e8fc97.js');
require('../../_chunks/dep-77879fb6.js');
require('../../_chunks/dep-356859aa.js');
require('../../_chunks/dep-e2240b05.js');
require('../../_chunks/dep-837f0312.js');
require('../../_chunks/dep-413bc6a7.js');
require('../../_chunks/dep-84d18206.js');
require('../../_chunks/dep-5e1fc2cd.js');
require('../../_chunks/dep-0be4d457.js');
require('../../_chunks/dep-6058edb6.js');
require('../../_chunks/dep-cfe601e8.js');
require('../../_chunks/dep-6c342676.js');
require('../../_chunks/dep-8bd04901.js');
require('../../_chunks/dep-2f3e85f6.js');
require('../../_chunks/dep-3cfcca89.js');
require('../../_chunks/dep-64afded1.js');
require('../../_chunks/dep-a1d853fb.js');
require('../../divider/index.js');
require('../../divider/Divider.js');
require('../../_chunks/dep-e358a1dc.js');
require('../../divider/defaultProps.js');
require('../../hooks/useDefaultProps.js');
require('../../hooks/useGlobalIcon.js');
require('../../_chunks/dep-8c89cfa8.js');
require('../../_chunks/dep-7bb447f9.js');
require('../../_chunks/dep-5941343f.js');
require('../../_chunks/dep-665eea2b.js');
require('../../hooks/useDomRefCallback.js');
require('../../hooks/useRipple.js');
require('../../_chunks/dep-8593a497.js');
require('../../hooks/useAnimation.js');
require('../../_chunks/dep-68db2ca6.js');
require('../../_chunks/dep-6e448b65.js');
require('../defaultProps.js');
require('../../_util/helper.js');
require('../../_chunks/dep-1819e167.js');
require('../../_chunks/dep-ed0d1cf9.js');
require('../../_chunks/dep-00e10ad8.js');
require('../../_chunks/dep-5d5d7b13.js');
require('../../_chunks/dep-ba207e81.js');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

var React__default = /*#__PURE__*/_interopDefaultLegacy(React);

function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { defineProperty._defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
var _getOptionsFromChildren = function getOptionsFromChildren(children) {
  if (!children) return [];
  if (children.type === dropdown_DropdownMenu["default"]) {
    var groupChildren = children.props.children;
    if (Array.isArray(groupChildren)) {
      return _getOptionsFromChildren(groupChildren);
    }
  }
  return React__default["default"].Children.toArray(children).map(function (item) {
    var _item$props, _item$props2;
    var groupChildren = (_item$props = item.props) === null || _item$props === void 0 ? void 0 : _item$props.children;
    var contextRes = (_item$props2 = item.props) === null || _item$props2 === void 0 ? void 0 : _item$props2.content;
    if (Array.isArray(groupChildren)) {
      var _groupChildren$filter, _groupChildren$filter2;
      var contentCtx = groupChildren === null || groupChildren === void 0 || (_groupChildren$filter = groupChildren.filter) === null || _groupChildren$filter === void 0 ? void 0 : _groupChildren$filter.call(groupChildren, function (v) {
        return ![dropdown_DropdownItem["default"], dropdown_DropdownMenu["default"]].includes(v.type);
      });
      var childrenCtx = groupChildren === null || groupChildren === void 0 || (_groupChildren$filter2 = groupChildren.filter) === null || _groupChildren$filter2 === void 0 ? void 0 : _groupChildren$filter2.call(groupChildren, function (v) {
        return [dropdown_DropdownItem["default"], dropdown_DropdownMenu["default"]].includes(v.type);
      });
      return _objectSpread(_objectSpread({}, item.props), {}, {
        content: contentCtx || groupChildren,
        children: childrenCtx.length > 0 ? _getOptionsFromChildren(groupChildren[1]) : null
      });
    }
    return _objectSpread(_objectSpread({}, item.props), {}, {
      content: groupChildren || contextRes,
      children: null
    });
  }).filter(function (v) {
    return !!v.content;
  });
};
function useDropdownOptions(children, options) {
  var dropdownOptions = React.useMemo(function () {
    if (options && options.length > 0) return options;
    var dropdownMenuChild;
    React__default["default"].Children.forEach(children, function (child) {
      if (! /*#__PURE__*/React__default["default"].isValidElement(child)) return;
      if (child.type === dropdown_DropdownMenu["default"] && child.props.children) {
        dropdownMenuChild = child.props.children;
      }
    });
    return _getOptionsFromChildren(dropdownMenuChild);
  }, [options, children]);
  return dropdownOptions;
}

exports["default"] = useDropdownOptions;
exports.getOptionsFromChildren = _getOptionsFromChildren;
//# sourceMappingURL=useDropdownOptions.js.map
