/**
 * tdesign v1.13.1
 * (c) 2025 tdesign
 * @license MIT
 */

'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var React = require('react');
var tree_Tree = require('../../tree/Tree.js');
var upload_upload = require('../../upload/upload.js');
var tag_CheckTag = require('../../tag/CheckTag.js');
var checkbox_CheckboxGroup = require('../../_chunks/dep-fef35254.js');
var tagInput_TagInput = require('../../tag-input/TagInput.js');
var rangeInput_RangeInput = require('../../range-input/RangeInput.js');
var transfer_Transfer = require('../../transfer/Transfer.js');
var datePicker_DateRangePicker = require('../../date-picker/DateRangePicker.js');
var timePicker_TimeRangePicker = require('../../time-picker/TimeRangePicker.js');
var form_FormContext = require('../FormContext.js');
var isEmpty = require('../../_chunks/dep-f0441248.js');
var get = require('../../_chunks/dep-8a28dfd9.js');
var omit = require('../../_chunks/dep-f4d31431.js');
require('../../_chunks/dep-210ce7c8.js');
require('../../_chunks/dep-7e3b8125.js');
require('../../_chunks/dep-7a6528ec.js');
require('../../_chunks/dep-c83f28a0.js');
require('../../_chunks/dep-3012da29.js');
require('react-transition-group');
require('classnames');
require('../../_chunks/dep-cc4e3925.js');
require('../../tree/TreeItem.js');
require('../../_chunks/dep-e358a1dc.js');
require('tdesign-icons-react');
require('../../loading/index.js');
require('../../loading/Loading.js');
require('../../_chunks/dep-68db2ca6.js');
require('../../_chunks/dep-6e448b65.js');
require('../../_chunks/dep-912bd8a2.js');
require('../../_chunks/dep-78e8fc97.js');
require('../../_chunks/dep-0fccdcfb.js');
require('../../hooks/useConfig.js');
require('../../config-provider/ConfigContext.js');
require('../../_chunks/dep-1debbc3e.js');
require('../../_chunks/dep-b4e78a42.js');
require('dayjs');
require('../../_chunks/dep-fdd584c5.js');
require('../../_chunks/dep-84fd1465.js');
require('../../_chunks/dep-023db433.js');
require('../../_chunks/dep-77879fb6.js');
require('../../_chunks/dep-356859aa.js');
require('../../_chunks/dep-e2240b05.js');
require('../../_chunks/dep-837f0312.js');
require('../../_chunks/dep-413bc6a7.js');
require('../../_chunks/dep-84d18206.js');
require('../../_chunks/dep-5e1fc2cd.js');
require('../../_chunks/dep-0be4d457.js');
require('../../_chunks/dep-6058edb6.js');
require('../../_chunks/dep-cfe601e8.js');
require('../../_chunks/dep-6c342676.js');
require('../../_chunks/dep-8bd04901.js');
require('../../_chunks/dep-2f3e85f6.js');
require('../../_chunks/dep-3cfcca89.js');
require('../../_chunks/dep-64afded1.js');
require('../../_chunks/dep-a1d853fb.js');
require('../../common/Portal.js');
require('react-dom');
require('../../hooks/useLayoutEffect.js');
require('../../loading/gradient.js');
require('../../_chunks/dep-8593a497.js');
require('../../_chunks/dep-f34d3a30.js');
require('../../_chunks/dep-b47ed304.js');
require('../../hooks/useDomRefCallback.js');
require('../../loading/defaultProps.js');
require('../../hooks/useDefaultProps.js');
require('../../loading/plugin.js');
require('../../_util/react-render.js');
require('../../_chunks/dep-608840a8.js');
require('../../common/PluginContainer.js');
require('../../config-provider/ConfigProvider.js');
require('../../_chunks/dep-34def105.js');
require('../../_chunks/dep-cc2fe55a.js');
require('../../_chunks/dep-680d1e3e.js');
require('../../_chunks/dep-a3962a45.js');
require('../../_chunks/dep-b6bde0bc.js');
require('../../_chunks/dep-f90d944e.js');
require('../../_chunks/dep-46616204.js');
require('../../hooks/useRipple.js');
require('../../hooks/useAnimation.js');
require('../../hooks/useGlobalIcon.js');
require('../../checkbox/index.js');
require('../../_util/forwardRefWithStatics.js');
require('hoist-non-react-statics');
require('../../common/Check.js');
require('../../_util/helper.js');
require('../../_chunks/dep-1819e167.js');
require('../../_chunks/dep-ed0d1cf9.js');
require('../../_chunks/dep-665eea2b.js');
require('../../_chunks/dep-00e10ad8.js');
require('../../_chunks/dep-5d5d7b13.js');
require('../../_chunks/dep-ba207e81.js');
require('../../hooks/useControlled.js');
require('../../_util/noop.js');
require('../../_chunks/dep-69751dfb.js');
require('../../checkbox/defaultProps.js');
require('../../tree/hooks/useTreeConfig.js');
require('../../locale/LocalReceiver.js');
require('../../tree/hooks/useDraggable.js');
require('../../tree/hooks/TreeDraggableContext.js');
require('../../_util/createHookContext.js');
require('../../hooks/usePersistFn.js');
require('../../_chunks/dep-8c89cfa8.js');
require('../../_chunks/dep-7bb447f9.js');
require('../../_chunks/dep-5941343f.js');
require('../../_util/composeRefs.js');
require('../../tree/hooks/useControllable.js');
require('../../tree/hooks/useStore.js');
require('../../_chunks/dep-b571b0e0.js');
require('../../_chunks/dep-560c14c5.js');
require('mitt');
require('../../_chunks/dep-8ee4aae7.js');
require('../../_chunks/dep-52a009fb.js');
require('../../_chunks/dep-8529ce07.js');
require('../../_chunks/dep-962f011a.js');
require('../../_chunks/dep-58cddfe4.js');
require('../../_chunks/dep-c29b655c.js');
require('../../_chunks/dep-d843946a.js');
require('../../_chunks/dep-dfe5fb78.js');
require('../../_chunks/dep-d9f53773.js');
require('../../_chunks/dep-c1986661.js');
require('../../_chunks/dep-bb56a94e.js');
require('../../_chunks/dep-2545fc22.js');
require('../../_chunks/dep-becc25b2.js');
require('../../_chunks/dep-a09b28f5.js');
require('../../hooks/useUpdateLayoutEffect.js');
require('../../hooks/useIsFirstRender.js');
require('../../hooks/usePrevious.js');
require('../../_chunks/dep-be9040ff.js');
require('../../_util/parseTNode.js');
require('../../tree/hooks/useTreeVirtualScroll.js');
require('../../hooks/useVirtualScroll.js');
require('../../hooks/useResizeObserver.js');
require('../../hooks/useLatest.js');
require('../../hooks/useEventCallback.js');
require('../../upload/themes/NormalFile.js');
require('../../_chunks/dep-cb5dac3c.js');
require('../../link/index.js');
require('../../link/Link.js');
require('../../link/defaultProps.js');
require('../../upload/themes/DraggerFile.js');
require('../../hooks/useCommonClassName.js');
require('../../upload/hooks/useDrag.js');
require('../../image-viewer/index.js');
require('../../image-viewer/ImageViewer.js');
require('../../_chunks/dep-92f915f5.js');
require('../../_chunks/dep-006cdaa7.js');
require('../../hooks/useImagePreviewUrl.js');
require('../../image/index.js');
require('../../image/Image.js');
require('../../_chunks/dep-3905781f.js');
require('../../image/defaultProps.js');
require('../../space/index.js');
require('../../space/Space.js');
require('react-is');
require('../../space/defaultProps.js');
require('../../tooltip/index.js');
require('../../tooltip/Tooltip.js');
require('../../popup/index.js');
require('../../popup/Popup.js');
require('../../_util/ref.js');
require('../../_util/isFragment.js');
require('../../hooks/useAttach.js');
require('../../hooks/useMutationObserver.js');
require('../../_chunks/dep-c73e0aa5.js');
require('../../_chunks/dep-ba79870d.js');
require('../../hooks/usePopper.js');
require('@popperjs/core');
require('react-fast-compare');
require('../../hooks/useWindowSize.js');
require('../../popup/defaultProps.js');
require('../../popup/hooks/useTrigger.js');
require('../../_util/listener.js');
require('../../popup/utils/transition.js');
require('../../popup/PopupPlugin.js');
require('../../tooltip/defaultProps.js');
require('../../tooltip/TooltipLite.js');
require('../../hooks/useSwitch.js');
require('../../dialog/index.js');
require('../../dialog/Dialog.js');
require('../../hooks/useSetState.js');
require('../../dialog/defaultProps.js');
require('../../dialog/DialogCard.js');
require('../../button/index.js');
require('../../button/Button.js');
require('../../button/defaultProps.js');
require('../../dialog/hooks/useDialogEsc.js');
require('../../dialog/hooks/useLockStyle.js');
require('../../_chunks/dep-d9b4b0dc.js');
require('../../dialog/hooks/useDialogPosition.js');
require('../../dialog/hooks/useDialogDrag.js');
require('../../dialog/utils.js');
require('../../dialog/plugin.js');
require('../../image-viewer/hooks/useIconMap.js');
require('../../image-viewer/hooks/useIndex.js');
require('../../image-viewer/hooks/useMirror.js');
require('../../image-viewer/hooks/usePosition.js');
require('../../image-viewer/hooks/useRotate.js');
require('../../image-viewer/hooks/useScale.js');
require('../../image-viewer/utils.js');
require('../../image-viewer/defaultProps.js');
require('../../image-viewer/hooks/useImageScale.js');
require('../../image-viewer/hooks/useList.js');
require('../../image-viewer/hooks/useViewerScale.js');
require('../../upload/themes/ImageCard.js');
require('../../upload/themes/MultipleFlowList.js');
require('../../upload/hooks/useUpload.js');
require('../../_chunks/dep-b1e7d4c3.js');
require('../../upload/defaultProps.js');
require('../../upload/themes/CustomFile.js');
require('../../_chunks/dep-59a9c125.js');
require('../../tag/defaultProps.js');
require('../../tag/Tag.js');
require('tinycolor2');
require('../../hooks/useDragSorter.js');
require('../../input/index.js');
require('../../input/Input.js');
require('../../input/InputGroup.js');
require('../../input/defaultProps.js');
require('../../input/useLengthLimit.js');
require('../../tag-input/useTagScroll.js');
require('../../tag-input/useTagList.js');
require('../../tag/index.js');
require('../../tag/CheckTagGroup.js');
require('../../tag-input/useHover.js');
require('../../tag-input/defaultProps.js');
require('../../range-input/defaultProps.js');
require('../../transfer/TransferList.js');
require('../../transfer/utils.js');
require('../../pagination/index.js');
require('../../pagination/Pagination.js');
require('../../select/index.js');
require('../../select/base/Select.js');
require('../../_chunks/dep-6638dce8.js');
require('../../select/base/OptionGroup.js');
require('../../select/defaultProps.js');
require('../../select/base/Option.js');
require('../../common/FakeArrow.js');
require('../../select-input/index.js');
require('../../select-input/SelectInput.js');
require('../../select-input/useSingle.js');
require('../../select-input/useMultiple.js');
require('../../tag-input/index.js');
require('../../select-input/useOverlayInnerStyle.js');
require('../../select-input/defaultProps.js');
require('../../select/base/PopupContent.js');
require('../../select/hooks/usePanelVirtualScroll.js');
require('../../input-number/index.js');
require('../../input-number/InputNumber.js');
require('../../input-number/useInputNumber.js');
require('../../input-number/defaultProps.js');
require('../../input-adornment/InputAdornment.js');
require('../../pagination/hooks/useBoundaryJumper.js');
require('../../pagination/hooks/usePrevNextJumper.js');
require('../../pagination/hooks/usePageNumber.js');
require('../../pagination/hooks/useTotal.js');
require('../../pagination/validators.js');
require('../../pagination/defaultProps.js');
require('../../pagination/PaginationMini.js');
require('../../transfer/defaultProps.js');
require('../../_chunks/dep-2c36bed6.js');
require('../../_chunks/dep-59cc13ee.js');
require('../../_chunks/dep-5b899485.js');
require('../../range-input/index.js');
require('../../range-input/RangeInputPopup.js');
require('../../date-picker/panel/RangePanel.js');
require('../../date-picker/panel/PanelContent.js');
require('../../date-picker/base/Header.js');
require('../../date-picker/base/Table.js');
require('../../date-picker/base/Cell.js');
require('../../time-picker/index.js');
require('../../time-picker/TimePicker.js');
require('../../_chunks/dep-feb1fd45.js');
require('../../time-picker/hooks/useTimePickerTextConfig.js');
require('../../hooks/useDebounce.js');
require('../../hooks/usePropsRef.js');
require('../../time-picker/panel/TimePickerPanel.js');
require('../../time-picker/defaultProps.js');
require('../../date-picker/panel/ExtraContent.js');
require('../../date-picker/base/Footer.js');
require('../../date-picker/hooks/useTableData.js');
require('../../date-picker/hooks/useDisableDate.js');
require('../../date-picker/utils.js');
require('../../date-picker/hooks/useRange.js');
require('../../date-picker/hooks/useRangeValue.js');
require('../../date-picker/defaultProps.js');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

var React__default = /*#__PURE__*/_interopDefaultLegacy(React);

/**
 * Removes the property at `path` of `object`.
 *
 * **Note:** This method mutates `object`.
 *
 * @static
 * @memberOf _
 * @since 4.0.0
 * @category Object
 * @param {Object} object The object to modify.
 * @param {Array|string} path The path of the property to unset.
 * @returns {boolean} Returns `true` if the property is deleted, else `false`.
 * @example
 *
 * var object = { 'a': [{ 'b': { 'c': 7 } }] };
 * _.unset(object, 'a[0].b.c');
 * // => true
 *
 * console.log(object);
 * // => { 'a': [{ 'b': {} }] };
 *
 * _.unset(object, ['a', '0', 'b', 'c']);
 * // => true
 *
 * console.log(object);
 * // => { 'a': [{ 'b': {} }] };
 */
function unset(object, path) {
  return object == null ? true : omit.baseUnset(object, path);
}

var ctrlKeyMap = /* @__PURE__ */new Map();
ctrlKeyMap.set(checkbox_CheckboxGroup.Checkbox, "checked");
ctrlKeyMap.set(tag_CheckTag["default"], "checked");
ctrlKeyMap.set(upload_upload["default"], "files");
var initialDataMap = /* @__PURE__ */new Map();
[tree_Tree["default"], upload_upload["default"], transfer_Transfer["default"], tagInput_TagInput["default"], rangeInput_RangeInput["default"], checkbox_CheckboxGroup.CheckboxGroup, datePicker_DateRangePicker["default"], timePicker_TimeRangePicker["default"]].forEach(function (component) {
  initialDataMap.set(component, []);
});
[checkbox_CheckboxGroup.Checkbox].forEach(function (component) {
  initialDataMap.set(component, false);
});
function useFormItemInitialData(name) {
  var hadReadFloatingFormData = false;
  var _useFormContext = form_FormContext.useFormContext(),
    floatingFormDataRef = _useFormContext.floatingFormDataRef,
    formContextInitialData = _useFormContext.initialData;
  var _useFormListContext = form_FormContext.useFormListContext(),
    formListName = _useFormListContext.name,
    formListInitialData = _useFormListContext.initialData;
  React.useEffect(function () {
    if (hadReadFloatingFormData) {
      var nameList = formListName ? [formListName, name].flat() : name;
      unset(floatingFormDataRef.current, nameList);
    }
  }, [hadReadFloatingFormData, floatingFormDataRef, formListName, name]);
  function getDefaultInitialData(_ref) {
    var children = _ref.children,
      initialData = _ref.initialData;
    if (name && floatingFormDataRef !== null && floatingFormDataRef !== void 0 && floatingFormDataRef.current && !isEmpty.isEmpty(floatingFormDataRef.current)) {
      var nameList = formListName ? [formListName, name].flat() : name;
      var defaultInitialData = get.get(floatingFormDataRef.current, nameList);
      if (typeof defaultInitialData !== "undefined") {
        hadReadFloatingFormData = true;
        return defaultInitialData;
      }
    }
    if (typeof initialData !== "undefined") {
      return initialData;
    }
    if (name && formListInitialData.length) {
      var _defaultInitialData = get.get(formListInitialData, name);
      if (typeof _defaultInitialData !== "undefined") return _defaultInitialData;
    }
    if (name && formContextInitialData) {
      var _defaultInitialData2 = get.get(formContextInitialData, name);
      if (typeof _defaultInitialData2 !== "undefined") return _defaultInitialData2;
    }
    if (typeof children !== "function") {
      var childList = React__default["default"].Children.toArray(children);
      var lastChild = childList[childList.length - 1];
      if (lastChild && /*#__PURE__*/React__default["default"].isValidElement(lastChild)) {
        var _lastChild$props;
        var isMultiple = lastChild === null || lastChild === void 0 || (_lastChild$props = lastChild.props) === null || _lastChild$props === void 0 ? void 0 : _lastChild$props.multiple;
        return isMultiple ? [] : initialDataMap.get(lastChild.type);
      }
    }
  }
  return {
    getDefaultInitialData: getDefaultInitialData
  };
}

exports.ctrlKeyMap = ctrlKeyMap;
exports["default"] = useFormItemInitialData;
exports.initialDataMap = initialDataMap;
//# sourceMappingURL=useFormItemInitialData.js.map
