/**
 * tdesign v1.13.1
 * (c) 2025 tdesign
 * @license MIT
 */

'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var slicedToArray = require('../../_chunks/dep-3012da29.js');
var React = require('react');
var form_hooks_useForm = require('./useForm.js');
var _util_noop = require('../../_util/noop.js');
var get = require('../../_chunks/dep-8a28dfd9.js');
var isUndefined = require('../../_chunks/dep-dfe5fb78.js');
require('../../_chunks/dep-7e3b8125.js');
require('../../_chunks/dep-210ce7c8.js');
require('../../_chunks/dep-560c14c5.js');
require('../../_chunks/dep-7a6528ec.js');
require('../../_chunks/dep-c83f28a0.js');
require('../../_chunks/dep-cc4e3925.js');
require('../../_chunks/dep-8529ce07.js');
require('../../_chunks/dep-78e8fc97.js');
require('../../_chunks/dep-665eea2b.js');
require('../../_chunks/dep-912bd8a2.js');
require('../../_chunks/dep-0fccdcfb.js');
require('../../_chunks/dep-5e1fc2cd.js');
require('../../_chunks/dep-0be4d457.js');
require('../../_chunks/dep-e2240b05.js');
require('../../_chunks/dep-837f0312.js');
require('../../_chunks/dep-6058edb6.js');
require('../../_chunks/dep-ed0d1cf9.js');

function useWatch(name, form) {
  var _useState = React.useState(),
    _useState2 = slicedToArray._slicedToArray(_useState, 2),
    value = _useState2[0],
    setValue = _useState2[1];
  var valueStr = React.useMemo(function () {
    return JSON.stringify(value);
  }, [value]);
  var valueStrRef = React.useRef(valueStr);
  var isValidForm = form && form._init;
  React.useEffect(function () {
    var _form$getInternalHook3, _form$getFieldsValue2;
    if (!isValidForm) return;
    var _form$getInternalHook = (_form$getInternalHook3 = form.getInternalHooks) === null || _form$getInternalHook3 === void 0 ? void 0 : _form$getInternalHook3.call(form, form_hooks_useForm.HOOK_MARK),
      _form$getInternalHook2 = _form$getInternalHook.registerWatch,
      registerWatch = _form$getInternalHook2 === void 0 ? _util_noop["default"] : _form$getInternalHook2;
    var cancelRegister = registerWatch(function () {
      var _form$getFieldsValue;
      var allFieldsValue2 = (_form$getFieldsValue = form.getFieldsValue) === null || _form$getFieldsValue === void 0 ? void 0 : _form$getFieldsValue.call(form, true);
      var newValue = get.get(allFieldsValue2, name);
      var nextValueStr = JSON.stringify(newValue);
      if (valueStrRef.current !== nextValueStr) {
        valueStrRef.current = nextValueStr;
        setValue(nextValueStr);
      }
    });
    var allFieldsValue = (_form$getFieldsValue2 = form.getFieldsValue) === null || _form$getFieldsValue2 === void 0 ? void 0 : _form$getFieldsValue2.call(form, true);
    var initialValue = get.get(allFieldsValue, name);
    setValue(JSON.stringify(initialValue));
    return cancelRegister;
  }, []);
  return isUndefined.isUndefined(value) ? value : JSON.parse(value);
}

exports["default"] = useWatch;
//# sourceMappingURL=useWatch.js.map
