/**
 * tdesign v1.13.1
 * (c) 2025 tdesign
 * @license MIT
 */

'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var slicedToArray = require('../_chunks/dep-3012da29.js');
var React = require('react');
var _util_noop = require('../_util/noop.js');
var upperFirst = require('../_chunks/dep-00e10ad8.js');
require('../_chunks/dep-7e3b8125.js');
require('../_chunks/dep-5d5d7b13.js');
require('../_chunks/dep-ba207e81.js');
require('../_chunks/dep-ed0d1cf9.js');
require('../_chunks/dep-912bd8a2.js');
require('../_chunks/dep-c83f28a0.js');
require('../_chunks/dep-78e8fc97.js');
require('../_chunks/dep-665eea2b.js');
require('../_chunks/dep-0fccdcfb.js');

var useControlled = function useControlled() {
  var props = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
  var valueKey = arguments.length > 1 ? arguments[1] : undefined;
  var onChange = arguments.length > 2 ? arguments[2] : undefined;
  var defaultOptions = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : {};
  var controlled = Reflect.has(props, valueKey);
  var value = props[valueKey];
  var defaultValue = defaultOptions["default".concat(upperFirst.upperFirst(valueKey))] || props["default".concat(upperFirst.upperFirst(valueKey))];
  var _useState = React.useState(defaultValue),
    _useState2 = slicedToArray._slicedToArray(_useState, 2),
    internalValue = _useState2[0],
    setInternalValue = _useState2[1];
  if (controlled) return [value, onChange || _util_noop["default"]];
  return [internalValue, function (newValue) {
    setInternalValue(newValue);
    for (var _len = arguments.length, args = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      args[_key - 1] = arguments[_key];
    }
    onChange === null || onChange === void 0 || onChange.apply(void 0, [newValue].concat(args));
  }];
};

exports["default"] = useControlled;
//# sourceMappingURL=useControlled.js.map
