/**
 * tdesign v1.13.1
 * (c) 2025 tdesign
 * @license MIT
 */

'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var React = require('react');
var hooks_usePersistFn = require('./usePersistFn.js');
var debounce = require('../_chunks/dep-7bb447f9.js');
require('../_chunks/dep-837f0312.js');
require('../_chunks/dep-c83f28a0.js');
require('../_chunks/dep-912bd8a2.js');
require('../_chunks/dep-5941343f.js');
require('../_chunks/dep-665eea2b.js');
require('../_chunks/dep-0fccdcfb.js');

var useDebounce = function useDebounce(func, delay, options) {
  var callback = hooks_usePersistFn.usePersistFn(func);
  var debounced = React.useCallback(debounce.debounce(callback, delay, options), [callback, delay, options]);
  React.useEffect(function () {
    return debounced.cancel;
  }, [debounced]);
  return debounced;
};

exports["default"] = useDebounce;
//# sourceMappingURL=useDebounce.js.map
