/**
 * tdesign v1.13.1
 * (c) 2025 tdesign
 * @license MIT
 */

'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var React = require('react');

function usePersistFn(fn) {
  var fnRef = React.useRef(fn);
  fnRef.current = fn;
  var persistFn = React.useRef(null);
  if (!persistFn.current) {
    persistFn.current = function () {
      for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
        args[_key] = arguments[_key];
      }
      return fnRef.current.apply(this, args);
    };
  }
  return persistFn.current;
}

exports.usePersistFn = usePersistFn;
//# sourceMappingURL=usePersistFn.js.map
