/**
 * tdesign v1.13.1
 * (c) 2025 tdesign
 * @license MIT
 */

'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var hooks_useLayoutEffect = require('./useLayoutEffect.js');
var _util_style = require('../_chunks/dep-68db2ca6.js');
var hooks_useLatest = require('./useLatest.js');
require('react');
require('../_chunks/dep-6e448b65.js');
require('../_chunks/dep-912bd8a2.js');
require('../_chunks/dep-c83f28a0.js');
require('../_chunks/dep-78e8fc97.js');
require('../_chunks/dep-0fccdcfb.js');

function useResizeObserver(container, callback) {
  var enabled = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : true;
  var callbackRef = hooks_useLatest["default"](callback);
  hooks_useLayoutEffect["default"](function () {
    var isSupport = _util_style.canUseDocument && window.ResizeObserver;
    var element = container.current;
    var observer = null;
    if (!enabled) return;
    if (isSupport && element) {
      var resizeCallback = function resizeCallback(entries) {
        callbackRef.current(entries);
      };
      observer = new ResizeObserver(resizeCallback);
      observer.observe(element);
    }
    return function () {
      if (observer && element) {
        var _observer$disconnect, _observer;
        observer.unobserve(element);
        (_observer$disconnect = (_observer = observer).disconnect) === null || _observer$disconnect === void 0 || _observer$disconnect.call(_observer);
        observer = null;
      }
    };
  }, [container, enabled]);
}

exports["default"] = useResizeObserver;
//# sourceMappingURL=useResizeObserver.js.map
