/**
 * tdesign v1.13.1
 * (c) 2025 tdesign
 * @license MIT
 */

'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var slicedToArray = require('../_chunks/dep-3012da29.js');
var React = require('react');
var _util_style = require('../_chunks/dep-68db2ca6.js');
var debounce = require('../_chunks/dep-7bb447f9.js');
require('../_chunks/dep-7e3b8125.js');
require('../_chunks/dep-6e448b65.js');
require('../_chunks/dep-912bd8a2.js');
require('../_chunks/dep-c83f28a0.js');
require('../_chunks/dep-78e8fc97.js');
require('../_chunks/dep-0fccdcfb.js');
require('../_chunks/dep-837f0312.js');
require('../_chunks/dep-5941343f.js');
require('../_chunks/dep-665eea2b.js');

function useWindowSize() {
  var _useState = React.useState(_util_style.getWindowSize),
    _useState2 = slicedToArray._slicedToArray(_useState, 2),
    size = _useState2[0],
    setSize = _useState2[1];
  React.useEffect(function () {
    function handleResize() {
      setSize(_util_style.getWindowSize());
    }
    var debounceResize = debounce.debounce(handleResize, 400);
    window.addEventListener("resize", debounceResize);
    return function () {
      window.removeEventListener("resize", debounceResize);
      debounceResize.cancel();
    };
  }, []);
  return size;
}

exports["default"] = useWindowSize;
//# sourceMappingURL=useWindowSize.js.map
