/**
 * tdesign v1.13.1
 * (c) 2025 tdesign
 * @license MIT
 */

'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var slicedToArray = require('../../_chunks/dep-3012da29.js');
var React = require('react');
var hooks_useControlled = require('../../hooks/useControlled.js');
require('../../_chunks/dep-7e3b8125.js');
require('../../_util/noop.js');
require('../../_chunks/dep-00e10ad8.js');
require('../../_chunks/dep-5d5d7b13.js');
require('../../_chunks/dep-ba207e81.js');
require('../../_chunks/dep-ed0d1cf9.js');
require('../../_chunks/dep-912bd8a2.js');
require('../../_chunks/dep-c83f28a0.js');
require('../../_chunks/dep-78e8fc97.js');
require('../../_chunks/dep-665eea2b.js');
require('../../_chunks/dep-0fccdcfb.js');

var useIndex = function useIndex(resProps, images) {
  var _useControlled = hooks_useControlled["default"](resProps, "index", resProps.onIndexChange),
    _useControlled2 = slicedToArray._slicedToArray(_useControlled, 2),
    index = _useControlled2[0],
    setIndex = _useControlled2[1];
  var next = React.useCallback(function () {
    var newIndex = index + 1;
    if (newIndex >= images.length) return index;
    setIndex(newIndex, {
      trigger: "next"
    });
  }, [setIndex, index, images.length]);
  var prev = React.useCallback(function () {
    var newIndex = index - 1 > 0 ? index - 1 : 0;
    setIndex(newIndex, {
      trigger: "prev"
    });
  }, [index, setIndex]);
  return {
    index: index,
    next: next,
    prev: prev,
    setIndex: setIndex
  };
};

exports["default"] = useIndex;
//# sourceMappingURL=useIndex.js.map
