import React from 'react';
import { StyledProps } from '../common';
import { TdLayoutProps, TdHeaderProps, TdFooterProps } from './type';
import Aside from './Aside';
export interface LayoutProps extends TdLayoutProps, StyledProps, React.HTMLAttributes<HTMLDivElement> {
    children?: React.ReactNode;
}
export interface HeaderProps extends TdHeaderProps, StyledProps, React.HTMLAttributes<HTMLElement> {
    children?: React.ReactNode;
}
export interface ContentProps extends StyledProps, React.HTMLAttributes<HTMLElement> {
    children?: React.ReactNode;
}
export interface FooterProps extends TdFooterProps, StyledProps, React.HTMLAttributes<HTMLElement> {
    children?: React.ReactNode;
}
declare const Header: React.FC<HeaderProps>;
declare const Footer: React.FC<FooterProps>;
declare const Content: React.FC<ContentProps>;
/**
 * 布局组件
 */
declare const Layout: React.FC<LayoutProps> & {
    Header: typeof Header;
    Content: typeof Content;
    Footer: typeof Footer;
    Aside: typeof Aside;
};
export default Layout;
