/**
 * tdesign v1.13.1
 * (c) 2025 tdesign
 * @license MIT
 */

'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var React = require('react');
var classNames = require('classnames');
var hooks_useConfig = require('../hooks/useConfig.js');
require('../config-provider/ConfigContext.js');
require('../_chunks/dep-7a6528ec.js');
require('../_chunks/dep-c83f28a0.js');
require('../_chunks/dep-1debbc3e.js');
require('../_chunks/dep-b4e78a42.js');
require('dayjs');
require('../_chunks/dep-fdd584c5.js');
require('../_chunks/dep-84fd1465.js');
require('../_chunks/dep-023db433.js');
require('../_chunks/dep-912bd8a2.js');
require('../_chunks/dep-0fccdcfb.js');
require('../_chunks/dep-78e8fc97.js');
require('../_chunks/dep-77879fb6.js');
require('../_chunks/dep-356859aa.js');
require('../_chunks/dep-e2240b05.js');
require('../_chunks/dep-837f0312.js');
require('../_chunks/dep-413bc6a7.js');
require('../_chunks/dep-84d18206.js');
require('../_chunks/dep-5e1fc2cd.js');
require('../_chunks/dep-0be4d457.js');
require('../_chunks/dep-6058edb6.js');
require('../_chunks/dep-cfe601e8.js');
require('../_chunks/dep-6c342676.js');
require('../_chunks/dep-8bd04901.js');
require('../_chunks/dep-2f3e85f6.js');
require('../_chunks/dep-3cfcca89.js');
require('../_chunks/dep-64afded1.js');
require('../_chunks/dep-a1d853fb.js');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

var React__default = /*#__PURE__*/_interopDefaultLegacy(React);
var classNames__default = /*#__PURE__*/_interopDefaultLegacy(classNames);

var ListItemMeta = /*#__PURE__*/React.forwardRef(function (props, ref) {
  var title = props.title,
    image = props.image,
    description = props.description,
    className = props.className,
    style = props.style;
  var _useConfig = hooks_useConfig["default"](),
    classPrefix = _useConfig.classPrefix;
  var renderAvatar = function renderAvatar() {
    if (image && typeof image === "string") {
      return /* @__PURE__ */React__default["default"].createElement("div", {
        className: "".concat(classPrefix, "-list-item__meta-avatar")
      }, /* @__PURE__ */React__default["default"].createElement("img", {
        src: image,
        alt: ""
      }));
    }
    return /* @__PURE__ */React__default["default"].createElement("div", {
      className: "".concat(classPrefix, "-list-item__meta-avatar")
    }, image);
  };
  return /* @__PURE__ */React__default["default"].createElement("div", {
    ref: ref,
    className: classNames__default["default"]("".concat(classPrefix, "-list-item__meta"), className),
    style: style
  }, image && renderAvatar(), /* @__PURE__ */React__default["default"].createElement("div", {
    className: "".concat(classPrefix, "-list-item__meta-content")
  }, /* @__PURE__ */React__default["default"].createElement("h3", {
    className: "".concat(classPrefix, "-list-item__meta-title")
  }, title), /* @__PURE__ */React__default["default"].createElement("div", {
    className: "".concat(classPrefix, "-list-item__meta-description")
  }, typeof description === "string" ? /* @__PURE__ */React__default["default"].createElement("p", null, description) : description)));
});
ListItemMeta.displayName = "ListItemMeta";

exports["default"] = ListItemMeta;
//# sourceMappingURL=ListItemMeta.js.map
