/**
 * tdesign v1.13.1
 * (c) 2025 tdesign
 * @license MIT
 */

'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var _typeof = require('../_chunks/dep-c83f28a0.js');
var _commonjsHelpers = require('../_chunks/dep-b4e78a42.js');
var dayjs = require('dayjs');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

var dayjs__default = /*#__PURE__*/_interopDefaultLegacy(dayjs);

var ja = {exports: {}};

(function (module, exports) {
  !function (e, _) {
    module.exports = _(dayjs__default["default"]) ;
  }(_commonjsHelpers.commonjsGlobal, function (e) {

    function _(e) {
      return e && "object" == _typeof._typeof(e) && "default" in e ? e : {
        "default": e
      };
    }
    var t = _(e),
      d = {
        name: "ja",
        weekdays: "日曜日_月曜日_火曜日_水曜日_木曜日_金曜日_土曜日".split("_"),
        weekdaysShort: "日_月_火_水_木_金_土".split("_"),
        weekdaysMin: "日_月_火_水_木_金_土".split("_"),
        months: "1月_2月_3月_4月_5月_6月_7月_8月_9月_10月_11月_12月".split("_"),
        monthsShort: "1月_2月_3月_4月_5月_6月_7月_8月_9月_10月_11月_12月".split("_"),
        ordinal: function ordinal(e) {
          return e + "日";
        },
        formats: {
          LT: "HH:mm",
          LTS: "HH:mm:ss",
          L: "YYYY/MM/DD",
          LL: "YYYY年M月D日",
          LLL: "YYYY年M月D日 HH:mm",
          LLLL: "YYYY年M月D日 dddd HH:mm",
          l: "YYYY/MM/DD",
          ll: "YYYY年M月D日",
          lll: "YYYY年M月D日 HH:mm",
          llll: "YYYY年M月D日(ddd) HH:mm"
        },
        meridiem: function meridiem(e) {
          return e < 12 ? "午前" : "午後";
        },
        relativeTime: {
          future: "%s後",
          past: "%s前",
          s: "数秒",
          m: "1分",
          mm: "%d分",
          h: "1時間",
          hh: "%d時間",
          d: "1日",
          dd: "%d日",
          M: "1ヶ月",
          MM: "%dヶ月",
          y: "1年",
          yy: "%d年"
        }
      };
    return t["default"].locale(d, null, !0), d;
  });
})(ja);

var jaJP = {
  autoComplete: {
    empty: "\u30C7\u30FC\u30BF\u306A\u3057"
  },
  pagination: {
    itemsPerPage: "{size} /\u30DA\u30FC\u30B8",
    jumpTo: "\u30B8\u30E3\u30F3\u30D7\u3059\u308B",
    page: "\u30DA\u30FC\u30B8",
    total: "\u5408\u8A08 {count} \u9805\u76EE\u30C7\u30FC\u30BF"
  },
  cascader: {
    empty: "\u30C7\u30FC\u30BF\u306A\u3057",
    loadingText: "\u30ED\u30FC\u30C7\u30A3\u30F3\u30B0",
    placeholder: "\u9078\u629E\u3057\u3066\u304F\u3060\u3055\u3044"
  },
  calendar: {
    yearSelection: "{year} \u5E74",
    monthSelection: "{month} \u6708",
    yearRadio: "\u5E74",
    monthRadio: "\u6708",
    hideWeekend: "\u30D2\u30C9\u30A5\u30F3\u30FB\u30A6\u30A3\u30FC\u30AF\u30A8\u30F3\u30C9",
    showWeekend: "\u30B7\u30E7\u30FC\u30A6\u30A3\u30FC\u30AF\u30A8\u30F3\u30C9",
    today: "\u4ECA\u65E5",
    thisMonth: "\u4ECA\u6708\u306F",
    week: "\u6708,\u706B,\u6C34,\u6728,\u91D1,\u571F,\u65E5",
    cellMonth: "1 \u6708,2 \u6708,3 \u6708,4 \u6708,5 \u6708,6 \u6708,7 \u6708,8 \u6708,9 \u6708,10 \u6708,11 \u6708,12 \u6708"
  },
  transfer: {
    title: "{checked} / {total} \u9805\u76EE",
    empty: "\u30C7\u30FC\u30BF\u306A\u3057",
    placeholder: "\u691C\u7D22\u3059\u308B\u30AD\u30FC\u30EF\u30FC\u30C9\u3092\u5165\u529B\u3057\u3066\u304F\u3060\u3055\u3044"
  },
  timePicker: {
    dayjsLocale: "ja",
    now: "\u3053\u306E\u3068\u304D",
    confirm: "\u6C7A\u5B9A\u4E8B\u9805",
    anteMeridiem: "\u30E2\u30FC\u30CB\u30F3\u30B0",
    postMeridiem: "\u5348\u5F8C",
    placeholder: "\u6642\u9593\u3092\u9078\u629E\u3059\u308B"
  },
  dialog: {
    confirm: "\u78BA\u8A8D\u4E8B\u9805",
    cancel: "\u30AD\u30E3\u30F3\u30BB\u30EB\u306B\u3064\u3044\u3066"
  },
  drawer: {
    confirm: "\u78BA\u8A8D\u4E8B\u9805",
    cancel: "\u30AD\u30E3\u30F3\u30BB\u30EB\u306B\u3064\u3044\u3066"
  },
  popconfirm: {
    confirm: {
      content: "\u78BA\u8A8D\u4E8B\u9805"
    },
    cancel: {
      content: "\u30AD\u30E3\u30F3\u30BB\u30EB\u306B\u3064\u3044\u3066"
    }
  },
  table: {
    empty: "\u30C7\u30FC\u30BF\u306A\u3057",
    loadingText: "\u30ED\u30FC\u30C9\u4E2D\u3067\u3059\u3001\u304A\u5F85\u3061\u304F\u3060\u3055\u3044",
    loadingMoreText: "\u30AF\u30EA\u30C3\u30AF\u3067\u3055\u3089\u306B\u8AAD\u307F\u8FBC\u307F",
    filterInputPlaceholder: "\u5185\u5BB9\u3092\u5165\u529B\u3057\u3066\u304F\u3060\u3055\u3044\uFF08\u521D\u671F\u5024\u306A\u3057\uFF09",
    sortAscendingOperationText: "\u30AF\u30EA\u30C3\u30AF\u3067\u6607\u964D",
    sortCancelOperationText: "\u30AF\u30EA\u30C3\u30AF\u3067\u30BD\u30FC\u30C8\u89E3\u9664",
    sortDescendingOperationText: "\u964D\u9806\u3067\u30AF\u30EA\u30C3\u30AF",
    clearFilterResultButtonText: "\u30AF\u30EA\u30A2\u30D5\u30A3\u30EB\u30BF\u30FC",
    columnConfigButtonText: "\u30AB\u30E9\u30E0\u69CB\u6210",
    columnConfigTitleText: "\u30C6\u30FC\u30D6\u30EB\u30AB\u30E9\u30E0\u306E\u69CB\u6210",
    columnConfigDescriptionText: "\u8868\u306B\u8868\u793A\u3059\u308B\u30C7\u30FC\u30BF\u306E\u5217\u3092\u9078\u629E\u3057\u3066\u304F\u3060\u3055\u3044\u3002",
    confirmText: "\u78BA\u8A8D\u4E8B\u9805",
    cancelText: "\u30AD\u30E3\u30F3\u30BB\u30EB\u306B\u3064\u3044\u3066",
    resetText: "\u30EA\u30BB\u30C3\u30C8",
    selectAllText: "\u3059\u3079\u3066\u9078\u629E",
    searchResultText: "\u691C\u7D22\u201C{result}\u201D\uFF0C\u63A2\u3059 {count} \u8A18\u4E8B\u7D50\u679C"
  },
  select: {
    empty: "\u30C7\u30FC\u30BF\u306A\u3057",
    loadingText: "\u30ED\u30FC\u30C7\u30A3\u30F3\u30B0",
    placeholder: "\u9078\u629E\u3057\u3066\u304F\u3060\u3055\u3044"
  },
  tree: {
    empty: "\u30C7\u30FC\u30BF\u306A\u3057"
  },
  treeSelect: {
    empty: "\u30C7\u30FC\u30BF\u306A\u3057",
    loadingText: "\u30ED\u30FC\u30C7\u30A3\u30F3\u30B0",
    placeholder: "\u9078\u629E\u3057\u3066\u304F\u3060\u3055\u3044"
  },
  datePicker: {
    dayjsLocale: "ja",
    placeholder: {
      date: "\u65E5\u4ED8\u3092\u9078\u629E\u3057\u3066\u304F\u3060\u3055\u3044",
      month: "\u6708\u3092\u9078\u629E\u3057\u3066\u304F\u3060\u3055\u3044",
      year: "\u5E74\u5EA6\u3092\u9078\u629E\u3057\u3066\u304F\u3060\u3055\u3044",
      quarter: "\u56DB\u534A\u671F\u3092\u9078\u629E\u3057\u3066\u304F\u3060\u3055\u3044",
      week: "\u9031\u3092\u9078\u629E\u3057\u3066\u304F\u3060\u3055\u3044"
    },
    weekdays: ["\u6708", "\u706B", "\u6C34", "\u6728", "\u91D1", "\u571F", "\u65E5"],
    months: ["1 \u6708", "2 \u6708", "3 \u6708", "4 \u6708", "5 \u6708", "6 \u6708", "7 \u6708", "8 \u6708", "9 \u6708", "10 \u6708", "11 \u6708", "12 \u6708"],
    quarters: ["Q1", "Q2", "Q3", "Q4"],
    rangeSeparator: " - ",
    direction: "ltr",
    format: "YYYY-MM-DD",
    dayAriaLabel: "\u65E5",
    weekAbbreviation: "\u9031\u9593",
    yearAriaLabel: "\u5E74",
    monthAriaLabel: "\u6708",
    confirm: "\u6C7A\u5B9A\u4E8B\u9805",
    selectTime: "\u6642\u9593\u3092\u9078\u629E\u3059\u308B",
    selectDate: "\u65E5\u4ED8\u3092\u9078\u629E",
    nextYear: "\u6765\u5E74\u5EA6",
    preYear: "\u524D\u5E74\u5EA6",
    nextMonth: "\u6765\u6708",
    preMonth: "\u5148\u6708",
    preDecade: "\u904E\u53BB10\u5E74\u9593",
    nextDecade: "\u6B21\u306E10\u5E74",
    now: "\u96FB\u6D41"
  },
  upload: {
    sizeLimitMessage: "\u753B\u50CF\u30B5\u30A4\u30BA\u306F\u6700\u5927\u3067 {sizeLimit}",
    cancelUploadText: "\u30A2\u30C3\u30D7\u30ED\u30FC\u30C9\u3092\u30AD\u30E3\u30F3\u30BB\u30EB\u3059\u308B",
    triggerUploadText: {
      fileInput: "\u30D5\u30A1\u30A4\u30EB\u9078\u629E",
      image: "\u30AF\u30EA\u30C3\u30AF\u3067\u753B\u50CF\u3092\u30A2\u30C3\u30D7\u30ED\u30FC\u30C9",
      normal: "\u30AF\u30EA\u30C3\u30AF\u3067\u30A2\u30C3\u30D7\u30ED\u30FC\u30C9",
      reupload: "\u518D\u30A2\u30C3\u30D7\u30ED\u30FC\u30C9",
      continueUpload: "\u30A2\u30C3\u30D7\u30ED\u30FC\u30C9\u3092\u7D99\u7D9A\u3059\u308B",
      "delete": "\u524A\u9664",
      uploading: "\u30A2\u30C3\u30D7\u30ED\u30FC\u30C9\u4E2D"
    },
    dragger: {
      dragDropText: "\u30DE\u30A6\u30B9\u3092\u96E2\u3059",
      draggingText: "\u3053\u306E\u9818\u57DF\u306B\u30C9\u30E9\u30C3\u30B0\uFF06\u30C9\u30ED\u30C3\u30D7\u3059\u308B",
      clickAndDragText: "\u4E0A\u306E\u300C\u30D5\u30A1\u30A4\u30EB\u3092\u9078\u629E\u300D\u3092\u30AF\u30EA\u30C3\u30AF\u3059\u308B\u304B\u3001\u3053\u306E\u30A8\u30EA\u30A2\u306B\u30D5\u30A1\u30A4\u30EB\u3092\u30C9\u30E9\u30C3\u30B0\uFF06\u30C9\u30ED\u30C3\u30D7\u3057\u3066\u304F\u3060\u3055\u3044"
    },
    file: {
      fileNameText: "\u30D5\u30A1\u30A4\u30EB\u540D",
      fileSizeText: "\u30D5\u30A1\u30A4\u30EB\u30B5\u30A4\u30BA",
      fileStatusText: "\u72B6\u614B\u3067\u3059",
      fileOperationText: "\u64CD\u4F5C",
      fileOperationDateText: "\u30A2\u30C3\u30D7\u30ED\u30FC\u30C9\u65E5"
    },
    progress: {
      uploadingText: "\u30A2\u30C3\u30D7\u30ED\u30FC\u30C9\u4E2D",
      waitingText: "\u30A2\u30C3\u30D7\u30ED\u30FC\u30C9\u4E88\u5B9A",
      failText: "\u30A2\u30C3\u30D7\u30ED\u30FC\u30C9\u306B\u5931\u6557\u3057\u307E\u3057\u305F",
      successText: "\u30A2\u30C3\u30D7\u30ED\u30FC\u30C9\u6210\u529F"
    }
  },
  form: {
    errorMessage: {
      date: "\u6B63\u3057\u304F\u5165\u529B\u3057\u3066\u304F\u3060\u3055\u3044${name}",
      url: "\u6B63\u3057\u304F\u5165\u529B\u3057\u3066\u304F\u3060\u3055\u3044${name}",
      required: "${name}\u5FC5\u9808\u9805\u76EE",
      whitespace: "${name}\u3092\u7A7A\u306B\u3059\u308B\u3053\u3068\u306F\u3067\u304D\u307E\u305B\u3093",
      max: "${name}\u6587\u5B57\u6570\u5236\u9650 ${validate} \u6587\u5B57\uFF0C\u4E00\u4E2D\u4E8C\u6587",
      min: "${name}\u3092\u4E0B\u56DE\u308B\u6587\u5B57\u6570\u306F\u4F7F\u7528\u3067\u304D\u307E\u305B\u3093 ${validate} \u6587\u5B57\uFF0C\u4E00\u4E2D\u4E8C\u6587",
      len: "${name}\u6587\u5B57\u306E\u9577\u3055\u306F\u3001\u5FC5\u305A ${validate}",
      "enum": "${name}\u3067\u3057\u304B\u3042\u308A\u3048\u307E\u305B\u3093${validate}\u7B49",
      idcard: "\u6B63\u3057\u304F\u5165\u529B\u3057\u3066\u304F\u3060\u3055\u3044${name}",
      telnumber: "\u6B63\u3057\u304F\u5165\u529B\u3057\u3066\u304F\u3060\u3055\u3044${name}",
      pattern: "\u6B63\u3057\u304F\u5165\u529B\u3057\u3066\u304F\u3060\u3055\u3044${name}",
      validator: "${name}\u8981\u4EF6\u3092\u6E80\u305F\u3057\u3066\u3044\u306A\u3044",
      "boolean": "${name}\u30C7\u30FC\u30BF\u578B\u306F Boolean \u578B\u3067\u3042\u308B\u3053\u3068",
      number: "${name}\u30C7\u30B8\u30BF\u30EB\u3067\u3042\u308B\u3053\u3068"
    },
    colonText: ":"
  },
  input: {
    placeholder: "\u5165\u529B\u3057\u3066\u304F\u3060\u3055\u3044"
  },
  list: {
    loadingText: "\u30ED\u30FC\u30C9\u4E2D\u3067\u3059\u3001\u304A\u5F85\u3061\u304F\u3060\u3055\u3044",
    loadingMoreText: "\u30AF\u30EA\u30C3\u30AF\u3067\u3055\u3089\u306B\u8AAD\u307F\u8FBC\u307F"
  },
  alert: {
    expandText: "\u3082\u3063\u3068\u62E1\u5927\u3059\u308B",
    collapseText: "\u30B3\u30EC\u30AF\u30C8"
  },
  anchor: {
    copySuccessText: "\u30EA\u30F3\u30AF\u304C\u6B63\u5E38\u306B\u30B3\u30D4\u30FC\u3055\u308C\u307E\u3057\u305F",
    copyText: "\u30B3\u30D4\u30FC\u30EA\u30F3\u30AF"
  },
  colorPicker: {
    swatchColorTitle: "\u30B7\u30B9\u30C6\u30E0\u30D7\u30EA\u30BB\u30C3\u30C8\u30AB\u30E9\u30FC",
    recentColorTitle: "\u6700\u8FD1\u4F7F\u7528\u3057\u305F\u8272",
    clearConfirmText: "\u6700\u8FD1\u4F7F\u7528\u3057\u305F\u8272\u3092\u30AF\u30EA\u30A2\u306B\u3059\u308B\u306E\u306F\u78BA\u5B9F\u3067\u3059\u304B\uFF1F",
    singleColor: "\u5358\u8272",
    gradientColor: "\u30B0\u30E9\u30C7"
  },
  guide: {
    finishButtonProps: {
      content: "\u7D42\u4E86",
      theme: "primary"
    },
    nextButtonProps: {
      content: "\u6B21\u306E\u30B9\u30C6\u30C3\u30D7",
      theme: "primary"
    },
    skipButtonProps: {
      content: "\u30B9\u30AD\u30C3\u30D7",
      theme: "default"
    },
    prevButtonProps: {
      content: "\u524D\u3078",
      theme: "default"
    }
  },
  image: {
    errorText: "\u753B\u50CF\u3092\u8868\u793A\u3067\u304D\u307E\u305B\u3093",
    loadingText: "\u753B\u50CF\u306E\u8AAD\u307F\u8FBC\u307F"
  },
  imageViewer: {
    errorText: "\u753B\u50CF\u306E\u8AAD\u307F\u8FBC\u307F\u306B\u5931\u6557\u3057\u307E\u3057\u305F\u3002\u518D\u8AAD\u307F\u8FBC\u307F\u3057\u3066\u307F\u3066\u304F\u3060\u3055\u3044",
    mirrorTipText: "\u93E1\u50CF",
    rotateTipText: "\u56DE\u8EE2\u3059\u308B",
    originalSizeTipText: "\u30AA\u30EA\u30B8\u30CA\u30EB\u30B5\u30A4\u30BA"
  },
  typography: {
    expandText: "\u3082\u3063\u3068\u62E1\u5927\u3059\u308B",
    collapseText: "\u7573\u3080",
    copiedText: "\u30B3\u30D4\u30FC\u6210\u529F"
  },
  rate: {
    rateText: ["\u3072\u3069\u3044", "\u304C\u3063\u304B\u308A", "\u666E\u901A", "\u6E80\u8DB3", "\u9A5A\u304D"]
  },
  empty: {
    titleText: {
      maintenance: "\u5EFA\u8A2D\u4E2D",
      success: "\u6210\u529F",
      fail: "\u5931\u6557",
      empty: "\u30C7\u30FC\u30BF\u306A\u3057",
      networkError: "\u30CD\u30C3\u30C8\u30EF\u30FC\u30AF\u30A8\u30E9\u30FC"
    }
  },
  descriptions: {
    colonText: ":"
  },
  chat: {
    placeholder: "\u30E1\u30C3\u30BB\u30FC\u30B8\u3092\u5165\u529B\u3057\u3066\u304F\u3060\u3055\u3044...",
    stopBtnText: "\u505C\u6B62",
    refreshTipText: "\u518D\u751F\u6210",
    copyTipText: "\u30B3\u30D4\u30FC",
    likeTipText: "\u3044\u3044\u306D",
    dislikeTipText: "\u4F4E\u8A55\u4FA1",
    copyCodeBtnText: "\u30B3\u30FC\u30C9\u3092\u30B3\u30D4\u30FC",
    copyCodeSuccessText: "\u30B3\u30D4\u30FC\u6E08\u307F",
    clearHistoryBtnText: "\u5C65\u6B74\u3092\u30AF\u30EA\u30A2",
    copyTextSuccess: "\u30AF\u30EA\u30C3\u30D7\u30DC\u30FC\u30C9\u306B\u30B3\u30D4\u30FC\u3057\u307E\u3057\u305F",
    copyTextFail: "\u30AF\u30EA\u30C3\u30D7\u30DC\u30FC\u30C9\u3078\u306E\u30B3\u30D4\u30FC\u306B\u5931\u6557\u3057\u307E\u3057\u305F",
    confirmClearHistory: "\u3059\u3079\u3066\u306E\u30E1\u30C3\u30BB\u30FC\u30B8\u3092\u30AF\u30EA\u30A2\u3057\u3066\u3082\u3088\u308D\u3057\u3044\u3067\u3059\u304B\uFF1F",
    loadingText: "\u8003\u3048\u4E2D...",
    loadingEndText: "\u6DF1\u304F\u8003\u3048\u307E\u3057\u305F",
    uploadImageText: "\u753B\u50CF\u3092\u30A2\u30C3\u30D7\u30ED\u30FC\u30C9",
    uploadAttachmentText: "\u6DFB\u4ED8\u30D5\u30A1\u30A4\u30EB\u3092\u30A2\u30C3\u30D7\u30ED\u30FC\u30C9"
  },
  qrcode: {
    expiredText: "\u671F\u9650\u5207\u308C",
    refreshText: "\u30EA\u30D5\u30EC\u30C3\u30B7\u30E5",
    scannedText: "\u30B9\u30AD\u30E3\u30F3\u3055\u308C\u305F"
  }
};

exports["default"] = jaJP;
//# sourceMappingURL=ja_JP.js.map
