/**
 * tdesign v1.13.1
 * (c) 2025 tdesign
 * @license MIT
 */

'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var defineProperty = require('../_chunks/dep-7a6528ec.js');
var React = require('react');
var classNames = require('classnames');
var hooks_useConfig = require('../hooks/useConfig.js');
var _util_forwardRefWithStatics = require('../_util/forwardRefWithStatics.js');
var menu_MenuContext = require('./MenuContext.js');
var menu__util_constant = require('./_util/constant.js');
var menu_hooks_useMenuContext = require('./hooks/useMenuContext.js');
var menu_defaultProps = require('./defaultProps.js');
var menu_HeadMenu = require('./HeadMenu.js');
var menu_SubMenu = require('./SubMenu.js');
var menu_MenuItem = require('./MenuItem.js');
var menu_MenuGroup = require('./MenuGroup.js');
var hooks_useDefaultProps = require('../hooks/useDefaultProps.js');
require('../_chunks/dep-c83f28a0.js');
require('../config-provider/ConfigContext.js');
require('../_chunks/dep-1debbc3e.js');
require('../_chunks/dep-b4e78a42.js');
require('dayjs');
require('../_chunks/dep-fdd584c5.js');
require('../_chunks/dep-84fd1465.js');
require('../_chunks/dep-023db433.js');
require('../_chunks/dep-912bd8a2.js');
require('../_chunks/dep-0fccdcfb.js');
require('../_chunks/dep-78e8fc97.js');
require('../_chunks/dep-77879fb6.js');
require('../_chunks/dep-356859aa.js');
require('../_chunks/dep-e2240b05.js');
require('../_chunks/dep-837f0312.js');
require('../_chunks/dep-413bc6a7.js');
require('../_chunks/dep-84d18206.js');
require('../_chunks/dep-5e1fc2cd.js');
require('../_chunks/dep-0be4d457.js');
require('../_chunks/dep-6058edb6.js');
require('../_chunks/dep-cfe601e8.js');
require('../_chunks/dep-6c342676.js');
require('../_chunks/dep-8bd04901.js');
require('../_chunks/dep-2f3e85f6.js');
require('../_chunks/dep-3cfcca89.js');
require('../_chunks/dep-64afded1.js');
require('../_chunks/dep-a1d853fb.js');
require('hoist-non-react-statics');
require('../_util/noop.js');
require('../_chunks/dep-3012da29.js');
require('../_chunks/dep-7e3b8125.js');
require('./_util/getMenuTree.js');
require('../_chunks/dep-210ce7c8.js');
require('../_chunks/dep-560c14c5.js');
require('../_chunks/dep-4b35efe1.js');
require('../_chunks/dep-e358a1dc.js');
require('../tabs/index.js');
require('../tabs/Tabs.js');
require('../tabs/TabNav.js');
require('tdesign-icons-react');
require('../tabs/useTabClass.js');
require('../tabs/TabNavItem.js');
require('../hooks/useRipple.js');
require('../_chunks/dep-8593a497.js');
require('../hooks/useAnimation.js');
require('../_chunks/dep-68db2ca6.js');
require('../_chunks/dep-6e448b65.js');
require('../hooks/useDomRefCallback.js');
require('../hooks/useGlobalIcon.js');
require('../tabs/TabBar.js');
require('../hooks/useMutationObserver.js');
require('../hooks/useLatest.js');
require('../_chunks/dep-c73e0aa5.js');
require('../_chunks/dep-becc25b2.js');
require('../_chunks/dep-ba79870d.js');
require('../_chunks/dep-680d1e3e.js');
require('../_chunks/dep-a3962a45.js');
require('../_chunks/dep-b6bde0bc.js');
require('../_chunks/dep-f90d944e.js');
require('../_chunks/dep-46616204.js');
require('../_chunks/dep-7bb447f9.js');
require('../_chunks/dep-5941343f.js');
require('../_chunks/dep-665eea2b.js');
require('../hooks/useResizeObserver.js');
require('../hooks/useLayoutEffect.js');
require('../_util/parseTNode.js');
require('../_chunks/dep-cc4e3925.js');
require('../_chunks/dep-f4d31431.js');
require('../_chunks/dep-ed0d1cf9.js');
require('../_chunks/dep-cc2fe55a.js');
require('../_chunks/dep-8529ce07.js');
require('../_chunks/dep-be9040ff.js');
require('../_chunks/dep-ba207e81.js');
require('../_chunks/dep-c29b655c.js');
require('../_chunks/dep-d843946a.js');
require('../tabs/TabPanel.js');
require('../tabs/defaultProps.js');
require('../hooks/useDragSorter.js');
require('../hooks/useEventCallback.js');
require('../hooks/useControlled.js');
require('../_chunks/dep-00e10ad8.js');
require('../_chunks/dep-5d5d7b13.js');
require('./_util/checkSubMenuActive.js');
require('./_util/checkMenuType.js');
require('./_util/type.js');
require('./_util/checkSubMenuChildrenActive.js');
require('react-transition-group');
require('./_util/getSubMenuChildStyle.js');
require('../common/FakeArrow.js');
require('./_util/cacularPaddingLeft.js');
require('../popup/index.js');
require('../popup/Popup.js');
require('../_util/ref.js');
require('react-is');
require('../_util/isFragment.js');
require('../common/Portal.js');
require('react-dom');
require('../hooks/useAttach.js');
require('../hooks/usePopper.js');
require('@popperjs/core');
require('react-fast-compare');
require('../hooks/useWindowSize.js');
require('../popup/defaultProps.js');
require('../popup/hooks/useTrigger.js');
require('../_util/composeRefs.js');
require('../_util/listener.js');
require('../popup/utils/transition.js');
require('../popup/PopupPlugin.js');
require('../_chunks/dep-608840a8.js');
require('../_util/react-render.js');
require('../common/PluginContainer.js');
require('../config-provider/ConfigProvider.js');
require('../_chunks/dep-34def105.js');
require('../tooltip/index.js');
require('../tooltip/Tooltip.js');
require('../tooltip/defaultProps.js');
require('../tooltip/TooltipLite.js');
require('../hooks/useSwitch.js');
require('../hooks/usePersistFn.js');
require('../_chunks/dep-8c89cfa8.js');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

var React__default = /*#__PURE__*/_interopDefaultLegacy(React);
var classNames__default = /*#__PURE__*/_interopDefaultLegacy(classNames);

function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { defineProperty._defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
var Menu = _util_forwardRefWithStatics["default"](function (originalProps, ref) {
  var props = hooks_useDefaultProps["default"](originalProps, menu_defaultProps.menuDefaultProps);
  var className = props.className,
    _props$width = props.width,
    width = _props$width === void 0 ? menu__util_constant.DEFAULT_MENU_WIDTH : _props$width,
    children = props.children,
    theme = props.theme,
    logo = props.logo,
    operations = props.operations,
    style = props.style;
  var _useConfig = hooks_useConfig["default"](),
    classPrefix = _useConfig.classPrefix;
  var _useMenuContext = menu_hooks_useMenuContext["default"](_objectSpread(_objectSpread({}, props), {}, {
      children: children,
      mode: "accordion"
    })),
    value = _useMenuContext.value;
  var menuWidthArr = Array.isArray(width) ? width : [width, menu__util_constant.DEFAULT_MENU_WIDTH[1]];
  var collapsed = value.collapsed;
  return /* @__PURE__ */React__default["default"].createElement(menu_MenuContext.MenuContext.Provider, {
    value: value
  }, /* @__PURE__ */React__default["default"].createElement("div", {
    ref: ref,
    className: classNames__default["default"]("".concat(classPrefix, "-default-menu"), className, defineProperty._defineProperty(defineProperty._defineProperty({}, "".concat(classPrefix, "-is-collapsed"), collapsed), "".concat(classPrefix, "-menu--dark"), theme === "dark")),
    style: _objectSpread({
      width: collapsed ? menuWidthArr[1] : menuWidthArr[0]
    }, style)
  }, /* @__PURE__ */React__default["default"].createElement("div", {
    className: "".concat(classPrefix, "-default-menu__inner")
  }, logo && /* @__PURE__ */React__default["default"].createElement("div", {
    className: "".concat(classPrefix, "-menu__logo")
  }, logo), /* @__PURE__ */React__default["default"].createElement("ul", {
    className: classNames__default["default"]("".concat(classPrefix, "-menu"), "".concat(classPrefix, "-menu--scroll"))
  }, children), operations && /* @__PURE__ */React__default["default"].createElement("div", {
    className: "".concat(classPrefix, "-menu__operations")
  }, operations))));
}, {
  HeadMenu: menu_HeadMenu["default"],
  SubMenu: menu_SubMenu["default"],
  MenuItem: menu_MenuItem["default"],
  MenuGroup: menu_MenuGroup["default"]
});
Menu.displayName = "Menu";

exports["default"] = Menu;
//# sourceMappingURL=Menu.js.map
