/**
 * tdesign v1.13.1
 * (c) 2025 tdesign
 * @license MIT
 */

'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var defineProperty = require('../_chunks/dep-7a6528ec.js');
var slicedToArray = require('../_chunks/dep-3012da29.js');
var objectWithoutProperties = require('../_chunks/dep-e358a1dc.js');
var React = require('react');
var classNames = require('classnames');
var reactTransitionGroup = require('react-transition-group');
var hooks_useConfig = require('../hooks/useConfig.js');
var menu_MenuContext = require('./MenuContext.js');
var hooks_useDomRefCallback = require('../hooks/useDomRefCallback.js');
var hooks_useRipple = require('../hooks/useRipple.js');
var menu__util_getSubMenuChildStyle = require('./_util/getSubMenuChildStyle.js');
var menu__util_checkSubMenuChildrenActive = require('./_util/checkSubMenuChildrenActive.js');
var common_FakeArrow = require('../common/FakeArrow.js');
var menu__util_checkMenuType = require('./_util/checkMenuType.js');
var menu__util_cacularPaddingLeft = require('./_util/cacularPaddingLeft.js');
var popup_index = require('../popup/index.js');
var _util_parseTNode = require('../_util/parseTNode.js');
require('../_chunks/dep-c83f28a0.js');
require('../_chunks/dep-7e3b8125.js');
require('../config-provider/ConfigContext.js');
require('../_chunks/dep-1debbc3e.js');
require('../_chunks/dep-b4e78a42.js');
require('dayjs');
require('../_chunks/dep-fdd584c5.js');
require('../_chunks/dep-84fd1465.js');
require('../_chunks/dep-023db433.js');
require('../_chunks/dep-912bd8a2.js');
require('../_chunks/dep-0fccdcfb.js');
require('../_chunks/dep-78e8fc97.js');
require('../_chunks/dep-77879fb6.js');
require('../_chunks/dep-356859aa.js');
require('../_chunks/dep-e2240b05.js');
require('../_chunks/dep-837f0312.js');
require('../_chunks/dep-413bc6a7.js');
require('../_chunks/dep-84d18206.js');
require('../_chunks/dep-5e1fc2cd.js');
require('../_chunks/dep-0be4d457.js');
require('../_chunks/dep-6058edb6.js');
require('../_chunks/dep-cfe601e8.js');
require('../_chunks/dep-6c342676.js');
require('../_chunks/dep-8bd04901.js');
require('../_chunks/dep-2f3e85f6.js');
require('../_chunks/dep-3cfcca89.js');
require('../_chunks/dep-64afded1.js');
require('../_chunks/dep-a1d853fb.js');
require('../_util/noop.js');
require('../_chunks/dep-8593a497.js');
require('../hooks/useAnimation.js');
require('../_chunks/dep-68db2ca6.js');
require('../_chunks/dep-6e448b65.js');
require('./_util/type.js');
require('../popup/Popup.js');
require('../_util/ref.js');
require('react-is');
require('../_util/isFragment.js');
require('../common/Portal.js');
require('react-dom');
require('../hooks/useLayoutEffect.js');
require('../hooks/useAttach.js');
require('../hooks/useControlled.js');
require('../_chunks/dep-00e10ad8.js');
require('../_chunks/dep-5d5d7b13.js');
require('../_chunks/dep-ba207e81.js');
require('../_chunks/dep-ed0d1cf9.js');
require('../_chunks/dep-665eea2b.js');
require('../hooks/useDefaultProps.js');
require('../hooks/useMutationObserver.js');
require('../hooks/useLatest.js');
require('../_chunks/dep-c73e0aa5.js');
require('../_chunks/dep-becc25b2.js');
require('../_chunks/dep-ba79870d.js');
require('../_chunks/dep-680d1e3e.js');
require('../_chunks/dep-a3962a45.js');
require('../_chunks/dep-b6bde0bc.js');
require('../_chunks/dep-f90d944e.js');
require('../_chunks/dep-46616204.js');
require('../_chunks/dep-7bb447f9.js');
require('../_chunks/dep-5941343f.js');
require('../hooks/usePopper.js');
require('../_chunks/dep-210ce7c8.js');
require('@popperjs/core');
require('react-fast-compare');
require('../hooks/useWindowSize.js');
require('../popup/defaultProps.js');
require('../popup/hooks/useTrigger.js');
require('../_util/composeRefs.js');
require('../_util/listener.js');
require('../popup/utils/transition.js');
require('../popup/PopupPlugin.js');
require('../_chunks/dep-608840a8.js');
require('../_util/react-render.js');
require('../common/PluginContainer.js');
require('../config-provider/ConfigProvider.js');
require('../_chunks/dep-34def105.js');
require('../_chunks/dep-cc2fe55a.js');
require('../_chunks/dep-cc4e3925.js');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

var React__default = /*#__PURE__*/_interopDefaultLegacy(React);
var classNames__default = /*#__PURE__*/_interopDefaultLegacy(classNames);

var _excluded = ["overlayClassName", "overlayInnerClassName"],
  _excluded2 = ["overlayClassName", "overlayInnerClassName"];
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { defineProperty._defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
var SubAccordion = function SubAccordion(props) {
  var content = props.content,
    _props$children = props.children,
    children = _props$children === void 0 ? content : _props$children,
    disabled = props.disabled,
    icon = props.icon,
    title = props.title,
    value = props.value,
    className = props.className,
    style = props.style,
    _props$level = props.level,
    level = _props$level === void 0 ? 1 : _props$level,
    popupProps = props.popupProps;
  var _ref = popupProps || {},
    overlayClassName = _ref.overlayClassName,
    overlayInnerClassName = _ref.overlayInnerClassName,
    restPopupProps = objectWithoutProperties._objectWithoutProperties(_ref, _excluded);
  var _useConfig = hooks_useConfig["default"](),
    classPrefix = _useConfig.classPrefix;
  var _useState = React.useState(false),
    _useState2 = slicedToArray._slicedToArray(_useState, 2),
    open = _useState2[0],
    setOpen = _useState2[1];
  var _useContext = React.useContext(menu_MenuContext.MenuContext),
    _useContext$expanded = _useContext.expanded,
    expanded = _useContext$expanded === void 0 ? [] : _useContext$expanded,
    onExpand = _useContext.onExpand,
    active = _useContext.active,
    expandType = _useContext.expandType,
    _useContext$theme = _useContext.theme,
    theme = _useContext$theme === void 0 ? "light" : _useContext$theme;
  var isPopUp = expandType === "popup";
  var isExpand = expanded.includes(value) && !disabled && !isPopUp;
  var handleClick = function handleClick(e) {
    e.stopPropagation();
    onExpand(value, expanded);
    setOpen(false);
  };
  var handleVisibleChange = function handleVisibleChange(visible) {
    setOpen(visible);
  };
  var popupChildren = React__default["default"].Children.map(children, function (child) {
    var _child$props;
    return /*#__PURE__*/React__default["default"].cloneElement(child, {
      className: classNames__default["default"]("".concat(classPrefix, "-menu__item--plain"), "".concat(classPrefix, "-submenu__item"), "".concat(classPrefix, "-submenu__item--icon"), (_child$props = child.props) === null || _child$props === void 0 ? void 0 : _child$props.className)
    });
  });
  var childStyle = {
    maxHeight: isExpand || open && isPopUp ? menu__util_getSubMenuChildStyle.getSubMenuMaxHeight(children) : 0
  };
  var isOpen = React.useMemo(function () {
    if (disabled) return false;
    if (isPopUp) return open;
    return isExpand;
  }, [disabled, isPopUp, open, isExpand]);
  var menuPaddingLeft = menu__util_cacularPaddingLeft.cacularPaddingLeft(level - 1);
  var fakeArrowStyle = isPopUp && level > 1 ? {
    transform: "rotate(-90deg)"
  } : {};
  var contentRef = React.useRef(null);
  var transitionCallbacks = {
    onEnter: function onEnter() {
      contentRef.current.style.height = "".concat(contentRef === null || contentRef === void 0 ? void 0 : contentRef.current.scrollHeight, "px");
    },
    onEntered: function onEntered() {
      contentRef.current.style.height = "auto";
    },
    onExit: function onExit() {
      contentRef.current.style.height = "".concat(contentRef === null || contentRef === void 0 ? void 0 : contentRef.current.scrollHeight, "px");
    },
    onExiting: function onExiting() {
      contentRef.current.style.height = "0px";
    }
  };
  var pupContent = /* @__PURE__ */React__default["default"].createElement("ul", {
    className: classNames__default["default"]("".concat(classPrefix, "-menu__popup-wrapper"), defineProperty._defineProperty({}, "".concat(classPrefix, "-is-opened"), isOpen)),
    key: "popup",
    style: childStyle
  }, popupChildren);
  var submenu = /* @__PURE__ */React__default["default"].createElement("li", {
    className: classNames__default["default"]("".concat(classPrefix, "-submenu"), className, defineProperty._defineProperty(defineProperty._defineProperty({}, "".concat(classPrefix, "-is-disabled"), disabled), "".concat(classPrefix, "-is-opened"), isOpen)),
    style: style
  }, /* @__PURE__ */React__default["default"].createElement("div", {
    className: classNames__default["default"]("".concat(classPrefix, "-menu__item"), defineProperty._defineProperty(defineProperty._defineProperty({}, "".concat(classPrefix, "-is-opened"), isOpen), "".concat(classPrefix, "-is-active"), menu__util_checkSubMenuChildrenActive["default"](children, active))),
    onClick: handleClick
  }, _util_parseTNode["default"](icon), /* @__PURE__ */React__default["default"].createElement("span", {
    className: "".concat(classPrefix, "-menu__content")
  }, title), /* @__PURE__ */React__default["default"].createElement(common_FakeArrow["default"], {
    style: fakeArrowStyle,
    isActive: isOpen,
    disabled: disabled
  })), !isPopUp && /* @__PURE__ */React__default["default"].createElement(reactTransitionGroup.CSSTransition, _objectSpread({
    "in": isOpen,
    appear: true,
    timeout: 300,
    nodeRef: contentRef
  }, transitionCallbacks), /* @__PURE__ */React__default["default"].createElement("ul", {
    key: "normal",
    style: _objectSpread(_objectSpread({}, childStyle), {}, {
      "--padding-left": "".concat(menuPaddingLeft, "px"),
      overflow: "hidden"
    }),
    className: classNames__default["default"]("".concat(classPrefix, "-menu__sub"), "".concat(classPrefix, "-slide-down-enter-active")),
    ref: contentRef
  }, popupChildren)));
  if (isPopUp) {
    return /* @__PURE__ */React__default["default"].createElement(popup_index.Popup, _objectSpread(_objectSpread({}, restPopupProps), {}, {
      overlayInnerClassName: ["".concat(classPrefix, "-menu__popup"), "".concat(classPrefix, "-is-vertical"), defineProperty._defineProperty({}, "".concat(classPrefix, "-is-opened"), isOpen), overlayInnerClassName],
      overlayClassName: ["".concat(classPrefix, "-menu--").concat(theme), defineProperty._defineProperty({}, "".concat(classPrefix, "-menu-is-nested"), level > 1), overlayClassName],
      visible: open,
      placement: "right-top",
      content: pupContent,
      onVisibleChange: handleVisibleChange
    }), submenu);
  }
  return submenu;
};
var SubTitleMenu = function SubTitleMenu(props) {
  var className = props.className,
    style = props.style,
    children = props.children,
    disabled = props.disabled,
    icon = props.icon,
    title = props.title,
    value = props.value,
    _props$level2 = props.level,
    level = _props$level2 === void 0 ? 1 : _props$level2,
    popupProps = props.popupProps;
  var _ref4 = popupProps || {},
    overlayClassName = _ref4.overlayClassName,
    overlayInnerClassName = _ref4.overlayInnerClassName,
    restPopupProps = objectWithoutProperties._objectWithoutProperties(_ref4, _excluded2);
  var _useContext2 = React.useContext(menu_MenuContext.MenuContext),
    active = _useContext2.active,
    onChange = _useContext2.onChange,
    expandType = _useContext2.expandType,
    _useContext2$theme = _useContext2.theme,
    theme = _useContext2$theme === void 0 ? "light" : _useContext2$theme;
  var _useConfig2 = hooks_useConfig["default"](),
    classPrefix = _useConfig2.classPrefix;
  var _useState3 = React.useState(false),
    _useState4 = slicedToArray._slicedToArray(_useState3, 2),
    open = _useState4[0],
    setOpen = _useState4[1];
  var handleClick = function handleClick() {
    return onChange(value);
  };
  var handleVisibleChange = function handleVisibleChange(visible) {
    setOpen(visible);
  };
  var _useDomRefCallback = hooks_useDomRefCallback["default"](),
    _useDomRefCallback2 = slicedToArray._slicedToArray(_useDomRefCallback, 2),
    subMenuDom = _useDomRefCallback2[0],
    setRefCurrent = _useDomRefCallback2[1];
  hooks_useRipple["default"](subMenuDom);
  var isPopUp = expandType === "popup";
  var isActive = menu__util_checkSubMenuChildrenActive["default"](children, active) || active === value;
  var isOpen = React.useMemo(function () {
    if (disabled) return false;
    if (isPopUp) return open;
    return false;
  }, [disabled, isPopUp, open]);
  var fakeArrowStyle = level > 1 ? {
    transform: "rotate(-90deg)"
  } : {};
  var pupContent = /* @__PURE__ */React__default["default"].createElement("ul", {
    className: classNames__default["default"]("".concat(classPrefix, "-menu__popup-wrapper"), defineProperty._defineProperty({}, "".concat(classPrefix, "-is-opened"), isOpen))
  }, children);
  var placement = "right-top";
  if (level < 2) {
    placement = "bottom-left";
  }
  var submenu = /* @__PURE__ */React__default["default"].createElement("li", {
    className: classNames__default["default"]("".concat(classPrefix, "-submenu"), className, defineProperty._defineProperty({}, "".concat(classPrefix, "-is-opened"), open))
  }, /* @__PURE__ */React__default["default"].createElement("div", {
    ref: setRefCurrent,
    className: classNames__default["default"]("".concat(classPrefix, "-menu__item"), defineProperty._defineProperty(defineProperty._defineProperty({}, "".concat(classPrefix, "-is-active"), isActive), "".concat(classPrefix, "-is-opened"), open)),
    onClick: handleClick,
    style: style
  }, _util_parseTNode["default"](icon), /* @__PURE__ */React__default["default"].createElement("span", null, title), isPopUp && /* @__PURE__ */React__default["default"].createElement(common_FakeArrow["default"], {
    style: fakeArrowStyle,
    isActive: level === 1 && open
  })));
  if (isPopUp) {
    return /* @__PURE__ */React__default["default"].createElement(popup_index.Popup, _objectSpread(_objectSpread({}, restPopupProps), {}, {
      overlayInnerClassName: ["".concat(classPrefix, "-menu__popup"), "".concat(classPrefix, "-is-vertical"), defineProperty._defineProperty({}, "".concat(classPrefix, "-is-opened"), isOpen), overlayInnerClassName],
      overlayClassName: ["".concat(classPrefix, "-menu--").concat(theme), "".concat(classPrefix, "-is-head-menu"), defineProperty._defineProperty({}, "".concat(classPrefix, "-menu-is-nested"), level > 1), overlayClassName],
      visible: open,
      placement: placement,
      content: pupContent,
      onVisibleChange: handleVisibleChange
    }), submenu);
  }
  return submenu;
};
var SubMenu = function SubMenu(props) {
  var _useContext3 = React.useContext(menu_MenuContext.MenuContext),
    mode = _useContext3.mode;
  var children = props.children,
    _props$level3 = props.level,
    level = _props$level3 === void 0 ? 1 : _props$level3;
  var _changeItemLevel = function changeItemLevel(item) {
    if (menu__util_checkMenuType.checkIsSubMenu(item)) {
      return /*#__PURE__*/React__default["default"].cloneElement(item, {
        level: level + 1
      });
    }
    if (menu__util_checkMenuType.checkIsMenuGroup(item)) {
      var groupChildren = React__default["default"].Children.map(item.props.children, function (item2) {
        return _changeItemLevel(item2);
      });
      return /*#__PURE__*/React__default["default"].cloneElement(item, {
        level: level + 1
      }, groupChildren);
    }
    return item;
  };
  var childElement = React__default["default"].Children.map(children, function (item) {
    return _changeItemLevel(item);
  });
  if (mode === "accordion") return /* @__PURE__ */React__default["default"].createElement(SubAccordion, _objectSpread({}, props), childElement);
  if (mode === "title") return /* @__PURE__ */React__default["default"].createElement(SubTitleMenu, _objectSpread({}, props), childElement);
  return null;
};
SubMenu.displayName = "SubMenu";

exports["default"] = SubMenu;
//# sourceMappingURL=SubMenu.js.map
