/**
 * tdesign v1.13.1
 * (c) 2025 tdesign
 * @license MIT
 */

'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var toConsumableArray = require('../_chunks/dep-210ce7c8.js');
var _typeof = require('../_chunks/dep-c83f28a0.js');
var notification_NotificationList = require('../_chunks/dep-d85a29ac.js');
var notification_config = require('./config.js');
require('../_chunks/dep-7e3b8125.js');
require('../_chunks/dep-7a6528ec.js');
require('react');
require('classnames');
require('tdesign-icons-react');
require('../_chunks/dep-3012da29.js');
require('../_util/react-render.js');
require('../_chunks/dep-608840a8.js');
require('react-dom');
require('../hooks/useConfig.js');
require('../config-provider/ConfigContext.js');
require('../_chunks/dep-1debbc3e.js');
require('../_chunks/dep-b4e78a42.js');
require('dayjs');
require('../_chunks/dep-fdd584c5.js');
require('../_chunks/dep-84fd1465.js');
require('../_chunks/dep-023db433.js');
require('../_chunks/dep-912bd8a2.js');
require('../_chunks/dep-0fccdcfb.js');
require('../_chunks/dep-78e8fc97.js');
require('../_chunks/dep-77879fb6.js');
require('../_chunks/dep-356859aa.js');
require('../_chunks/dep-e2240b05.js');
require('../_chunks/dep-837f0312.js');
require('../_chunks/dep-413bc6a7.js');
require('../_chunks/dep-84d18206.js');
require('../_chunks/dep-5e1fc2cd.js');
require('../_chunks/dep-0be4d457.js');
require('../_chunks/dep-6058edb6.js');
require('../_chunks/dep-cfe601e8.js');
require('../_chunks/dep-6c342676.js');
require('../_chunks/dep-8bd04901.js');
require('../_chunks/dep-2f3e85f6.js');
require('../_chunks/dep-3cfcca89.js');
require('../_chunks/dep-64afded1.js');
require('../_chunks/dep-a1d853fb.js');
require('../_util/noop.js');
require('../_util/parseTNode.js');
require('../_chunks/dep-cc4e3925.js');
require('../hooks/useGlobalIcon.js');
require('./defaultProps.js');
require('../hooks/useDefaultProps.js');
require('../config-provider/ConfigProvider.js');
require('../_chunks/dep-34def105.js');
require('../_chunks/dep-cc2fe55a.js');
require('../_chunks/dep-680d1e3e.js');
require('../_chunks/dep-a3962a45.js');
require('../_chunks/dep-b6bde0bc.js');
require('../_chunks/dep-f90d944e.js');
require('../_chunks/dep-46616204.js');
require('../common/PluginContainer.js');

var renderNotification = function renderNotification(theme, options) {
  if (_typeof._typeof(options) !== "object") return;
  var configs = notification_config.getConfig(options);
  var placement = configs.placement;
  var attach = function () {
    var containerId = "tdesign-notification-".concat(placement);
    var container = document.querySelector("#".concat(containerId));
    if (container && container instanceof HTMLElement) {
      return container;
    }
    var element = document.createElement("div");
    element.setAttribute("id", containerId);
    if (options.attach && typeof options.attach === "string") {
      var container2 = document.querySelector(options.attach);
      if (container2 instanceof HTMLElement) return container2.appendChild(element);
    }
    if (options.attach instanceof HTMLElement) return options.attach.appendChild(element);
    document.body.appendChild(element);
    return element;
  }();
  return notification_NotificationList.fetchListInstance(placement, attach, configs.zIndex).then(function (listInstance) {
    return listInstance.push(theme, configs);
  });
};
var NotificationPlugin = function NotificationPlugin(theme, props) {
  return renderNotification(theme, props);
};
NotificationPlugin.info = function (options) {
  return renderNotification("info", options);
};
NotificationPlugin.success = function (options) {
  return renderNotification("success", options);
};
NotificationPlugin.warning = function (options) {
  return renderNotification("warning", options);
};
NotificationPlugin.error = function (options) {
  return renderNotification("error", options);
};
NotificationPlugin.close = function (promise) {
  return promise.then(function (instance) {
    return instance.close();
  });
};
NotificationPlugin.closeAll = function () {
  return toConsumableArray._toConsumableArray(notification_NotificationList.listMap.values()).forEach(function (list) {
    return list.removeAll();
  });
};
NotificationPlugin.config = function (options) {
  return notification_config.setGlobalConfig(options);
};

exports.NotificationPlugin = NotificationPlugin;
//# sourceMappingURL=NotificationPlugin.js.map
