/**
 * tdesign v1.13.1
 * (c) 2025 tdesign
 * @license MIT
 */

'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var React = require('react');
var tdesignIconsReact = require('tdesign-icons-react');
var loading_index = require('../loading/index.js');
require('../loading/Loading.js');
require('../_chunks/dep-7a6528ec.js');
require('../_chunks/dep-c83f28a0.js');
require('../_chunks/dep-3012da29.js');
require('../_chunks/dep-7e3b8125.js');
require('classnames');
require('../_chunks/dep-68db2ca6.js');
require('../_chunks/dep-6e448b65.js');
require('../_chunks/dep-912bd8a2.js');
require('../_chunks/dep-78e8fc97.js');
require('../_chunks/dep-0fccdcfb.js');
require('../hooks/useConfig.js');
require('../config-provider/ConfigContext.js');
require('../_chunks/dep-1debbc3e.js');
require('../_chunks/dep-b4e78a42.js');
require('dayjs');
require('../_chunks/dep-fdd584c5.js');
require('../_chunks/dep-84fd1465.js');
require('../_chunks/dep-023db433.js');
require('../_chunks/dep-77879fb6.js');
require('../_chunks/dep-356859aa.js');
require('../_chunks/dep-e2240b05.js');
require('../_chunks/dep-837f0312.js');
require('../_chunks/dep-413bc6a7.js');
require('../_chunks/dep-84d18206.js');
require('../_chunks/dep-5e1fc2cd.js');
require('../_chunks/dep-0be4d457.js');
require('../_chunks/dep-6058edb6.js');
require('../_chunks/dep-cfe601e8.js');
require('../_chunks/dep-6c342676.js');
require('../_chunks/dep-8bd04901.js');
require('../_chunks/dep-2f3e85f6.js');
require('../_chunks/dep-3cfcca89.js');
require('../_chunks/dep-64afded1.js');
require('../_chunks/dep-a1d853fb.js');
require('../common/Portal.js');
require('react-dom');
require('../hooks/useLayoutEffect.js');
require('../loading/gradient.js');
require('../_chunks/dep-8593a497.js');
require('../_chunks/dep-f34d3a30.js');
require('../_chunks/dep-210ce7c8.js');
require('../_chunks/dep-b47ed304.js');
require('../hooks/useDomRefCallback.js');
require('../loading/defaultProps.js');
require('../hooks/useDefaultProps.js');
require('../loading/plugin.js');
require('../_util/react-render.js');
require('../_chunks/dep-608840a8.js');
require('../common/PluginContainer.js');
require('../config-provider/ConfigProvider.js');
require('../_chunks/dep-34def105.js');
require('../_chunks/dep-cc2fe55a.js');
require('../_chunks/dep-680d1e3e.js');
require('../_chunks/dep-a3962a45.js');
require('../_chunks/dep-b6bde0bc.js');
require('../_chunks/dep-f90d944e.js');
require('../_chunks/dep-46616204.js');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

var React__default = /*#__PURE__*/_interopDefaultLegacy(React);

var defaultSpin = /* @__PURE__ */React__default["default"].createElement(loading_index.Loading, {
  size: "32px"
});
function QRcodeStatus(_ref) {
  var locale = _ref.locale,
    classPrefix = _ref.classPrefix,
    onRefresh = _ref.onRefresh,
    statusRender = _ref.statusRender,
    status = _ref.status;
  var defaultExpiredNode = React.useMemo(function () {
    return /* @__PURE__ */React__default["default"].createElement(React__default["default"].Fragment, null, /* @__PURE__ */React__default["default"].createElement("p", {
      className: "".concat(classPrefix, "-expired__text")
    }, locale === null || locale === void 0 ? void 0 : locale.expiredText), onRefresh && /* @__PURE__ */React__default["default"].createElement("p", {
      className: "".concat(classPrefix, "-expired__button"),
      onClick: onRefresh
    }, /* @__PURE__ */React__default["default"].createElement(tdesignIconsReact.RefreshIcon, {
      size: 16
    }), locale === null || locale === void 0 ? void 0 : locale.refreshText));
  }, [classPrefix, locale === null || locale === void 0 ? void 0 : locale.expiredText, locale === null || locale === void 0 ? void 0 : locale.refreshText, onRefresh]);
  var defaultScannedNode = React.useMemo(function () {
    return /* @__PURE__ */React__default["default"].createElement("p", {
      className: "".concat(classPrefix, "-scanned")
    }, /* @__PURE__ */React__default["default"].createElement(tdesignIconsReact.CheckCircleFilledIcon, {
      size: 16,
      className: "".concat(classPrefix, "-scanned__icon")
    }), locale === null || locale === void 0 ? void 0 : locale.scannedText);
  }, [classPrefix, locale === null || locale === void 0 ? void 0 : locale.scannedText]);
  var defaultNodes = React.useMemo(function () {
    return {
      expired: defaultExpiredNode,
      loading: defaultSpin,
      scanned: defaultScannedNode
    };
  }, [defaultExpiredNode, defaultScannedNode]);
  var defaultStatusRender = React.useCallback(function (info) {
    return defaultNodes[info.status];
  }, [defaultNodes]);
  var mergedStatusRender = statusRender !== null && statusRender !== void 0 ? statusRender : defaultStatusRender;
  return /* @__PURE__ */React__default["default"].createElement(React__default["default"].Fragment, null, mergedStatusRender({
    status: status,
    onRefresh: onRefresh
  }) || null);
}

exports["default"] = QRcodeStatus;
//# sourceMappingURL=QRCodeStatus.js.map
