/**
 * tdesign v1.13.1
 * (c) 2025 tdesign
 * @license MIT
 */

'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var defineProperty = require('../_chunks/dep-7a6528ec.js');
var React = require('react');
var classNames = require('classnames');
var hooks_useConfig = require('../hooks/useConfig.js');
var popup_index = require('../popup/index.js');
require('../_chunks/dep-c83f28a0.js');
require('../config-provider/ConfigContext.js');
require('../_chunks/dep-1debbc3e.js');
require('../_chunks/dep-b4e78a42.js');
require('dayjs');
require('../_chunks/dep-fdd584c5.js');
require('../_chunks/dep-84fd1465.js');
require('../_chunks/dep-023db433.js');
require('../_chunks/dep-912bd8a2.js');
require('../_chunks/dep-0fccdcfb.js');
require('../_chunks/dep-78e8fc97.js');
require('../_chunks/dep-77879fb6.js');
require('../_chunks/dep-356859aa.js');
require('../_chunks/dep-e2240b05.js');
require('../_chunks/dep-837f0312.js');
require('../_chunks/dep-413bc6a7.js');
require('../_chunks/dep-84d18206.js');
require('../_chunks/dep-5e1fc2cd.js');
require('../_chunks/dep-0be4d457.js');
require('../_chunks/dep-6058edb6.js');
require('../_chunks/dep-cfe601e8.js');
require('../_chunks/dep-6c342676.js');
require('../_chunks/dep-8bd04901.js');
require('../_chunks/dep-2f3e85f6.js');
require('../_chunks/dep-3cfcca89.js');
require('../_chunks/dep-64afded1.js');
require('../_chunks/dep-a1d853fb.js');
require('../popup/Popup.js');
require('../_chunks/dep-3012da29.js');
require('../_chunks/dep-7e3b8125.js');
require('react-transition-group');
require('../_util/ref.js');
require('react-is');
require('../_util/isFragment.js');
require('../_chunks/dep-68db2ca6.js');
require('../_chunks/dep-6e448b65.js');
require('../common/Portal.js');
require('react-dom');
require('../hooks/useLayoutEffect.js');
require('../hooks/useAnimation.js');
require('../hooks/useAttach.js');
require('../hooks/useControlled.js');
require('../_util/noop.js');
require('../_chunks/dep-00e10ad8.js');
require('../_chunks/dep-5d5d7b13.js');
require('../_chunks/dep-ba207e81.js');
require('../_chunks/dep-ed0d1cf9.js');
require('../_chunks/dep-665eea2b.js');
require('../hooks/useDefaultProps.js');
require('../hooks/useMutationObserver.js');
require('../hooks/useLatest.js');
require('../_chunks/dep-c73e0aa5.js');
require('../_chunks/dep-becc25b2.js');
require('../_chunks/dep-ba79870d.js');
require('../_chunks/dep-680d1e3e.js');
require('../_chunks/dep-a3962a45.js');
require('../_chunks/dep-b6bde0bc.js');
require('../_chunks/dep-f90d944e.js');
require('../_chunks/dep-46616204.js');
require('../_chunks/dep-7bb447f9.js');
require('../_chunks/dep-5941343f.js');
require('../hooks/usePopper.js');
require('../_chunks/dep-210ce7c8.js');
require('@popperjs/core');
require('react-fast-compare');
require('../hooks/useWindowSize.js');
require('../popup/defaultProps.js');
require('../popup/hooks/useTrigger.js');
require('../_util/composeRefs.js');
require('../_util/listener.js');
require('../popup/utils/transition.js');
require('../popup/PopupPlugin.js');
require('../_chunks/dep-608840a8.js');
require('../_util/react-render.js');
require('../common/PluginContainer.js');
require('../config-provider/ConfigProvider.js');
require('../_chunks/dep-34def105.js');
require('../_chunks/dep-cc2fe55a.js');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

var React__default = /*#__PURE__*/_interopDefaultLegacy(React);
var classNames__default = /*#__PURE__*/_interopDefaultLegacy(classNames);

function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { defineProperty._defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
var StickyItem = /*#__PURE__*/React__default["default"].forwardRef(function (props, ref) {
  var icon = props.icon,
    label = props.label,
    popup = props.popup,
    popupProps = props.popupProps,
    trigger = props.trigger,
    type = props.type,
    shape = props.shape,
    placement = props.placement,
    basePopupProps = props.basePopupProps,
    baseWidth = props.baseWidth,
    onClick = props.onClick,
    onHover = props.onHover,
    style = props.style,
    className = props.className;
  var _useConfig = hooks_useConfig["default"](),
    classPrefix = _useConfig.classPrefix;
  var popupPlacement = React.useMemo(function () {
    return placement.includes("right") ? "left" : "right";
  }, [placement]);
  var styles = React.useMemo(function () {
    var styles2 = _objectSpread({}, style);
    if (baseWidth) {
      var selfWidth = type === "normal" ? "56px" : "40px";
      styles2.margin = "calc((".concat(baseWidth, " - ").concat(selfWidth, ")/2)");
    }
    return styles2;
  }, [baseWidth, style, type]);
  var handleClickItem = React.useCallback(function (e) {
    var item = {
      icon: icon,
      label: label,
      popup: popup,
      popupProps: popupProps,
      trigger: trigger
    };
    onClick({
      e: e,
      item: item
    });
  }, [icon, label, popup, popupProps, trigger, onClick]);
  var handleHoverItem = React.useCallback(function (e) {
    var item = {
      icon: icon,
      label: label,
      popup: popup,
      popupProps: popupProps,
      trigger: trigger
    };
    onHover({
      e: e,
      item: item
    });
  }, [icon, label, popup, popupProps, trigger, onHover]);
  var finalPopupProps = _objectSpread(_objectSpread({
    hideEmptyPopup: true
  }, basePopupProps), popupProps);
  return /* @__PURE__ */React__default["default"].createElement(popup_index.Popup, _objectSpread({
    overlayInnerClassName: classNames__default["default"]("".concat(classPrefix, "-sticky-tool-popup-content")),
    trigger: props.trigger,
    hideEmptyPopup: true,
    placement: popupPlacement,
    content: popup
  }, finalPopupProps), /* @__PURE__ */React__default["default"].createElement("div", {
    ref: ref,
    className: classNames__default["default"]("".concat(classPrefix, "-sticky-item"), "".concat(classPrefix, "-sticky-item--").concat(shape), "".concat(classPrefix, "-sticky-item--").concat(type), className),
    style: styles,
    onClick: handleClickItem,
    onMouseEnter: handleHoverItem
  }, icon, props.type === "normal" ? /* @__PURE__ */React__default["default"].createElement("div", {
    className: classNames__default["default"]("".concat(classPrefix, "-sticky-item__label"))
  }, label) : null));
});
StickyItem.displayName = "StickyItem";

exports["default"] = StickyItem;
//# sourceMappingURL=StickyItem.js.map
