/**
 * tdesign v1.13.1
 * (c) 2025 tdesign
 * @license MIT
 */

'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var defineProperty = require('../_chunks/dep-7a6528ec.js');
var slicedToArray = require('../_chunks/dep-3012da29.js');
var objectWithoutProperties = require('../_chunks/dep-e358a1dc.js');
var React = require('react');
var classNames = require('classnames');
var log = require('../_chunks/dep-cc4e3925.js');
var loading_index = require('../loading/index.js');
var hooks_useConfig = require('../hooks/useConfig.js');
var hooks_useCommonClassName = require('../hooks/useCommonClassName.js');
var switch_defaultProps = require('./defaultProps.js');
var _util_parseTNode = require('../_util/parseTNode.js');
var hooks_useDefaultProps = require('../hooks/useDefaultProps.js');
require('../_chunks/dep-c83f28a0.js');
require('../_chunks/dep-7e3b8125.js');
require('../loading/Loading.js');
require('../_chunks/dep-68db2ca6.js');
require('../_chunks/dep-6e448b65.js');
require('../_chunks/dep-912bd8a2.js');
require('../_chunks/dep-78e8fc97.js');
require('../_chunks/dep-0fccdcfb.js');
require('../common/Portal.js');
require('react-dom');
require('../hooks/useLayoutEffect.js');
require('../loading/gradient.js');
require('../_chunks/dep-8593a497.js');
require('../_chunks/dep-f34d3a30.js');
require('../_chunks/dep-210ce7c8.js');
require('../_chunks/dep-b47ed304.js');
require('../hooks/useDomRefCallback.js');
require('../loading/defaultProps.js');
require('../config-provider/ConfigContext.js');
require('../_chunks/dep-1debbc3e.js');
require('../_chunks/dep-b4e78a42.js');
require('dayjs');
require('../_chunks/dep-fdd584c5.js');
require('../_chunks/dep-84fd1465.js');
require('../_chunks/dep-023db433.js');
require('../_chunks/dep-77879fb6.js');
require('../_chunks/dep-356859aa.js');
require('../_chunks/dep-e2240b05.js');
require('../_chunks/dep-837f0312.js');
require('../_chunks/dep-413bc6a7.js');
require('../_chunks/dep-84d18206.js');
require('../_chunks/dep-5e1fc2cd.js');
require('../_chunks/dep-0be4d457.js');
require('../_chunks/dep-6058edb6.js');
require('../_chunks/dep-cfe601e8.js');
require('../_chunks/dep-6c342676.js');
require('../_chunks/dep-8bd04901.js');
require('../_chunks/dep-2f3e85f6.js');
require('../_chunks/dep-3cfcca89.js');
require('../_chunks/dep-64afded1.js');
require('../_chunks/dep-a1d853fb.js');
require('../loading/plugin.js');
require('../_util/react-render.js');
require('../_chunks/dep-608840a8.js');
require('../common/PluginContainer.js');
require('../config-provider/ConfigProvider.js');
require('../_chunks/dep-34def105.js');
require('../_chunks/dep-cc2fe55a.js');
require('../_chunks/dep-680d1e3e.js');
require('../_chunks/dep-a3962a45.js');
require('../_chunks/dep-b6bde0bc.js');
require('../_chunks/dep-f90d944e.js');
require('../_chunks/dep-46616204.js');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

var React__default = /*#__PURE__*/_interopDefaultLegacy(React);
var classNames__default = /*#__PURE__*/_interopDefaultLegacy(classNames);

var _excluded = ["className", "value", "defaultValue", "disabled", "loading", "size", "label", "customValue", "onChange", "beforeChange"];
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { defineProperty._defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
var Switch = /*#__PURE__*/React__default["default"].forwardRef(function (originalProps, ref) {
  var _useConfig = hooks_useConfig["default"](),
    classPrefix = _useConfig.classPrefix;
  var props = hooks_useDefaultProps["default"](originalProps, switch_defaultProps.switchDefaultProps);
  var className = props.className,
    value = props.value,
    defaultValue = props.defaultValue,
    disabled = props.disabled,
    loading = props.loading,
    size = props.size,
    label = props.label,
    customValue = props.customValue,
    onChange = props.onChange,
    beforeChange = props.beforeChange,
    restProps = objectWithoutProperties._objectWithoutProperties(props, _excluded);
  var _ref = customValue || [],
    _ref2 = slicedToArray._slicedToArray(_ref, 2),
    _ref2$ = _ref2[0],
    activeValue = _ref2$ === void 0 ? true : _ref2$,
    _ref2$2 = _ref2[1],
    inactiveValue = _ref2$2 === void 0 ? false : _ref2$2;
  var isControlled = typeof value !== "undefined";
  var initChecked = defaultValue === activeValue || value === activeValue;
  var _useState = React.useState(initChecked),
    _useState2 = slicedToArray._slicedToArray(_useState, 2),
    innerChecked = _useState2[0],
    setInnerChecked = _useState2[1];
  var contentNode = React__default["default"].useMemo(function () {
    if (Array.isArray(label)) {
      var _label = slicedToArray._slicedToArray(label, 2),
        _label$ = _label[0],
        activeContent = _label$ === void 0 ? "" : _label$,
        _label$2 = _label[1],
        inactiveContent = _label$2 === void 0 ? "" : _label$2;
      var content = innerChecked ? activeContent : inactiveContent;
      return _util_parseTNode["default"](content, {
        value: value
      });
    }
    return _util_parseTNode["default"](label, {
      value: value
    });
  }, [label, innerChecked, value]);
  var handleChange = function handleChange(e) {
    !isControlled && setInnerChecked(!innerChecked);
    var changedValue = !innerChecked ? activeValue : inactiveValue;
    onChange === null || onChange === void 0 || onChange(changedValue, {
      e: e
    });
  };
  var onInternalClick = function onInternalClick(e) {
    if (disabled) {
      return;
    }
    if (!beforeChange) {
      handleChange(e);
      return;
    }
    Promise.resolve(beforeChange()).then(function (v) {
      if (v) {
        handleChange(e);
      }
    })["catch"](function (e2) {
      log.log.error("Switch", "some error occurred: ".concat(e2));
    });
  };
  React.useEffect(function () {
    if (Array.isArray(customValue) && !customValue.includes(value)) {
      log.log.error("Switch", "value is not in customValue: ".concat(JSON.stringify(customValue)));
    }
    isControlled && setInnerChecked(value === activeValue);
  }, [value, customValue, activeValue, isControlled]);
  var _useCommonClassName = hooks_useCommonClassName["default"](),
    SIZE = _useCommonClassName.SIZE,
    STATUS = _useCommonClassName.STATUS;
  var switchClassName = classNames__default["default"]("".concat(classPrefix, "-switch"), className, defineProperty._defineProperty(defineProperty._defineProperty(defineProperty._defineProperty({}, STATUS.checked, innerChecked), STATUS.disabled, disabled), STATUS.loading, loading), SIZE[size]);
  return /* @__PURE__ */React__default["default"].createElement("button", _objectSpread(_objectSpread({}, restProps), {}, {
    type: "button",
    role: "switch",
    disabled: disabled || loading,
    className: switchClassName,
    ref: ref,
    onClick: onInternalClick
  }), /* @__PURE__ */React__default["default"].createElement("span", {
    className: "".concat(classPrefix, "-switch__handle")
  }, loading && /* @__PURE__ */React__default["default"].createElement(loading_index.Loading, {
    loading: true,
    size: "small"
  })), /* @__PURE__ */React__default["default"].createElement("div", {
    className: "".concat(classPrefix, "-switch__content")
  }, contentNode));
});
Switch.displayName = "Switch";

exports["default"] = Switch;
//# sourceMappingURL=Switch.js.map
