/**
 * tdesign v1.13.1
 * (c) 2025 tdesign
 * @license MIT
 */

'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var defineProperty = require('../../_chunks/dep-7a6528ec.js');
var slicedToArray = require('../../_chunks/dep-3012da29.js');
var React = require('react');
var classNames = require('classnames');
var loading_index = require('../../loading/index.js');
var table_hooks_useClassName = require('./useClassName.js');
var locale_LocalReceiver = require('../../locale/LocalReceiver.js');
var isString = require('../../_chunks/dep-6e448b65.js');
require('../../_chunks/dep-c83f28a0.js');
require('../../_chunks/dep-7e3b8125.js');
require('../../loading/Loading.js');
require('../../_chunks/dep-68db2ca6.js');
require('../../hooks/useConfig.js');
require('../../config-provider/ConfigContext.js');
require('../../_chunks/dep-1debbc3e.js');
require('../../_chunks/dep-b4e78a42.js');
require('dayjs');
require('../../_chunks/dep-fdd584c5.js');
require('../../_chunks/dep-84fd1465.js');
require('../../_chunks/dep-023db433.js');
require('../../_chunks/dep-912bd8a2.js');
require('../../_chunks/dep-0fccdcfb.js');
require('../../_chunks/dep-78e8fc97.js');
require('../../_chunks/dep-77879fb6.js');
require('../../_chunks/dep-356859aa.js');
require('../../_chunks/dep-e2240b05.js');
require('../../_chunks/dep-837f0312.js');
require('../../_chunks/dep-413bc6a7.js');
require('../../_chunks/dep-84d18206.js');
require('../../_chunks/dep-5e1fc2cd.js');
require('../../_chunks/dep-0be4d457.js');
require('../../_chunks/dep-6058edb6.js');
require('../../_chunks/dep-cfe601e8.js');
require('../../_chunks/dep-6c342676.js');
require('../../_chunks/dep-8bd04901.js');
require('../../_chunks/dep-2f3e85f6.js');
require('../../_chunks/dep-3cfcca89.js');
require('../../_chunks/dep-64afded1.js');
require('../../_chunks/dep-a1d853fb.js');
require('../../common/Portal.js');
require('react-dom');
require('../../hooks/useLayoutEffect.js');
require('../../loading/gradient.js');
require('../../_chunks/dep-8593a497.js');
require('../../_chunks/dep-f34d3a30.js');
require('../../_chunks/dep-210ce7c8.js');
require('../../_chunks/dep-b47ed304.js');
require('../../hooks/useDomRefCallback.js');
require('../../loading/defaultProps.js');
require('../../hooks/useDefaultProps.js');
require('../../loading/plugin.js');
require('../../_util/react-render.js');
require('../../_chunks/dep-608840a8.js');
require('../../common/PluginContainer.js');
require('../../config-provider/ConfigProvider.js');
require('../../_chunks/dep-34def105.js');
require('../../_chunks/dep-cc2fe55a.js');
require('../../_chunks/dep-680d1e3e.js');
require('../../_chunks/dep-a3962a45.js');
require('../../_chunks/dep-b6bde0bc.js');
require('../../_chunks/dep-f90d944e.js');
require('../../_chunks/dep-46616204.js');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

var React__default = /*#__PURE__*/_interopDefaultLegacy(React);
var classNames__default = /*#__PURE__*/_interopDefaultLegacy(classNames);

function useAsyncLoading(props) {
  var _useLocaleReceiver = locale_LocalReceiver.useLocaleReceiver("table"),
    _useLocaleReceiver2 = slicedToArray._slicedToArray(_useLocaleReceiver, 1),
    local = _useLocaleReceiver2[0];
  var _useClassName = table_hooks_useClassName["default"](),
    isLoadingClass = _useClassName.isLoadingClass,
    isLoadMoreClass = _useClassName.isLoadMoreClass,
    asyncLoadingClass = _useClassName.asyncLoadingClass;
  var classes = [asyncLoadingClass, defineProperty._defineProperty(defineProperty._defineProperty({}, isLoadingClass, props.asyncLoading === "loading"), isLoadMoreClass, props.asyncLoading === "load-more")];
  function onLoadClick() {
    var _props$onAsyncLoading;
    if (typeof props.asyncLoading !== "string") return;
    var status = props.asyncLoading === "loading" ? "loading" : "load-more";
    (_props$onAsyncLoading = props.onAsyncLoadingClick) === null || _props$onAsyncLoading === void 0 || _props$onAsyncLoading.call(props, {
      status: status
    });
  }
  function renderAsyncLoading() {
    var asyncLoadingNode = props.asyncLoading;
    if (isString.isString(asyncLoadingNode)) {
      var asyncLoading = props.asyncLoading;
      var loadingText = {
        "load-more": local.loadingMoreText,
        loading: local.loadingText
      }[String(asyncLoading)];
      return /* @__PURE__ */React__default["default"].createElement("div", {
        className: classNames__default["default"](classes),
        onClick: onLoadClick
      }, /* @__PURE__ */React__default["default"].createElement(loading_index.Loading, {
        loading: true,
        size: "small",
        text: loadingText,
        indicator: asyncLoading === "loading"
      }));
    }
    if (asyncLoadingNode) {
      return /* @__PURE__ */React__default["default"].createElement("div", {
        className: classNames__default["default"](classes),
        onClick: onLoadClick
      }, asyncLoadingNode);
    }
    return null;
  }
  return {
    renderAsyncLoading: renderAsyncLoading
  };
}

exports["default"] = useAsyncLoading;
//# sourceMappingURL=useAsyncLoading.js.map
