/**
 * tdesign v1.13.1
 * (c) 2025 tdesign
 * @license MIT
 */

'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var defineProperty = require('../../_chunks/dep-7a6528ec.js');
var React = require('react');
var table_hooks_useClassName = require('./useClassName.js');
var hooks_useCommonClassName = require('../../hooks/useCommonClassName.js');
require('../../_chunks/dep-c83f28a0.js');
require('../../hooks/useConfig.js');
require('../../config-provider/ConfigContext.js');
require('../../_chunks/dep-1debbc3e.js');
require('../../_chunks/dep-b4e78a42.js');
require('dayjs');
require('../../_chunks/dep-fdd584c5.js');
require('../../_chunks/dep-84fd1465.js');
require('../../_chunks/dep-023db433.js');
require('../../_chunks/dep-912bd8a2.js');
require('../../_chunks/dep-0fccdcfb.js');
require('../../_chunks/dep-78e8fc97.js');
require('../../_chunks/dep-77879fb6.js');
require('../../_chunks/dep-356859aa.js');
require('../../_chunks/dep-e2240b05.js');
require('../../_chunks/dep-837f0312.js');
require('../../_chunks/dep-413bc6a7.js');
require('../../_chunks/dep-84d18206.js');
require('../../_chunks/dep-5e1fc2cd.js');
require('../../_chunks/dep-0be4d457.js');
require('../../_chunks/dep-6058edb6.js');
require('../../_chunks/dep-cfe601e8.js');
require('../../_chunks/dep-6c342676.js');
require('../../_chunks/dep-8bd04901.js');
require('../../_chunks/dep-2f3e85f6.js');
require('../../_chunks/dep-3cfcca89.js');
require('../../_chunks/dep-64afded1.js');
require('../../_chunks/dep-a1d853fb.js');

function formatCSSUnit(unit) {
  if (!unit) return unit;
  return isNaN(Number(unit)) ? unit : "".concat(unit, "px");
}
function useStyle(props) {
  var className = props.className,
    size = props.size,
    bordered = props.bordered,
    stripe = props.stripe,
    hover = props.hover,
    verticalAlign = props.verticalAlign,
    height = props.height,
    maxHeight = props.maxHeight,
    tableContentWidth = props.tableContentWidth;
  var _useClassName = table_hooks_useClassName["default"](),
    tableBaseClass = _useClassName.tableBaseClass,
    tableAlignClasses = _useClassName.tableAlignClasses;
  var _useCommonClassName = hooks_useCommonClassName["default"](),
    sizeClassNames = _useCommonClassName.sizeClassNames;
  var tableClasses = React.useMemo(function () {
    return [tableBaseClass.table, size !== "medium" && sizeClassNames[size], verticalAlign !== "middle" && tableAlignClasses[verticalAlign], defineProperty._defineProperty(defineProperty._defineProperty(defineProperty._defineProperty(defineProperty._defineProperty(defineProperty._defineProperty(defineProperty._defineProperty({}, tableBaseClass.bordered, bordered), tableBaseClass.striped, stripe), tableBaseClass.hover, hover), tableBaseClass.loading, props.loading), tableBaseClass.affixedHeader, props.headerAffixedTop), tableBaseClass.rowspanAndColspan, props.rowspanAndColspan), className];
  }, [className, bordered, hover, props.loading, props.headerAffixedTop, props.rowspanAndColspan, size, sizeClassNames, stripe, tableAlignClasses, tableBaseClass, verticalAlign]);
  var tableContentStyles = React.useMemo(function () {
    return {
      height: formatCSSUnit(height),
      maxHeight: formatCSSUnit(maxHeight)
    };
  }, [height, maxHeight]);
  var tableElementStyles = React.useMemo(function () {
    return {
      width: formatCSSUnit(tableContentWidth)
    };
  }, [tableContentWidth]);
  return {
    tableClasses: tableClasses,
    sizeClassNames: sizeClassNames,
    tableElementStyles: tableElementStyles,
    tableContentStyles: tableContentStyles
  };
}

exports["default"] = useStyle;
exports.formatCSSUnit = formatCSSUnit;
//# sourceMappingURL=useStyle.js.map
