/**
 * tdesign v1.13.1
 * (c) 2025 tdesign
 * @license MIT
 */

'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var defineProperty = require('../_chunks/dep-7a6528ec.js');
var slicedToArray = require('../_chunks/dep-3012da29.js');
var React = require('react');
var classNames = require('classnames');
var hooks_useConfig = require('../hooks/useConfig.js');
var hooks_useMutationObserver = require('../hooks/useMutationObserver.js');
var hooks_useResizeObserver = require('../hooks/useResizeObserver.js');
require('../_chunks/dep-c83f28a0.js');
require('../_chunks/dep-7e3b8125.js');
require('../config-provider/ConfigContext.js');
require('../_chunks/dep-1debbc3e.js');
require('../_chunks/dep-b4e78a42.js');
require('dayjs');
require('../_chunks/dep-fdd584c5.js');
require('../_chunks/dep-84fd1465.js');
require('../_chunks/dep-023db433.js');
require('../_chunks/dep-912bd8a2.js');
require('../_chunks/dep-0fccdcfb.js');
require('../_chunks/dep-78e8fc97.js');
require('../_chunks/dep-77879fb6.js');
require('../_chunks/dep-356859aa.js');
require('../_chunks/dep-e2240b05.js');
require('../_chunks/dep-837f0312.js');
require('../_chunks/dep-413bc6a7.js');
require('../_chunks/dep-84d18206.js');
require('../_chunks/dep-5e1fc2cd.js');
require('../_chunks/dep-0be4d457.js');
require('../_chunks/dep-6058edb6.js');
require('../_chunks/dep-cfe601e8.js');
require('../_chunks/dep-6c342676.js');
require('../_chunks/dep-8bd04901.js');
require('../_chunks/dep-2f3e85f6.js');
require('../_chunks/dep-3cfcca89.js');
require('../_chunks/dep-64afded1.js');
require('../_chunks/dep-a1d853fb.js');
require('../hooks/useLatest.js');
require('../_chunks/dep-c73e0aa5.js');
require('../_chunks/dep-becc25b2.js');
require('../_chunks/dep-ba79870d.js');
require('../_chunks/dep-680d1e3e.js');
require('../_chunks/dep-a3962a45.js');
require('../_chunks/dep-b6bde0bc.js');
require('../_chunks/dep-f90d944e.js');
require('../_chunks/dep-46616204.js');
require('../_chunks/dep-7bb447f9.js');
require('../_chunks/dep-5941343f.js');
require('../_chunks/dep-665eea2b.js');
require('../hooks/useLayoutEffect.js');
require('../_chunks/dep-68db2ca6.js');
require('../_chunks/dep-6e448b65.js');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

var React__default = /*#__PURE__*/_interopDefaultLegacy(React);
var classNames__default = /*#__PURE__*/_interopDefaultLegacy(classNames);

var TabBar = function TabBar(props) {
  var tabPosition = props.tabPosition,
    activeId = props.activeId,
    containerRef = props.containerRef,
    navsWrapRef = props.navsWrapRef;
  var _useConfig = hooks_useConfig["default"](),
    classPrefix = _useConfig.classPrefix;
  var _useState = React.useState({}),
    _useState2 = slicedToArray._slicedToArray(_useState, 2),
    barStyle = _useState2[0],
    setBarStyle = _useState2[1];
  var tabsClassPrefix = "".concat(classPrefix, "-tabs");
  var currentActiveIdRef = React.useRef(activeId);
  React.useEffect(function () {
    currentActiveIdRef.current = activeId;
  }, [activeId]);
  var computeStyle = React__default["default"].useCallback(function () {
    var isHorizontal = ["bottom", "top"].includes(tabPosition);
    var transformPosition = isHorizontal ? "translateX" : "translateY";
    var itemProp = isHorizontal ? "width" : "height";
    var barBorderProp = isHorizontal ? "width" : "height";
    var offset = 0;
    if (containerRef.current) {
      var _containerRef$current;
      var itemsRef = (_containerRef$current = containerRef.current) === null || _containerRef$current === void 0 ? void 0 : _containerRef$current.querySelectorAll(".".concat(tabsClassPrefix, "__nav-item"));
      if (itemsRef.length - 1 >= currentActiveIdRef.current) {
        itemsRef.forEach(function (item, itemIndex) {
          if (itemIndex < currentActiveIdRef.current) {
            offset += Number(getComputedStyle(item)[itemProp].replace("px", ""));
          }
        });
        var computedItem = itemsRef[currentActiveIdRef.current];
        if (!computedItem) {
          setBarStyle(defineProperty._defineProperty({
            transform: "".concat(transformPosition, "(", 0, "px)")
          }, barBorderProp, 0));
          return;
        }
        var itemPropValue = getComputedStyle(computedItem)[itemProp];
        setBarStyle(defineProperty._defineProperty({
          transform: "".concat(transformPosition, "(").concat(offset, "px)")
        }, barBorderProp, itemPropValue || 0));
      }
    }
  }, [currentActiveIdRef, containerRef, tabPosition, tabsClassPrefix]);
  React.useEffect(function () {
    if (containerRef.current) {
      setTimeout(function () {
        return computeStyle();
      });
    }
  }, [tabPosition, activeId, containerRef.current]);
  var handleMutationObserver = React__default["default"].useCallback(function (mutations) {
    mutations.forEach(function (mutation) {
      if (mutation.type === "characterData") {
        computeStyle();
      }
    });
  }, [computeStyle]);
  hooks_useMutationObserver["default"](containerRef.current, handleMutationObserver);
  hooks_useResizeObserver["default"](navsWrapRef, computeStyle);
  return /* @__PURE__ */React__default["default"].createElement("div", {
    className: classNames__default["default"](defineProperty._defineProperty(defineProperty._defineProperty({}, "".concat(tabsClassPrefix, "__bar"), true), "".concat(classPrefix, "-is-").concat(tabPosition), true)),
    style: barStyle
  });
};
TabBar.displayName = "TabBar";

exports["default"] = TabBar;
//# sourceMappingURL=TabBar.js.map
