/**
 * tdesign v1.13.1
 * (c) 2025 tdesign
 * @license MIT
 */

'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var defineProperty = require('../_chunks/dep-7a6528ec.js');
var slicedToArray = require('../_chunks/dep-3012da29.js');
var React = require('react');
var classNames = require('classnames');
var dayjs = require('dayjs');
var customParseFormat = require('../_chunks/dep-5b899485.js');
var tdesignIconsReact = require('tdesign-icons-react');
var timePicker_panel_SinglePanel = require('../_chunks/dep-feb1fd45.js');
var _util_forwardRefWithStatics = require('../_util/forwardRefWithStatics.js');
var hooks_useControlled = require('../hooks/useControlled.js');
var hooks_useConfig = require('../hooks/useConfig.js');
var hooks_useGlobalIcon = require('../hooks/useGlobalIcon.js');
var _util_noop = require('../_util/noop.js');
var selectInput_index = require('../select-input/index.js');
var timePicker_TimeRangePicker = require('./TimeRangePicker.js');
var timePicker_panel_TimePickerPanel = require('./panel/TimePickerPanel.js');
var timePicker_hooks_useTimePickerTextConfig = require('./hooks/useTimePickerTextConfig.js');
var timePicker_defaultProps = require('./defaultProps.js');
var hooks_useDefaultProps = require('../hooks/useDefaultProps.js');
require('../_chunks/dep-c83f28a0.js');
require('../_chunks/dep-7e3b8125.js');
require('../_chunks/dep-5941343f.js');
require('../_chunks/dep-837f0312.js');
require('../_chunks/dep-665eea2b.js');
require('../_chunks/dep-912bd8a2.js');
require('../_chunks/dep-0fccdcfb.js');
require('../_chunks/dep-b4e78a42.js');
require('../hooks/useDebounce.js');
require('../hooks/usePersistFn.js');
require('../_chunks/dep-7bb447f9.js');
require('../hooks/usePropsRef.js');
require('../_chunks/dep-a1d853fb.js');
require('../_chunks/dep-6058edb6.js');
require('../_chunks/dep-356859aa.js');
require('../_chunks/dep-e2240b05.js');
require('../_chunks/dep-84d18206.js');
require('../_chunks/dep-ed0d1cf9.js');
require('../_chunks/dep-78e8fc97.js');
require('../_chunks/dep-5d5d7b13.js');
require('../_chunks/dep-ba207e81.js');
require('hoist-non-react-statics');
require('../_chunks/dep-00e10ad8.js');
require('../config-provider/ConfigContext.js');
require('../_chunks/dep-1debbc3e.js');
require('../_chunks/dep-fdd584c5.js');
require('../_chunks/dep-84fd1465.js');
require('../_chunks/dep-023db433.js');
require('../_chunks/dep-77879fb6.js');
require('../_chunks/dep-413bc6a7.js');
require('../_chunks/dep-5e1fc2cd.js');
require('../_chunks/dep-0be4d457.js');
require('../_chunks/dep-cfe601e8.js');
require('../_chunks/dep-6c342676.js');
require('../_chunks/dep-8bd04901.js');
require('../_chunks/dep-2f3e85f6.js');
require('../_chunks/dep-3cfcca89.js');
require('../_chunks/dep-64afded1.js');
require('../select-input/SelectInput.js');
require('../popup/index.js');
require('../popup/Popup.js');
require('react-transition-group');
require('../_util/ref.js');
require('react-is');
require('../_util/isFragment.js');
require('../_chunks/dep-68db2ca6.js');
require('../_chunks/dep-6e448b65.js');
require('../common/Portal.js');
require('react-dom');
require('../hooks/useLayoutEffect.js');
require('../hooks/useAnimation.js');
require('../hooks/useAttach.js');
require('../hooks/useMutationObserver.js');
require('../hooks/useLatest.js');
require('../_chunks/dep-c73e0aa5.js');
require('../_chunks/dep-becc25b2.js');
require('../_chunks/dep-ba79870d.js');
require('../_chunks/dep-680d1e3e.js');
require('../_chunks/dep-a3962a45.js');
require('../_chunks/dep-b6bde0bc.js');
require('../_chunks/dep-f90d944e.js');
require('../_chunks/dep-46616204.js');
require('../hooks/usePopper.js');
require('../_chunks/dep-210ce7c8.js');
require('@popperjs/core');
require('react-fast-compare');
require('../hooks/useWindowSize.js');
require('../popup/defaultProps.js');
require('../popup/hooks/useTrigger.js');
require('../_util/composeRefs.js');
require('../_util/listener.js');
require('../popup/utils/transition.js');
require('../popup/PopupPlugin.js');
require('../_chunks/dep-608840a8.js');
require('../_util/react-render.js');
require('../common/PluginContainer.js');
require('../config-provider/ConfigProvider.js');
require('../_chunks/dep-34def105.js');
require('../_chunks/dep-cc2fe55a.js');
require('../select-input/useSingle.js');
require('../input/index.js');
require('../input/Input.js');
require('../_chunks/dep-e358a1dc.js');
require('../input/InputGroup.js');
require('../locale/LocalReceiver.js');
require('../input/defaultProps.js');
require('../_util/parseTNode.js');
require('../_chunks/dep-cc4e3925.js');
require('../input/useLengthLimit.js');
require('../_chunks/dep-f34d3a30.js');
require('../_chunks/dep-b47ed304.js');
require('../loading/index.js');
require('../loading/Loading.js');
require('../loading/gradient.js');
require('../_chunks/dep-8593a497.js');
require('../hooks/useDomRefCallback.js');
require('../loading/defaultProps.js');
require('../loading/plugin.js');
require('../_chunks/dep-52a009fb.js');
require('../_chunks/dep-8529ce07.js');
require('../_chunks/dep-962f011a.js');
require('../_chunks/dep-58cddfe4.js');
require('../_chunks/dep-c29b655c.js');
require('../_chunks/dep-d843946a.js');
require('../select-input/useMultiple.js');
require('../tag-input/index.js');
require('../tag-input/TagInput.js');
require('../hooks/useDragSorter.js');
require('../hooks/useEventCallback.js');
require('../tag-input/useTagScroll.js');
require('../tag-input/useTagList.js');
require('../tag/index.js');
require('../tag/Tag.js');
require('tinycolor2');
require('../tag/defaultProps.js');
require('../tag/CheckTag.js');
require('../_chunks/dep-59a9c125.js');
require('../tag/CheckTagGroup.js');
require('../tag-input/useHover.js');
require('../tag-input/defaultProps.js');
require('../select-input/useOverlayInnerStyle.js');
require('../select-input/defaultProps.js');
require('../range-input/index.js');
require('../range-input/RangeInput.js');
require('../range-input/defaultProps.js');
require('../range-input/RangeInputPopup.js');
require('../button/index.js');
require('../button/Button.js');
require('../hooks/useRipple.js');
require('../button/defaultProps.js');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

var React__default = /*#__PURE__*/_interopDefaultLegacy(React);
var classNames__default = /*#__PURE__*/_interopDefaultLegacy(classNames);
var dayjs__default = /*#__PURE__*/_interopDefaultLegacy(dayjs);

function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { defineProperty._defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
dayjs__default["default"].extend(customParseFormat.customParseFormat);
var TimePicker = _util_forwardRefWithStatics["default"](function (originalProps, ref) {
  var props = hooks_useDefaultProps["default"](originalProps, timePicker_defaultProps.timePickerDefaultProps);
  var TEXT_CONFIG = timePicker_hooks_useTimePickerTextConfig.useTimePickerTextConfig();
  var allowInput = props.allowInput,
    borderless = props.borderless,
    className = props.className,
    clearable = props.clearable,
    disabled = props.disabled,
    style = props.style,
    _props$format = props.format,
    format = _props$format === void 0 ? timePicker_panel_SinglePanel.DEFAULT_FORMAT : _props$format,
    _props$hideDisabledTi = props.hideDisabledTime,
    hideDisabledTime = _props$hideDisabledTi === void 0 ? true : _props$hideDisabledTi,
    _props$steps = props.steps,
    steps = _props$steps === void 0 ? timePicker_panel_SinglePanel.DEFAULT_STEPS : _props$steps,
    _props$placeholder = props.placeholder,
    placeholder = _props$placeholder === void 0 ? TEXT_CONFIG.placeholder : _props$placeholder,
    disableTime = props.disableTime,
    _props$onBlur = props.onBlur,
    onBlur = _props$onBlur === void 0 ? _util_noop["default"] : _props$onBlur,
    _props$onClose = props.onClose,
    onClose = _props$onClose === void 0 ? _util_noop["default"] : _props$onClose,
    _props$onFocus = props.onFocus,
    onFocus = _props$onFocus === void 0 ? _util_noop["default"] : _props$onFocus,
    _props$onOpen = props.onOpen,
    onOpen = _props$onOpen === void 0 ? _util_noop["default"] : _props$onOpen,
    _props$onInput = props.onInput,
    onInput = _props$onInput === void 0 ? _util_noop["default"] : _props$onInput,
    _props$onPick = props.onPick,
    onPick = _props$onPick === void 0 ? _util_noop["default"] : _props$onPick,
    _props$onClear = props.onClear,
    onClear = _props$onClear === void 0 ? _util_noop["default"] : _props$onClear;
  var _useControlled = hooks_useControlled["default"](props, "value", props.onChange),
    _useControlled2 = slicedToArray._slicedToArray(_useControlled, 2),
    value = _useControlled2[0],
    onChange = _useControlled2[1];
  var _useState = React.useState(false),
    _useState2 = slicedToArray._slicedToArray(_useState, 2),
    isPanelShowed = _useState2[0],
    setPanelShow = _useState2[1];
  var _useState3 = React.useState(""),
    _useState4 = slicedToArray._slicedToArray(_useState3, 2),
    currentValue = _useState4[0],
    setCurrentValue = _useState4[1];
  var _useConfig = hooks_useConfig["default"](),
    classPrefix = _useConfig.classPrefix;
  var _useGlobalIcon = hooks_useGlobalIcon["default"]({
      TimeIcon: tdesignIconsReact.TimeIcon
    }),
    TimeIcon = _useGlobalIcon.TimeIcon;
  var name = "".concat(classPrefix, "-time-picker");
  var inputClasses = classNames__default["default"]("".concat(name, "__group"), defineProperty._defineProperty({}, "".concat(classPrefix, "-is-focused"), isPanelShowed));
  var effectVisibleCurrentValue = function effectVisibleCurrentValue(visible) {
    setPanelShow(visible);
    setCurrentValue(visible ? value !== null && value !== void 0 ? value : "" : "");
  };
  var handleShowPopup = function handleShowPopup(visible, context) {
    effectVisibleCurrentValue(visible);
    visible ? onOpen(context) : onClose(context);
  };
  var handleClear = function handleClear(context) {
    var e = context.e;
    e.stopPropagation();
    setCurrentValue("");
    onChange(null);
    onClear(context);
  };
  var handleInputChange = function handleInputChange(value2, context) {
    setCurrentValue(value2);
    if (allowInput) {
      onInput({
        value: value2,
        e: context.e
      });
    }
  };
  var handleInputBlur = function handleInputBlur(value2, ctx) {
    if (allowInput) {
      var isValidTime = timePicker_panel_SinglePanel.validateInputValue(currentValue, format);
      if (isValidTime) {
        onChange(timePicker_panel_SinglePanel.formatInputValue(currentValue, format));
      }
    }
    onBlur(_objectSpread({
      value: String(value2)
    }, ctx));
  };
  var handleClickConfirm = function handleClickConfirm() {
    var isValidTime = timePicker_panel_SinglePanel.validateInputValue(currentValue, format);
    if (isValidTime) onChange(currentValue);
    effectVisibleCurrentValue(false);
  };
  var handlePanelChange = function handlePanelChange(v, ctx) {
    setCurrentValue(v);
    onPick === null || onPick === void 0 || onPick(v, ctx);
  };
  return /* @__PURE__ */React__default["default"].createElement("div", {
    className: classNames__default["default"](name, className),
    ref: ref,
    style: style
  }, /* @__PURE__ */React__default["default"].createElement(selectInput_index.SelectInput, {
    onFocus: onFocus,
    onClear: handleClear,
    disabled: disabled,
    clearable: clearable,
    allowInput: allowInput,
    className: inputClasses,
    borderless: borderless,
    suffixIcon: /* @__PURE__ */React__default["default"].createElement(TimeIcon, null),
    popupVisible: isPanelShowed,
    onInputChange: handleInputChange,
    onBlur: handleInputBlur,
    onPopupVisibleChange: handleShowPopup,
    placeholder: !value ? placeholder : void 0,
    value: isPanelShowed ? currentValue : value !== null && value !== void 0 ? value : void 0,
    inputValue: isPanelShowed ? currentValue : value !== null && value !== void 0 ? value : void 0,
    inputProps: _objectSpread(_objectSpread({}, props.inputProps), {}, {
      size: props.size
    }),
    popupProps: _objectSpread({
      overlayInnerStyle: {
        width: "auto",
        padding: 0
      }
    }, props.popupProps),
    tips: props.tips,
    status: props.status,
    label: props.label,
    panel: /* @__PURE__ */React__default["default"].createElement(timePicker_panel_TimePickerPanel["default"], {
      steps: steps,
      format: format,
      value: currentValue,
      isFooterDisplay: true,
      isShowPanel: isPanelShowed,
      disableTime: disableTime,
      onChange: handlePanelChange,
      onPick: props.onPick,
      hideDisabledTime: hideDisabledTime,
      handleConfirmClick: handleClickConfirm,
      presets: props.presets
    })
  }));
}, {
  TimeRangePicker: timePicker_TimeRangePicker["default"],
  TimePickerPanel: timePicker_panel_TimePickerPanel["default"]
});
TimePicker.displayName = "TimePicker";

exports["default"] = TimePicker;
//# sourceMappingURL=TimePicker.js.map
