/**
 * tdesign v1.13.1
 * (c) 2025 tdesign
 * @license MIT
 */

'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var defineProperty = require('../../_chunks/dep-7a6528ec.js');
var React = require('react');
var treeStore = require('../../_chunks/dep-b571b0e0.js');
var hooks_usePersistFn = require('../../hooks/usePersistFn.js');
var treeSelect_defaultProps = require('../defaultProps.js');
require('../../_chunks/dep-c83f28a0.js');
require('../../_chunks/dep-560c14c5.js');
require('mitt');
require('../../_chunks/dep-8ee4aae7.js');
require('../../_chunks/dep-608840a8.js');
require('../../_chunks/dep-210ce7c8.js');
require('../../_chunks/dep-7e3b8125.js');
require('../../_chunks/dep-cc4e3925.js');
require('../../_chunks/dep-52a009fb.js');
require('../../_chunks/dep-8529ce07.js');
require('../../_chunks/dep-78e8fc97.js');
require('../../_chunks/dep-665eea2b.js');
require('../../_chunks/dep-912bd8a2.js');
require('../../_chunks/dep-0fccdcfb.js');
require('../../_chunks/dep-5e1fc2cd.js');
require('../../_chunks/dep-0be4d457.js');
require('../../_chunks/dep-e2240b05.js');
require('../../_chunks/dep-837f0312.js');
require('../../_chunks/dep-6058edb6.js');
require('../../_chunks/dep-ed0d1cf9.js');
require('../../_chunks/dep-962f011a.js');
require('../../_chunks/dep-cfe601e8.js');
require('../../_chunks/dep-6c342676.js');
require('../../_chunks/dep-84d18206.js');
require('../../_chunks/dep-58cddfe4.js');
require('../../_chunks/dep-023db433.js');
require('../../_chunks/dep-356859aa.js');
require('../../_chunks/dep-c29b655c.js');
require('../../_chunks/dep-d843946a.js');
require('../../_chunks/dep-a3962a45.js');
require('../../_chunks/dep-3cfcca89.js');
require('../../_chunks/dep-69751dfb.js');
require('../../_chunks/dep-f4d31431.js');
require('../../_chunks/dep-cc2fe55a.js');
require('../../_chunks/dep-84fd1465.js');
require('../../_chunks/dep-77879fb6.js');
require('../../_chunks/dep-413bc6a7.js');
require('../../_chunks/dep-8bd04901.js');
require('../../_chunks/dep-680d1e3e.js');
require('../../_chunks/dep-b6bde0bc.js');
require('../../_chunks/dep-f90d944e.js');
require('../../_chunks/dep-46616204.js');
require('../../_chunks/dep-be9040ff.js');
require('../../_chunks/dep-ba207e81.js');
require('../../_chunks/dep-64afded1.js');
require('../../_chunks/dep-dfe5fb78.js');
require('../../_chunks/dep-b47ed304.js');
require('../../_chunks/dep-8a28dfd9.js');
require('../../_chunks/dep-d9f53773.js');
require('../../_chunks/dep-c1986661.js');
require('../../_chunks/dep-6e448b65.js');
require('../../_chunks/dep-bb56a94e.js');
require('../../_chunks/dep-2545fc22.js');
require('../../_chunks/dep-becc25b2.js');
require('../../_chunks/dep-a09b28f5.js');
require('../../_chunks/dep-2f3e85f6.js');
require('../../_chunks/dep-1819e167.js');
require('../../_chunks/dep-00e10ad8.js');
require('../../_chunks/dep-5d5d7b13.js');

function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { defineProperty._defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
var useTreeSelectUtils = function useTreeSelectUtils(_ref, treeRef) {
  var data = _ref.data,
    treeProps = _ref.treeProps,
    valueType = _ref.valueType;
  var defaultStore = React.useMemo(function () {
    var store = new treeStore.TreeStore(_objectSpread(_objectSpread({}, treeSelect_defaultProps.treeSelectDefaultProps.treeProps), treeProps));
    store.append(data);
    return store;
  }, [data, treeProps]);
  var getNodeItem = hooks_usePersistFn.usePersistFn(function (value) {
    var _defaultStore$getNode;
    if (treeRef.current) {
      return treeRef.current.getItem(value);
    }
    return (_defaultStore$getNode = defaultStore.getNode(value)) === null || _defaultStore$getNode === void 0 ? void 0 : _defaultStore$getNode.getModel();
  });
  var formatValue = hooks_usePersistFn.usePersistFn(function (value) {
    var _treeProps$keys$value, _treeProps$keys, _treeProps$keys$label, _treeProps$keys2;
    var label = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : String(value);
    var valueKey = (_treeProps$keys$value = treeProps === null || treeProps === void 0 || (_treeProps$keys = treeProps.keys) === null || _treeProps$keys === void 0 ? void 0 : _treeProps$keys.value) !== null && _treeProps$keys$value !== void 0 ? _treeProps$keys$value : "value";
    var labelKey = (_treeProps$keys$label = treeProps === null || treeProps === void 0 || (_treeProps$keys2 = treeProps.keys) === null || _treeProps$keys2 === void 0 ? void 0 : _treeProps$keys2.label) !== null && _treeProps$keys$label !== void 0 ? _treeProps$keys$label : "label";
    return value && valueType === "object" ? defineProperty._defineProperty(defineProperty._defineProperty({}, valueKey, value), labelKey, label) : value;
  });
  var normalizeValue = hooks_usePersistFn.usePersistFn(function (value) {
    var _treeProps$keys$value2, _treeProps$keys3, _treeProps$keys$label2, _treeProps$keys4, _ref3, _node$label;
    var valueKey = (_treeProps$keys$value2 = treeProps === null || treeProps === void 0 || (_treeProps$keys3 = treeProps.keys) === null || _treeProps$keys3 === void 0 ? void 0 : _treeProps$keys3.value) !== null && _treeProps$keys$value2 !== void 0 ? _treeProps$keys$value2 : "value";
    var labelKey = (_treeProps$keys$label2 = treeProps === null || treeProps === void 0 || (_treeProps$keys4 = treeProps.keys) === null || _treeProps$keys4 === void 0 ? void 0 : _treeProps$keys4.label) !== null && _treeProps$keys$label2 !== void 0 ? _treeProps$keys$label2 : "label";
    var realValue = valueType === "value" ? value : value === null || value === void 0 ? void 0 : value[valueKey];
    var node = getNodeItem(realValue);
    var realLabel = valueType === "object" ? value === null || value === void 0 ? void 0 : value[labelKey] : void 0;
    return {
      value: realValue,
      label: (_ref3 = (_node$label = node === null || node === void 0 ? void 0 : node.label) !== null && _node$label !== void 0 ? _node$label : realLabel) !== null && _ref3 !== void 0 ? _ref3 : String(realValue)
    };
  });
  return {
    getNodeItem: getNodeItem,
    formatValue: formatValue,
    normalizeValue: normalizeValue
  };
};

exports.useTreeSelectUtils = useTreeSelectUtils;
//# sourceMappingURL=useTreeSelectUtils.js.map
