import React from 'react';
import TreeNode from '@tdesign/common-js/tree-v1/tree-node';
import type { TdTreeProps } from './type';
import type { TreeItemProps } from './interface';
/**
 * 树节点组件
 */
declare const TreeItem: React.ForwardRefExoticComponent<TreeItemProps & {
    onTreeItemMounted?: (rowData: {
        ref: HTMLElement;
        data: TreeNode;
    }) => void;
    isVirtual?: boolean;
    keys: TdTreeProps["keys"];
    allowDrop?: TdTreeProps["allowDrop"];
} & React.RefAttributes<HTMLDivElement>>;
export default TreeItem;
