/**
 * tdesign v1.13.1
 * (c) 2025 tdesign
 * @license MIT
 */

'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var toConsumableArray = require('../../_chunks/dep-210ce7c8.js');
var defineProperty = require('../../_chunks/dep-7a6528ec.js');
var React = require('react');
var classNames = require('classnames');
var tdesignIconsReact = require('tdesign-icons-react');
var utils = require('../../_chunks/dep-cb5dac3c.js');
var link_index = require('../../link/index.js');
var hooks_useCommonClassName = require('../../hooks/useCommonClassName.js');
var loading_index = require('../../loading/index.js');
var upload_hooks_useDrag = require('../hooks/useDrag.js');
var hooks_useGlobalIcon = require('../../hooks/useGlobalIcon.js');
var imageViewer_index = require('../../image-viewer/index.js');
var _util_parseTNode = require('../../_util/parseTNode.js');
var image_index = require('../../image/index.js');
require('../../_chunks/dep-7e3b8125.js');
require('../../_chunks/dep-c83f28a0.js');
require('../../_chunks/dep-cc4e3925.js');
require('../../link/Link.js');
require('../../_chunks/dep-e358a1dc.js');
require('../../hooks/useConfig.js');
require('../../config-provider/ConfigContext.js');
require('../../_chunks/dep-1debbc3e.js');
require('../../_chunks/dep-b4e78a42.js');
require('dayjs');
require('../../_chunks/dep-fdd584c5.js');
require('../../_chunks/dep-84fd1465.js');
require('../../_chunks/dep-023db433.js');
require('../../_chunks/dep-912bd8a2.js');
require('../../_chunks/dep-0fccdcfb.js');
require('../../_chunks/dep-78e8fc97.js');
require('../../_chunks/dep-77879fb6.js');
require('../../_chunks/dep-356859aa.js');
require('../../_chunks/dep-e2240b05.js');
require('../../_chunks/dep-837f0312.js');
require('../../_chunks/dep-413bc6a7.js');
require('../../_chunks/dep-84d18206.js');
require('../../_chunks/dep-5e1fc2cd.js');
require('../../_chunks/dep-0be4d457.js');
require('../../_chunks/dep-6058edb6.js');
require('../../_chunks/dep-cfe601e8.js');
require('../../_chunks/dep-6c342676.js');
require('../../_chunks/dep-8bd04901.js');
require('../../_chunks/dep-2f3e85f6.js');
require('../../_chunks/dep-3cfcca89.js');
require('../../_chunks/dep-64afded1.js');
require('../../_chunks/dep-a1d853fb.js');
require('../../hooks/useDefaultProps.js');
require('../../link/defaultProps.js');
require('../../loading/Loading.js');
require('../../_chunks/dep-3012da29.js');
require('../../_chunks/dep-68db2ca6.js');
require('../../_chunks/dep-6e448b65.js');
require('../../common/Portal.js');
require('react-dom');
require('../../hooks/useLayoutEffect.js');
require('../../loading/gradient.js');
require('../../_chunks/dep-8593a497.js');
require('../../_chunks/dep-f34d3a30.js');
require('../../_chunks/dep-b47ed304.js');
require('../../hooks/useDomRefCallback.js');
require('../../loading/defaultProps.js');
require('../../loading/plugin.js');
require('../../_util/react-render.js');
require('../../_chunks/dep-608840a8.js');
require('../../common/PluginContainer.js');
require('../../config-provider/ConfigProvider.js');
require('../../_chunks/dep-34def105.js');
require('../../_chunks/dep-cc2fe55a.js');
require('../../_chunks/dep-680d1e3e.js');
require('../../_chunks/dep-a3962a45.js');
require('../../_chunks/dep-b6bde0bc.js');
require('../../_chunks/dep-f90d944e.js');
require('../../_chunks/dep-46616204.js');
require('../../image-viewer/ImageViewer.js');
require('../../_chunks/dep-92f915f5.js');
require('../../_chunks/dep-006cdaa7.js');
require('../../hooks/useImagePreviewUrl.js');
require('../../locale/LocalReceiver.js');
require('../../tooltip/index.js');
require('../../tooltip/Tooltip.js');
require('../../popup/index.js');
require('../../popup/Popup.js');
require('react-transition-group');
require('../../_util/ref.js');
require('react-is');
require('../../_util/isFragment.js');
require('../../hooks/useAnimation.js');
require('../../hooks/useAttach.js');
require('../../hooks/useControlled.js');
require('../../_util/noop.js');
require('../../_chunks/dep-00e10ad8.js');
require('../../_chunks/dep-5d5d7b13.js');
require('../../_chunks/dep-ba207e81.js');
require('../../_chunks/dep-ed0d1cf9.js');
require('../../_chunks/dep-665eea2b.js');
require('../../hooks/useMutationObserver.js');
require('../../hooks/useLatest.js');
require('../../_chunks/dep-c73e0aa5.js');
require('../../_chunks/dep-becc25b2.js');
require('../../_chunks/dep-ba79870d.js');
require('../../_chunks/dep-7bb447f9.js');
require('../../_chunks/dep-5941343f.js');
require('../../hooks/usePopper.js');
require('@popperjs/core');
require('react-fast-compare');
require('../../hooks/useWindowSize.js');
require('../../popup/defaultProps.js');
require('../../popup/hooks/useTrigger.js');
require('../../_util/composeRefs.js');
require('../../_util/listener.js');
require('../../popup/utils/transition.js');
require('../../popup/PopupPlugin.js');
require('../../tooltip/defaultProps.js');
require('../../tooltip/TooltipLite.js');
require('../../hooks/useSwitch.js');
require('../../hooks/usePersistFn.js');
require('../../_chunks/dep-8c89cfa8.js');
require('../../dialog/index.js');
require('../../dialog/Dialog.js');
require('../../hooks/useSetState.js');
require('../../dialog/defaultProps.js');
require('../../dialog/DialogCard.js');
require('../../button/index.js');
require('../../button/Button.js');
require('../../hooks/useRipple.js');
require('../../button/defaultProps.js');
require('../../dialog/hooks/useDialogEsc.js');
require('../../dialog/hooks/useLockStyle.js');
require('../../_chunks/dep-d9b4b0dc.js');
require('../../dialog/hooks/useDialogPosition.js');
require('../../dialog/hooks/useDialogDrag.js');
require('../../dialog/utils.js');
require('../../_chunks/dep-dfe5fb78.js');
require('../../dialog/plugin.js');
require('../../image-viewer/hooks/useIconMap.js');
require('../../image-viewer/hooks/useIndex.js');
require('../../image-viewer/hooks/useMirror.js');
require('../../image-viewer/hooks/usePosition.js');
require('../../image-viewer/hooks/useRotate.js');
require('../../image-viewer/hooks/useScale.js');
require('../../image-viewer/utils.js');
require('../../image-viewer/defaultProps.js');
require('../../image-viewer/hooks/useImageScale.js');
require('../../image-viewer/hooks/useList.js');
require('../../image-viewer/hooks/useViewerScale.js');
require('../../image/Image.js');
require('../../_chunks/dep-3905781f.js');
require('../../image/defaultProps.js');
require('../../space/index.js');
require('../../space/Space.js');
require('../../space/defaultProps.js');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

var React__default = /*#__PURE__*/_interopDefaultLegacy(React);
var classNames__default = /*#__PURE__*/_interopDefaultLegacy(classNames);

function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { defineProperty._defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
var DraggerFile = function DraggerFile(props) {
  var displayFiles = props.displayFiles,
    locale = props.locale,
    disabled = props.disabled,
    trigger = props.trigger,
    accept = props.accept;
  var _useCommonClassName = hooks_useCommonClassName["default"](),
    SIZE = _useCommonClassName.SIZE;
  var uploadPrefix = "".concat(props.classPrefix, "-upload");
  var drag = upload_hooks_useDrag["default"](_objectSpread(_objectSpread({}, props.dragEvents), {}, {
    accept: accept
  }));
  var dragActive = drag.dragActive;
  var draggerFileRef = React.useRef(null);
  var _useGlobalIcon = hooks_useGlobalIcon["default"]({
      CheckCircleFilledIcon: tdesignIconsReact.CheckCircleFilledIcon,
      ErrorCircleFilledIcon: tdesignIconsReact.ErrorCircleFilledIcon
    }),
    CheckCircleFilledIcon = _useGlobalIcon.CheckCircleFilledIcon,
    ErrorCircleFilledIcon = _useGlobalIcon.ErrorCircleFilledIcon;
  var classes = React.useMemo(function () {
    var _displayFiles$;
    return ["".concat(uploadPrefix, "__dragger"), defineProperty._defineProperty({}, "".concat(uploadPrefix, "__dragger-center"), !displayFiles[0]), defineProperty._defineProperty({}, "".concat(uploadPrefix, "__dragger-error"), ((_displayFiles$ = displayFiles[0]) === null || _displayFiles$ === void 0 ? void 0 : _displayFiles$.status) === "fail")];
  }, [displayFiles, uploadPrefix]);
  var renderImage = function renderImage() {
    var _file$response;
    var file = displayFiles[0];
    var url = (file === null || file === void 0 ? void 0 : file.url) || (file === null || file === void 0 || (_file$response = file.response) === null || _file$response === void 0 ? void 0 : _file$response.url);
    return /* @__PURE__ */React__default["default"].createElement("div", {
      className: "".concat(uploadPrefix, "__dragger-img-wrap")
    }, /* @__PURE__ */React__default["default"].createElement(imageViewer_index.ImageViewer, _objectSpread({
      images: [url],
      trigger: function trigger(_ref3) {
        var open = _ref3.open;
        return /* @__PURE__ */React__default["default"].createElement(image_index.Image, {
          src: url || file.raw,
          onClick: open
        });
      }
    }, props.imageViewerProps)));
  };
  var renderUploading = function renderUploading() {
    var file = displayFiles[0];
    if ((file === null || file === void 0 ? void 0 : file.status) === "progress") {
      return /* @__PURE__ */React__default["default"].createElement("div", {
        className: "".concat(uploadPrefix, "__single-progress")
      }, /* @__PURE__ */React__default["default"].createElement(loading_index.Loading, null), /* @__PURE__ */React__default["default"].createElement("span", {
        className: "".concat(uploadPrefix, "__single-percent")
      }, file.percent, "%"));
    }
  };
  var renderMainPreview = function renderMainPreview() {
    var file = displayFiles[0];
    var fileName = props.abridgeName ? utils.abridgeName.apply(void 0, [file.name].concat(toConsumableArray._toConsumableArray(props.abridgeName))) : file.name;
    var fileInfo = /* @__PURE__ */React__default["default"].createElement(React__default["default"].Fragment, null, /* @__PURE__ */React__default["default"].createElement("div", {
      className: "".concat(uploadPrefix, "__dragger-text")
    }, /* @__PURE__ */React__default["default"].createElement("span", {
      className: "".concat(uploadPrefix, "__single-name")
    }, fileName), file.status === "progress" && renderUploading(), file.status === "success" && /* @__PURE__ */React__default["default"].createElement(CheckCircleFilledIcon, null), file.status === "fail" && /* @__PURE__ */React__default["default"].createElement(ErrorCircleFilledIcon, null)), /* @__PURE__ */React__default["default"].createElement("small", {
      className: "".concat(SIZE.small)
    }, locale.file.fileSizeText, "\uFF1A", utils.getFileSizeText(file.size)), /* @__PURE__ */React__default["default"].createElement("small", {
      className: "".concat(SIZE.small)
    }, locale.file.fileOperationDateText, "\uFF1A", file.uploadTime || "-"));
    return /* @__PURE__ */React__default["default"].createElement("div", {
      className: "".concat(uploadPrefix, "__dragger-progress")
    }, props.theme === "image" && renderImage(), /* @__PURE__ */React__default["default"].createElement("div", {
      className: "".concat(uploadPrefix, "__dragger-progress-info")
    }, props.fileListDisplay ? _util_parseTNode.parseContentTNode(props.fileListDisplay, {
      files: displayFiles
    }) : fileInfo, /* @__PURE__ */React__default["default"].createElement("div", {
      className: "".concat(uploadPrefix, "__dragger-btns")
    }, ["progress", "waiting"].includes(file.status) && !disabled && /* @__PURE__ */React__default["default"].createElement(link_index.Link, {
      theme: "primary",
      hover: "color",
      disabled: disabled,
      className: "".concat(uploadPrefix, "__dragger-progress-cancel"),
      onClick: function onClick(e) {
        var _props$cancelUpload;
        return (_props$cancelUpload = props.cancelUpload) === null || _props$cancelUpload === void 0 ? void 0 : _props$cancelUpload.call(props, {
          e: e,
          file: props.toUploadFiles[0] || props.files[0]
        });
      }
    }, locale === null || locale === void 0 ? void 0 : locale.cancelUploadText), !props.autoUpload && file.status === "waiting" && /* @__PURE__ */React__default["default"].createElement(link_index.Link, {
      theme: "primary",
      hover: "color",
      disabled: disabled,
      onClick: function onClick() {
        var _props$uploadFiles;
        return (_props$uploadFiles = props.uploadFiles) === null || _props$uploadFiles === void 0 ? void 0 : _props$uploadFiles.call(props);
      },
      className: "".concat(uploadPrefix, "__dragger-upload-btn")
    }, locale.triggerUploadText.normal)), ["fail", "success"].includes(file === null || file === void 0 ? void 0 : file.status) && !disabled && /* @__PURE__ */React__default["default"].createElement("div", {
      className: "".concat(uploadPrefix, "__dragger-btns")
    }, /* @__PURE__ */React__default["default"].createElement(link_index.Link, {
      theme: "primary",
      hover: "color",
      disabled: disabled,
      className: "".concat(uploadPrefix, "__dragger-progress-reupload"),
      onClick: props.triggerUpload
    }, locale.triggerUploadText.reupload), /* @__PURE__ */React__default["default"].createElement(link_index.Link, {
      theme: "danger",
      hover: "color",
      disabled: disabled,
      className: "".concat(uploadPrefix, "__dragger-delete-btn"),
      onClick: function onClick(e) {
        return props.onRemove({
          e: e,
          index: 0,
          file: file
        });
      }
    }, locale.triggerUploadText["delete"]))));
  };
  var renderDefaultDragElement = function renderDefaultDragElement() {
    var _locale$triggerUpload;
    var unActiveElement = /* @__PURE__ */React__default["default"].createElement("div", null, /* @__PURE__ */React__default["default"].createElement("span", {
      className: "".concat(uploadPrefix, "--highlight")
    }, (_locale$triggerUpload = locale.triggerUploadText) === null || _locale$triggerUpload === void 0 ? void 0 : _locale$triggerUpload.normal), /* @__PURE__ */React__default["default"].createElement("span", null, "\xA0\xA0/\xA0\xA0", locale.dragger.draggingText));
    var activeElement = /* @__PURE__ */React__default["default"].createElement("div", null, locale.dragger.dragDropText);
    return dragActive ? activeElement : unActiveElement;
  };
  var getContent = function getContent() {
    var file = displayFiles[0];
    if (file && (["progress", "success", "fail", "waiting"].includes(file.status) || !file.status)) {
      return renderMainPreview();
    }
    return /* @__PURE__ */React__default["default"].createElement("div", {
      className: "".concat(uploadPrefix, "__trigger"),
      onClick: props.triggerUpload
    }, props.children || renderDefaultDragElement());
  };
  return /* @__PURE__ */React__default["default"].createElement("div", {
    ref: draggerFileRef,
    className: classNames__default["default"](classes),
    onDrop: drag.handleDrop,
    onDragEnter: drag.handleDragenter,
    onDragOver: drag.handleDragover,
    onDragLeave: drag.handleDragleave
  }, (_util_parseTNode.parseContentTNode === null || _util_parseTNode.parseContentTNode === void 0 ? void 0 : _util_parseTNode.parseContentTNode(trigger, {
    files: displayFiles,
    dragActive: dragActive
  })) || getContent());
};
DraggerFile.displayName = "DraggerFile";

exports["default"] = DraggerFile;
//# sourceMappingURL=DraggerFile.js.map
