import React, { ReactNode } from 'react';
import { TNode } from '../common';
export default function parseTNode(renderNode: TNode | TNode<any> | undefined, renderParams?: any, defaultNode?: ReactNode): ReactNode;
/**
 * 解析各种数据类型的 TNode
 * 函数类型：content={(props) => <Icon></Icon>}
 * 组件类型：content={<Button>click me</Button>} 这种方式可以避免函数重复渲染，对应的 props 已经注入
 * 字符类型
 */
export declare function parseContentTNode<T>(tnode: TNode<T>, props: T): string | number | boolean | React.ReactElement<any, string | React.JSXElementConstructor<any>> | Iterable<React.ReactNode>;
