/**
 * tdesign v1.13.1
 * (c) 2025 tdesign
 * @license MIT
 */

import { _ as _slicedToArray } from '../_chunks/dep-5965bf34.js';
import { useState, useEffect } from 'react';
import '../_chunks/dep-8780bcdf.js';

var useScroll = function useScroll(props) {
  var target = props.target;
  var _useState = useState(0),
    _useState2 = _slicedToArray(_useState, 2),
    scrollLeft = _useState2[0],
    setScrollLeft = _useState2[1];
  var _useState3 = useState(0),
    _useState4 = _slicedToArray(_useState3, 2),
    scrollTop = _useState4[0],
    setScrollTop = _useState4[1];
  useEffect(function () {
    if (!target) return;
    var setPosition = function setPosition() {
      if (target === document) {
        setScrollLeft(target.documentElement.scrollLeft);
        setScrollTop(target.documentElement.scrollTop);
      } else {
        setScrollLeft(target.scrollLeft);
        setScrollTop(target.scrollTop);
      }
    };
    target.addEventListener("scroll", setPosition);
    return function () {
      target.removeEventListener("scroll", setPosition);
    };
  }, [target]);
  return {
    scrollLeft: scrollLeft,
    scrollTop: scrollTop
  };
};

export { useScroll as default };
//# sourceMappingURL=useScroll.js.map
