/**
 * tdesign v1.13.1
 * (c) 2025 tdesign
 * @license MIT
 */

import { _ as _defineProperty } from '../../_chunks/dep-4d3bcd6b.js';
import { _ as _slicedToArray } from '../../_chunks/dep-5965bf34.js';
import React from 'react';
import classNames from 'classnames';
import { useLocaleReceiver } from '../../locale/LocalReceiver.js';
import { Button } from '../../button/index.js';
import useConfig from '../../hooks/useConfig.js';
import '../../_chunks/dep-b703e6a4.js';
import '../../_chunks/dep-8780bcdf.js';
import 'lodash-es';
import '../../config-provider/index.js';
import '../../config-provider/ConfigProvider.js';
import '../../config-provider/ConfigContext.js';
import '../../locale/zh_CN.js';
import '../../_chunks/dep-8e2f260a.js';
import 'dayjs';
import '../../_chunks/dep-11419884.js';
import '../../config-provider/type.js';
import '../../button/Button.js';
import '../../_chunks/dep-3be76470.js';
import '../../hooks/useDomRefCallback.js';
import '../../hooks/useRipple.js';
import '../../_chunks/dep-8c2d2a8b.js';
import '../../hooks/useAnimation.js';
import '../../_chunks/dep-f1a86416.js';
import '../../loading/index.js';
import '../../loading/Loading.js';
import '../../common/Portal.js';
import 'react-dom';
import '../../hooks/useLayoutEffect.js';
import '../../loading/gradient.js';
import '../../_chunks/dep-a03c72be.js';
import '../../_chunks/dep-80f26a18.js';
import '../../loading/defaultProps.js';
import '../../hooks/useDefaultProps.js';
import '../../loading/plugin.js';
import '../../_util/react-render.js';
import '../../_chunks/dep-b5cee20d.js';
import '../../common/PluginContainer.js';
import '../../loading/style/css.js';
import '../../loading/type.js';
import '../../button/defaultProps.js';
import '../../_util/parseTNode.js';
import '../../_chunks/dep-07f6ec14.js';
import '../../_chunks/dep-d564deee.js';
import '../../button/style/css.js';
import '../../button/type.js';

var DatePickerFooter = function DatePickerFooter(props) {
  var _useLocaleReceiver = useLocaleReceiver("datePicker"),
    _useLocaleReceiver2 = _slicedToArray(_useLocaleReceiver, 2),
    local = _useLocaleReceiver2[0],
    t = _useLocaleReceiver2[1];
  var confirmText = t(local.confirm);
  var _useConfig = useConfig(),
    classPrefix = _useConfig.classPrefix;
  var enableTimePicker = props.enableTimePicker,
    onConfirmClick = props.onConfirmClick,
    _props$presetsPlaceme = props.presetsPlacement,
    presetsPlacement = _props$presetsPlaceme === void 0 ? "bottom" : _props$presetsPlaceme,
    presets = props.presets,
    onPresetClick = props.onPresetClick,
    selectedValue = props.selectedValue,
    needConfirm = props.needConfirm;
  var footerClass = classNames("".concat(classPrefix, "-date-picker__footer"), "".concat(classPrefix, "-date-picker__footer--").concat(presetsPlacement));
  return /* @__PURE__ */React.createElement("div", {
    className: footerClass
  }, /* @__PURE__ */React.createElement("div", {
    className: "".concat(classPrefix, "-date-picker__presets")
  }, presets && Object.keys(presets).map(function (key) {
    return /* @__PURE__ */React.createElement(Button, {
      key: key,
      size: "small",
      variant: "text",
      onClick: function onClick(e) {
        return onPresetClick(presets[key], {
          e: e,
          preset: _defineProperty({}, key, presets[key])
        });
      }
    }, key);
  })), enableTimePicker && needConfirm && /* @__PURE__ */React.createElement(Button, {
    disabled: !selectedValue,
    size: "small",
    theme: "primary",
    onClick: function onClick(e) {
      return onConfirmClick({
        e: e
      });
    }
  }, confirmText));
};
DatePickerFooter.displayName = "DatePickerFooter";

export { DatePickerFooter as default };
//# sourceMappingURL=Footer.js.map
