/**
 * tdesign v1.13.1
 * (c) 2025 tdesign
 * @license MIT
 */

import { isObject } from 'lodash-es';
import dayjs from 'dayjs';
import { j as isEnabledDate } from '../../_chunks/dep-44ce7d72.js';
import '../../_chunks/dep-5965bf34.js';
import '../../_chunks/dep-8780bcdf.js';
import '../../_chunks/dep-4d3bcd6b.js';
import '../../_chunks/dep-b703e6a4.js';
import '../../_chunks/dep-8e2f260a.js';
import '../../_chunks/dep-a91fb9a2.js';
import '../../_chunks/dep-6d787b66.js';
import '../../_chunks/dep-07f6ec14.js';
import '../../_chunks/dep-d564deee.js';

function useDisableDate(props) {
  var _disableDate = props.disableDate,
    format = props.format,
    mode = props.mode,
    start = props.start,
    end = props.end;
  return {
    disableDate: function disableDate(value) {
      return !isEnabledDate({
        disableDate: _disableDate,
        format: format,
        mode: mode,
        value: value
      });
    },
    minDate: isObject(_disableDate) && "before" in _disableDate ? new Date(dayjs(_disableDate.before).startOf("day").format()) : start,
    maxDate: isObject(_disableDate) && "after" in _disableDate ? new Date(dayjs(_disableDate.after).endOf("day").format()) : end
  };
}

export { useDisableDate as default };
//# sourceMappingURL=useDisableDate.js.map
