/**
 * tdesign v1.13.1
 * (c) 2025 tdesign
 * @license MIT
 */

import React from 'react';
import DatePickerFooter from '../base/Footer.js';
import '../../_chunks/dep-4d3bcd6b.js';
import '../../_chunks/dep-b703e6a4.js';
import '../../_chunks/dep-5965bf34.js';
import '../../_chunks/dep-8780bcdf.js';
import 'classnames';
import '../../locale/LocalReceiver.js';
import 'lodash-es';
import '../../config-provider/index.js';
import '../../config-provider/ConfigProvider.js';
import '../../config-provider/ConfigContext.js';
import '../../locale/zh_CN.js';
import '../../_chunks/dep-8e2f260a.js';
import 'dayjs';
import '../../_chunks/dep-11419884.js';
import '../../config-provider/type.js';
import '../../button/index.js';
import '../../button/Button.js';
import '../../_chunks/dep-3be76470.js';
import '../../hooks/useConfig.js';
import '../../hooks/useDomRefCallback.js';
import '../../hooks/useRipple.js';
import '../../_chunks/dep-8c2d2a8b.js';
import '../../hooks/useAnimation.js';
import '../../_chunks/dep-f1a86416.js';
import '../../loading/index.js';
import '../../loading/Loading.js';
import '../../common/Portal.js';
import 'react-dom';
import '../../hooks/useLayoutEffect.js';
import '../../loading/gradient.js';
import '../../_chunks/dep-a03c72be.js';
import '../../_chunks/dep-80f26a18.js';
import '../../loading/defaultProps.js';
import '../../hooks/useDefaultProps.js';
import '../../loading/plugin.js';
import '../../_util/react-render.js';
import '../../_chunks/dep-b5cee20d.js';
import '../../common/PluginContainer.js';
import '../../loading/style/css.js';
import '../../loading/type.js';
import '../../button/defaultProps.js';
import '../../_util/parseTNode.js';
import '../../_chunks/dep-07f6ec14.js';
import '../../_chunks/dep-d564deee.js';
import '../../button/style/css.js';
import '../../button/type.js';

function ExtraContent(props) {
  var presets = props.presets,
    enableTimePicker = props.enableTimePicker,
    presetsPlacement = props.presetsPlacement,
    onPresetClick = props.onPresetClick,
    onConfirmClick = props.onConfirmClick,
    selectedValue = props.selectedValue,
    needConfirm = props.needConfirm;
  var showPanelFooter = enableTimePicker && needConfirm || presets;
  return showPanelFooter ? /* @__PURE__ */React.createElement(DatePickerFooter, {
    presets: presets,
    onPresetClick: onPresetClick,
    enableTimePicker: enableTimePicker,
    onConfirmClick: onConfirmClick,
    presetsPlacement: presetsPlacement,
    selectedValue: selectedValue,
    needConfirm: needConfirm
  }) : null;
}

export { ExtraContent as default };
//# sourceMappingURL=ExtraContent.js.map
