/**
 * tdesign v1.13.1
 * (c) 2025 tdesign
 * @license MIT
 */

import React from 'react';
import { checkIsSubMenu, checkIsMenuItem } from './checkMenuType.js';
import './type.js';

var _checkSubMenuChildrenActive = function checkSubMenuChildrenActive(children, active) {
  var activeFlag = false;
  React.Children.forEach(children, function (child) {
    if (activeFlag) return;
    if (checkIsSubMenu(child)) {
      activeFlag = _checkSubMenuChildrenActive(child.props.children, active);
    } else if (checkIsMenuItem(child)) {
      activeFlag = active === child.props.value ? true : activeFlag;
    }
  });
  return activeFlag;
};

export { _checkSubMenuChildrenActive as default };
//# sourceMappingURL=checkSubMenuChildrenActive.js.map
