/**
 * tdesign v1.13.1
 * (c) 2025 tdesign
 * @license MIT
 */

import { _ as _slicedToArray } from '../../_chunks/dep-5965bf34.js';
import React from 'react';
import useConfig from '../../hooks/useConfig.js';
import { useLocaleReceiver } from '../../locale/LocalReceiver.js';
import '../../_chunks/dep-8780bcdf.js';
import '../../config-provider/ConfigContext.js';
import '../../_chunks/dep-4d3bcd6b.js';
import '../../_chunks/dep-b703e6a4.js';
import 'lodash-es';
import '../../locale/zh_CN.js';
import '../../_chunks/dep-8e2f260a.js';
import 'dayjs';
import '../../_chunks/dep-11419884.js';
import '../../config-provider/index.js';
import '../../config-provider/ConfigProvider.js';
import '../../config-provider/type.js';

function useTotal(props) {
  var _useLocaleReceiver = useLocaleReceiver("pagination"),
    _useLocaleReceiver2 = _slicedToArray(_useLocaleReceiver, 2),
    locale = _useLocaleReceiver2[0],
    t = _useLocaleReceiver2[1];
  var _useConfig = useConfig(),
    classPrefix = _useConfig.classPrefix;
  var name = "".concat(classPrefix, "-pagination");
  var totalContent = props.totalContent,
    pageSize = props.pageSize,
    current = props.current,
    total = props.total;
  var totalControl = null;
  if (totalContent === false) return {
    totalControl: totalControl
  };
  var renderTotalContent = function renderTotalContent() {
    if (typeof totalContent === "boolean") {
      return totalContent ? t(locale.total, total) : null;
    }
    if (typeof totalContent === "function") {
      var start = (current - 1) * pageSize;
      var end = Math.min(total, start + pageSize);
      return totalContent(total, [start + 1, end]);
    }
    return totalContent;
  };
  totalControl = /* @__PURE__ */React.createElement("div", {
    className: "".concat(name, "__total")
  }, renderTotalContent());
  return {
    totalControl: totalControl
  };
}

export { useTotal as default };
//# sourceMappingURL=useTotal.js.map
