/**
 * tdesign v1.13.1
 * (c) 2025 tdesign
 * @license MIT
 */

import React, { useMemo, useCallback } from 'react';
import { RefreshIcon, CheckCircleFilledIcon } from 'tdesign-icons-react';
import { Loading } from '../loading/index.js';
import '../loading/Loading.js';
import '../_chunks/dep-4d3bcd6b.js';
import '../_chunks/dep-b703e6a4.js';
import '../_chunks/dep-5965bf34.js';
import '../_chunks/dep-8780bcdf.js';
import 'classnames';
import '../_chunks/dep-f1a86416.js';
import 'lodash-es';
import '../hooks/useConfig.js';
import '../config-provider/ConfigContext.js';
import '../locale/zh_CN.js';
import '../_chunks/dep-8e2f260a.js';
import 'dayjs';
import '../_chunks/dep-11419884.js';
import '../common/Portal.js';
import 'react-dom';
import '../hooks/useLayoutEffect.js';
import '../loading/gradient.js';
import '../_chunks/dep-8c2d2a8b.js';
import '../_chunks/dep-a03c72be.js';
import '../_chunks/dep-80f26a18.js';
import '../_chunks/dep-3be76470.js';
import '../hooks/useDomRefCallback.js';
import '../loading/defaultProps.js';
import '../hooks/useDefaultProps.js';
import '../loading/plugin.js';
import '../_util/react-render.js';
import '../_chunks/dep-b5cee20d.js';
import '../common/PluginContainer.js';
import '../config-provider/index.js';
import '../config-provider/ConfigProvider.js';
import '../config-provider/type.js';
import '../loading/style/css.js';
import '../loading/type.js';

var defaultSpin = /* @__PURE__ */React.createElement(Loading, {
  size: "32px"
});
function QRcodeStatus(_ref) {
  var locale = _ref.locale,
    classPrefix = _ref.classPrefix,
    onRefresh = _ref.onRefresh,
    statusRender = _ref.statusRender,
    status = _ref.status;
  var defaultExpiredNode = useMemo(function () {
    return /* @__PURE__ */React.createElement(React.Fragment, null, /* @__PURE__ */React.createElement("p", {
      className: "".concat(classPrefix, "-expired__text")
    }, locale === null || locale === void 0 ? void 0 : locale.expiredText), onRefresh && /* @__PURE__ */React.createElement("p", {
      className: "".concat(classPrefix, "-expired__button"),
      onClick: onRefresh
    }, /* @__PURE__ */React.createElement(RefreshIcon, {
      size: 16
    }), locale === null || locale === void 0 ? void 0 : locale.refreshText));
  }, [classPrefix, locale === null || locale === void 0 ? void 0 : locale.expiredText, locale === null || locale === void 0 ? void 0 : locale.refreshText, onRefresh]);
  var defaultScannedNode = useMemo(function () {
    return /* @__PURE__ */React.createElement("p", {
      className: "".concat(classPrefix, "-scanned")
    }, /* @__PURE__ */React.createElement(CheckCircleFilledIcon, {
      size: 16,
      className: "".concat(classPrefix, "-scanned__icon")
    }), locale === null || locale === void 0 ? void 0 : locale.scannedText);
  }, [classPrefix, locale === null || locale === void 0 ? void 0 : locale.scannedText]);
  var defaultNodes = useMemo(function () {
    return {
      expired: defaultExpiredNode,
      loading: defaultSpin,
      scanned: defaultScannedNode
    };
  }, [defaultExpiredNode, defaultScannedNode]);
  var defaultStatusRender = useCallback(function (info) {
    return defaultNodes[info.status];
  }, [defaultNodes]);
  var mergedStatusRender = statusRender !== null && statusRender !== void 0 ? statusRender : defaultStatusRender;
  return /* @__PURE__ */React.createElement(React.Fragment, null, mergedStatusRender({
    status: status,
    onRefresh: onRefresh
  }) || null);
}

export { QRcodeStatus as default };
//# sourceMappingURL=QRCodeStatus.js.map
