/**
 * tdesign v1.13.1
 * (c) 2025 tdesign
 * @license MIT
 */

import { useMemo } from 'react';
import '../_chunks/dep-07f6ec14.js';
import { l as log } from '../_chunks/dep-d564deee.js';

var DefaultAlign = {
  vertical: ["left", "right"],
  horizontal: ["top", "bottom"]
};
var useAlign = function useAlign(align) {
  var layout = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : "vertical";
  return useMemo(function () {
    var renderAlign = layout === "vertical" ? "left" : "top";
    if (layout === "vertical" && align) {
      var index = DefaultAlign.horizontal.indexOf(align);
      var isError = index !== -1;
      isError && log.warn("Timeline", 'If layout is vertical, align should be "left","alternate" or "right" ');
      renderAlign = isError ? DefaultAlign.vertical[index] : align;
    }
    if (layout === "horizontal" && align) {
      var _index = DefaultAlign.vertical.indexOf(align);
      var _isError = _index !== -1;
      _isError && log.warn("Timeline", 'If layout is horizontal, align should be "top","alternate" or "bottom" ');
      renderAlign = _isError ? DefaultAlign.horizontal[_index] : align;
    }
    return renderAlign;
  }, [align, layout]);
};

export { useAlign };
//# sourceMappingURL=useAlign.js.map
