import { CSSProperties } from 'react';
import TreeNode from '@tdesign/common-js/tree-v1/tree-node';
import { TScroll } from '../../common';
import type { TdTreeProps } from '../type';
export default function useTreeVirtualScroll({ treeRef, scroll, data, onScroll, }: {
    data: TreeNode[];
    scroll: TScroll;
    treeRef: React.MutableRefObject<HTMLElement>;
    onScroll: TdTreeProps['onScroll'];
}): {
    scrollHeight: number;
    translateY: number;
    visibleData: any[];
    handleRowMounted: (rowData: any) => void;
    isVirtual: boolean;
    cursorStyle: CSSProperties;
    treeNodeStyle: CSSProperties;
    scrollToElement: (p: import("../../common").ScrollToElementParams) => void;
};
