import React, { MouseEvent } from 'react';
import { CalendarCell, TdCalendarProps } from './type';
type extendType = Required<Pick<TdCalendarProps, 'fillWithZero' | 'mode' | 'theme' | 'cell' | 'cellAppend'>>;
interface CalendarCellProps extends extendType {
    cellData: CalendarCell;
    isCurrent: boolean;
    isNow: boolean;
    isDisabled?: boolean;
    createCalendarCell: (cellData: CalendarCell) => CalendarCell;
    onCellClick: (e: MouseEvent<HTMLDivElement>) => void;
    onCellDoubleClick: (e: MouseEvent<HTMLDivElement>) => void;
    onCellRightClick: (e: MouseEvent<HTMLDivElement>) => void;
}
declare const CalendarCellComp: React.FC<CalendarCellProps>;
export default CalendarCellComp;
