/**
 * tdesign v1.13.1
 * (c) 2025 tdesign
 * @license MIT
 */

import { _ as _defineProperty } from '../_chunks/dep-4d3bcd6b.js';
import React from 'react';
import { pick } from 'lodash-es';
import classNames from 'classnames';
import Panel from './components/Panel.js';
import { useCascaderContext } from './hooks.js';
import { cascaderDefaultProps } from './defaultProps.js';
import useDefaultProps from '../hooks/useDefaultProps.js';
import '../_chunks/dep-b703e6a4.js';
import '../_chunks/dep-5965bf34.js';
import '../_chunks/dep-8780bcdf.js';
import './components/Item.js';
import 'tdesign-icons-react';
import '../loading/index.js';
import '../loading/Loading.js';
import '../_chunks/dep-f1a86416.js';
import '../hooks/useConfig.js';
import '../config-provider/ConfigContext.js';
import '../locale/zh_CN.js';
import '../_chunks/dep-8e2f260a.js';
import 'dayjs';
import '../_chunks/dep-11419884.js';
import '../common/Portal.js';
import 'react-dom';
import '../hooks/useLayoutEffect.js';
import '../loading/gradient.js';
import '../_chunks/dep-8c2d2a8b.js';
import '../_chunks/dep-a03c72be.js';
import '../_chunks/dep-80f26a18.js';
import '../_chunks/dep-3be76470.js';
import '../hooks/useDomRefCallback.js';
import '../loading/defaultProps.js';
import '../loading/plugin.js';
import '../_util/react-render.js';
import '../_chunks/dep-b5cee20d.js';
import '../common/PluginContainer.js';
import '../config-provider/index.js';
import '../config-provider/ConfigProvider.js';
import '../config-provider/type.js';
import '../loading/style/index.js';
import '../loading/type.js';
import '../checkbox/index.js';
import '../_chunks/dep-3ca46c75.js';
import '../_util/forwardRefWithStatics.js';
import 'hoist-non-react-statics';
import '../common/Check.js';
import '../_util/helper.js';
import '../hooks/useControlled.js';
import '../_util/noop.js';
import '../checkbox/defaultProps.js';
import '../checkbox/style/index.js';
import '../checkbox/type.js';
import '../hooks/useGlobalIcon.js';
import '../hooks/useCommonClassName.js';
import './core/helper.js';
import './core/className.js';
import '../locale/LocalReceiver.js';
import './core/effect.js';
import '../_util/parseTNode.js';
import '../_chunks/dep-07f6ec14.js';
import '../_chunks/dep-d564deee.js';
import '../_chunks/dep-0e9834b9.js';
import '../_chunks/dep-15a1e181.js';
import 'mitt';
import '../_chunks/dep-f334ffb7.js';

function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
var CascaderPanel = function CascaderPanel(originalProps) {
  var props = useDefaultProps(originalProps, cascaderDefaultProps);
  var _useCascaderContext = useCascaderContext(props),
    cascaderContext = _useCascaderContext.cascaderContext;
  return /* @__PURE__ */React.createElement(Panel, _objectSpread({
    className: classNames(props.className),
    style: props.style,
    cascaderContext: cascaderContext
  }, pick(props, ["trigger", "onChange", "empty", "option"])));
};
CascaderPanel.displayName = "CascaderPanel";

export { CascaderPanel as default };
//# sourceMappingURL=CascaderPanel.js.map
