/**
 * tdesign v1.13.1
 * (c) 2025 tdesign
 * @license MIT
 */

import { _ as _defineProperty } from '../../_chunks/dep-4d3bcd6b.js';
import React from 'react';
import classNames from 'classnames';
import { g as getColorObject, C as Color } from '../../_chunks/dep-b83c6f51.js';
import { Input } from '../../input/index.js';
import useClassNames from '../hooks/useClassNames.js';
import noop from '../../_util/noop.js';
import '../../_chunks/dep-b703e6a4.js';
import '../../_chunks/dep-5965bf34.js';
import '../../_chunks/dep-8780bcdf.js';
import '../../_chunks/dep-15a1e181.js';
import 'tinycolor2';
import '../../_chunks/dep-978c2042.js';
import 'lodash-es';
import '../../input/Input.js';
import '../../_chunks/dep-3be76470.js';
import 'tdesign-icons-react';
import '../../hooks/useLayoutEffect.js';
import '../../_chunks/dep-f1a86416.js';
import '../../_util/forwardRefWithStatics.js';
import 'hoist-non-react-statics';
import '../../hooks/useConfig.js';
import '../../config-provider/ConfigContext.js';
import '../../locale/zh_CN.js';
import '../../_chunks/dep-8e2f260a.js';
import 'dayjs';
import '../../_chunks/dep-11419884.js';
import '../../hooks/useGlobalIcon.js';
import '../../input/InputGroup.js';
import '../../hooks/useControlled.js';
import '../../locale/LocalReceiver.js';
import '../../config-provider/index.js';
import '../../config-provider/ConfigProvider.js';
import '../../config-provider/type.js';
import '../../input/defaultProps.js';
import '../../_util/parseTNode.js';
import '../../_chunks/dep-07f6ec14.js';
import '../../_chunks/dep-d564deee.js';
import '../../input/useLengthLimit.js';
import '../../_chunks/dep-a03c72be.js';
import '../../_chunks/dep-80f26a18.js';
import '../../hooks/useDefaultProps.js';
import '../../input/style/index.js';
import '../../input/type.js';

function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
var ColorPickerTrigger = function ColorPickerTrigger(props) {
  var baseClassName = useClassNames();
  var _props$disabled = props.disabled,
    disabled = _props$disabled === void 0 ? false : _props$disabled,
    _props$borderless = props.borderless,
    borderless = _props$borderless === void 0 ? false : _props$borderless,
    _props$inputProps = props.inputProps,
    inputProps = _props$inputProps === void 0 ? {
      autoWidth: true
    } : _props$inputProps,
    clearable = props.clearable,
    onClear = props.onClear;
  var handleChange = function handleChange(input) {
    if (input !== props.value) {
      var _props$onChange;
      (_props$onChange = props.onChange) === null || _props$onChange === void 0 || _props$onChange.call(props, input, {
        color: getColorObject(new Color(input)),
        trigger: "input"
      });
    }
  };
  return /* @__PURE__ */React.createElement("div", {
    className: "".concat(baseClassName, "__trigger--default")
  }, /* @__PURE__ */React.createElement(Input, _objectSpread(_objectSpread({
    borderless: borderless,
    clearable: clearable
  }, inputProps), {}, {
    value: props.value,
    disabled: disabled,
    label: /* @__PURE__ */React.createElement("div", {
      className: classNames("".concat(baseClassName, "__trigger--default__color"), "".concat(baseClassName, "--bg-alpha"))
    }, /* @__PURE__ */React.createElement("span", {
      className: "color-inner",
      style: {
        background: props.value
      }
    })),
    onChange: handleChange,
    onClear: onClear || noop
  })));
};
var ColorTrigger = /*#__PURE__*/React.memo(ColorPickerTrigger);

export { ColorTrigger as default };
//# sourceMappingURL=trigger.js.map
