/**
 * tdesign v1.13.1
 * (c) 2025 tdesign
 * @license MIT
 */

import { _ as _slicedToArray } from '../../_chunks/dep-5965bf34.js';
import { useCallback } from 'react';
import useControlled from '../../hooks/useControlled.js';
import '../../_chunks/dep-8780bcdf.js';
import 'lodash-es';
import '../../_util/noop.js';

var useIndex = function useIndex(resProps, images) {
  var _useControlled = useControlled(resProps, "index", resProps.onIndexChange),
    _useControlled2 = _slicedToArray(_useControlled, 2),
    index = _useControlled2[0],
    setIndex = _useControlled2[1];
  var next = useCallback(function () {
    var newIndex = index + 1;
    if (newIndex >= images.length) return index;
    setIndex(newIndex, {
      trigger: "next"
    });
  }, [setIndex, index, images.length]);
  var prev = useCallback(function () {
    var newIndex = index - 1 > 0 ? index - 1 : 0;
    setIndex(newIndex, {
      trigger: "prev"
    });
  }, [index, setIndex]);
  return {
    index: index,
    next: next,
    prev: prev,
    setIndex: setIndex
  };
};

export { useIndex as default };
//# sourceMappingURL=useIndex.js.map
