/**
 * tdesign v1.13.1
 * (c) 2025 tdesign
 * @license MIT
 */

import { _ as _defineProperty } from '../../_chunks/dep-4d3bcd6b.js';
import React from 'react';
import classNames from 'classnames';
import { ChevronLeftIcon, ChevronRightIcon } from 'tdesign-icons-react';
import useConfig from '../../hooks/useConfig.js';
import useGlobalIcon from '../../hooks/useGlobalIcon.js';
import '../../_chunks/dep-b703e6a4.js';
import '../../config-provider/ConfigContext.js';
import 'lodash-es';
import '../../locale/zh_CN.js';
import '../../_chunks/dep-8e2f260a.js';
import 'dayjs';
import '../../_chunks/dep-11419884.js';

function usePrevNextJumper(props) {
  var _useConfig = useConfig(),
    classPrefix = _useConfig.classPrefix;
  var _useGlobalIcon = useGlobalIcon({
      ChevronLeftIcon: ChevronLeftIcon,
      ChevronRightIcon: ChevronRightIcon
    }),
    ChevronLeftIcon$1 = _useGlobalIcon.ChevronLeftIcon,
    ChevronRightIcon$1 = _useGlobalIcon.ChevronRightIcon;
  var name = "".concat(classPrefix, "-pagination");
  var showPreviousAndNextBtn = props.showPreviousAndNextBtn,
    disabled = props.disabled,
    current = props.current,
    pageCount = props.pageCount,
    changeCurrent = props.changeCurrent;
  var prevJumper = showPreviousAndNextBtn && /* @__PURE__ */React.createElement("div", {
    className: classNames("".concat(name, "__btn"), "".concat(name, "__btn-prev"), _defineProperty({}, "".concat(classPrefix, "-is-disabled"), disabled || current === 1)),
    onClick: function onClick() {
      if (disabled || current === 1) return;
      changeCurrent(current - 1);
    }
  }, /* @__PURE__ */React.createElement(ChevronLeftIcon$1, null));
  var nextJumper = showPreviousAndNextBtn && /* @__PURE__ */React.createElement("div", {
    className: classNames("".concat(name, "__btn"), "".concat(name, "__btn-next"), _defineProperty({}, "".concat(classPrefix, "-is-disabled"), disabled || current === pageCount)),
    onClick: function onClick() {
      if (disabled || current === pageCount) return;
      changeCurrent(current + 1);
    }
  }, /* @__PURE__ */React.createElement(ChevronRightIcon$1, null));
  return {
    prevJumper: prevJumper,
    nextJumper: nextJumper
  };
}

export { usePrevNextJumper as default };
//# sourceMappingURL=usePrevNextJumper.js.map
