import React from 'react';
import { TdSelectProps, SelectValue, SelectValueChangeTrigger } from '../type';
interface SelectPopupProps extends Pick<TdSelectProps, 'value' | 'size' | 'multiple' | 'empty' | 'options' | 'max' | 'loadingText' | 'loading' | 'valueType' | 'keys' | 'panelTopContent' | 'panelBottomContent' | 'scroll'> {
    onChange?: (value: SelectValue, context?: {
        label?: string | number;
        value?: SelectValue;
        restData?: Record<string, any>;
        e: React.MouseEvent<HTMLLIElement>;
        trigger: SelectValueChangeTrigger;
    }) => void;
    /**
     * 是否展示popup
     */
    showPopup: boolean;
    /**
     * 控制popup展示的函数
     */
    setShowPopup: (show: boolean) => void;
    children?: React.ReactNode;
    onCheckAllChange?: (checkAll: boolean, e: React.MouseEvent<HTMLLIElement>) => void;
    getPopupInstance?: () => HTMLDivElement;
}
declare const PopupContent: React.ForwardRefExoticComponent<SelectPopupProps & React.RefAttributes<HTMLDivElement>>;
export default PopupContent;
