import React, { ForwardRefRenderFunction, FocusEvent } from 'react';
import { StyledProps } from '../common';
import { TdTagProps } from './type';
/**
 * Tag 组件支持的属性。
 */
export interface TagProps extends TdTagProps, StyledProps {
    /**
     * 标签内容
     */
    tabIndex?: number;
    onFocus?: (e: FocusEvent<HTMLDivElement>) => void;
    onBlur?: (e: FocusEvent<HTMLDivElement>) => void;
}
export declare const TagFunction: ForwardRefRenderFunction<HTMLDivElement, TagProps>;
export declare const Tag: React.ForwardRefExoticComponent<TagProps & React.RefAttributes<HTMLDivElement>>;
export default Tag;
