/**
 * tdesign v1.13.1
 * (c) 2025 tdesign
 * @license MIT
 */

import { _ as _defineProperty } from '../_chunks/dep-4d3bcd6b.js';
import { _ as _objectWithoutProperties } from '../_chunks/dep-3be76470.js';
import React, { useContext, useEffect } from 'react';
import classNames from 'classnames';
import useConfig from '../hooks/useConfig.js';
import { AnchorContext } from './AnchorContext.js';
import { anchorItemDefaultProps } from './defaultProps.js';
import useDefaultProps from '../hooks/useDefaultProps.js';
import '../_chunks/dep-b703e6a4.js';
import '../config-provider/ConfigContext.js';
import 'lodash-es';
import '../_chunks/dep-ee1d6f73.js';
import '../_chunks/dep-25abb26d.js';
import 'dayjs';
import '../_util/noop.js';

var _excluded = ["href", "title", "target", "children", "className"];
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
var AnchorItem = function AnchorItem(props) {
  var _useContext = useContext(AnchorContext),
    onClick = _useContext.onClick,
    activeItem = _useContext.activeItem,
    registerItem = _useContext.registerItem,
    unregisterItem = _useContext.unregisterItem;
  var _useDefaultProps = useDefaultProps(props, anchorItemDefaultProps),
    href = _useDefaultProps.href,
    title = _useDefaultProps.title,
    target = _useDefaultProps.target,
    children = _useDefaultProps.children,
    className = _useDefaultProps.className,
    rest = _objectWithoutProperties(_useDefaultProps, _excluded);
  var _useConfig = useConfig(),
    classPrefix = _useConfig.classPrefix;
  var titleAttr = typeof title === "string" ? title : null;
  var handleClick = function handleClick(e) {
    onClick({
      title: titleAttr,
      href: href
    }, e);
  };
  useEffect(function () {
    registerItem(href);
    return function () {
      return unregisterItem(href);
    };
  }, [href, registerItem, unregisterItem]);
  return /* @__PURE__ */React.createElement("div", _objectSpread(_objectSpread({}, rest), {}, {
    className: classNames("".concat(classPrefix, "-anchor__item"), _defineProperty({}, "".concat(classPrefix, "-is-active"), activeItem === href), className)
  }), /* @__PURE__ */React.createElement("a", {
    href: href,
    className: classNames("".concat(classPrefix, "-anchor__item-link")),
    title: titleAttr,
    target: target,
    onClick: function onClick(e) {
      return handleClick(e);
    }
  }, title), children);
};
AnchorItem.displayName = "AnchorItem";

export { AnchorItem as default };
//# sourceMappingURL=AnchorItem.js.map
