/**
 * tdesign v1.13.1
 * (c) 2025 tdesign
 * @license MIT
 */

import { _ as _slicedToArray } from '../../_chunks/dep-5965bf34.js';
import { g as getWeeks, b as getQuarters, d as getMonths, f as getYears, h as flagActive } from '../../_chunks/dep-25c3be77.js';
import { useLocaleReceiver } from '../../locale/LocalReceiver.js';
import '../../_chunks/dep-8780bcdf.js';
import '../../_chunks/dep-4d3bcd6b.js';
import '../../_chunks/dep-b703e6a4.js';
import 'lodash-es';
import 'dayjs';
import '../../_chunks/dep-25abb26d.js';
import '../../_chunks/dep-ec2d65f1.js';
import '../../_chunks/dep-f1e94724.js';
import '../../_chunks/dep-d564deee.js';
import 'react';
import '../../config-provider/ConfigProvider.js';
import '../../config-provider/ConfigContext.js';
import '../../_chunks/dep-ee1d6f73.js';

function useTableData(props) {
  var _useLocaleReceiver = useLocaleReceiver("datePicker"),
    _useLocaleReceiver2 = _slicedToArray(_useLocaleReceiver, 2),
    local = _useLocaleReceiver2[0],
    t = _useLocaleReceiver2[1];
  var monthLocal = t(local.months);
  var quarterLocal = t(local.quarters);
  var start = props.start,
    end = props.end,
    hoverStart = props.hoverStart,
    hoverEnd = props.hoverEnd,
    year = props.year,
    month = props.month,
    mode = props.mode,
    firstDayOfWeek = props.firstDayOfWeek,
    disableDate = props.disableDate,
    minDate = props.minDate,
    maxDate = props.maxDate,
    isRange = props.isRange,
    value = props.value,
    multiple = props.multiple;
  var data = [];
  var options = {
    minDate: minDate,
    maxDate: maxDate,
    disableDate: disableDate,
    firstDayOfWeek: firstDayOfWeek,
    monthLocal: monthLocal,
    quarterLocal: quarterLocal,
    showWeekOfYear: mode === "week",
    dayjsLocale: local.dayjsLocale,
    cancelRangeSelectLimit: props.cancelRangeSelectLimit
  };
  if (mode === "date") {
    data = getWeeks({
      year: year,
      month: month
    }, options);
  } else if (mode === "week") {
    data = getWeeks({
      year: year,
      month: month
    }, options);
  } else if (mode === "quarter") {
    data = getQuarters(year, options);
  } else if (mode === "month") {
    data = getMonths(year, options);
  } else if (mode === "year") {
    data = getYears(year, options);
  }
  return flagActive(data, {
    start: start,
    end: end,
    hoverStart: hoverStart,
    hoverEnd: hoverEnd,
    type: mode,
    isRange: isRange,
    value: value,
    multiple: multiple
  });
}

export { useTableData as default };
//# sourceMappingURL=useTableData.js.map
