/**
 * tdesign v1.13.1
 * (c) 2025 tdesign
 * @license MIT
 */

import React, { forwardRef } from 'react';
import classNames from 'classnames';
import useConfig from '../hooks/useConfig.js';
import '../config-provider/ConfigContext.js';
import '../_chunks/dep-4d3bcd6b.js';
import '../_chunks/dep-b703e6a4.js';
import 'lodash-es';
import '../_chunks/dep-ee1d6f73.js';
import '../_chunks/dep-25abb26d.js';
import 'dayjs';

var ListItem = /*#__PURE__*/forwardRef(function (props, ref) {
  var children = props.children,
    className = props.className,
    style = props.style,
    action = props.action,
    content = props.content;
  var _useConfig = useConfig(),
    classPrefix = _useConfig.classPrefix;
  var actionElement = action && /* @__PURE__ */React.createElement("ul", {
    className: "".concat(classPrefix, "-list-item__action")
  }, action);
  return /* @__PURE__ */React.createElement("li", {
    ref: ref,
    className: classNames("".concat(classPrefix, "-list-item"), className),
    style: style
  }, /* @__PURE__ */React.createElement("div", {
    className: "".concat(classPrefix, "-list-item-main")
  }, children ? children : content, actionElement));
});
ListItem.displayName = "ListItem";

export { ListItem as default };
//# sourceMappingURL=ListItem.js.map
