/**
 * tdesign v1.13.1
 * (c) 2025 tdesign
 * @license MIT
 */

import { _ as _typeof } from '../_chunks/dep-b703e6a4.js';
import { c as commonjsGlobal } from '../_chunks/dep-25abb26d.js';
import dayjs from 'dayjs';

var ar = {exports: {}};

(function (module, exports) {
  !function (e, t) {
    module.exports = t(dayjs) ;
  }(commonjsGlobal, function (e) {

    function t(e) {
      return e && "object" == _typeof(e) && "default" in e ? e : {
        "default": e
      };
    }
    var n = t(e),
      r = "يناير_فبراير_مارس_أبريل_مايو_يونيو_يوليو_أغسطس_سبتمبر_أكتوبر_نوفمبر_ديسمبر".split("_"),
      d = {
        1: "١",
        2: "٢",
        3: "٣",
        4: "٤",
        5: "٥",
        6: "٦",
        7: "٧",
        8: "٨",
        9: "٩",
        0: "٠"
      },
      _ = {
        "١": "1",
        "٢": "2",
        "٣": "3",
        "٤": "4",
        "٥": "5",
        "٦": "6",
        "٧": "7",
        "٨": "8",
        "٩": "9",
        "٠": "0"
      },
      o = {
        name: "ar",
        weekdays: "الأحد_الإثنين_الثلاثاء_الأربعاء_الخميس_الجمعة_السبت".split("_"),
        weekdaysShort: "أحد_إثنين_ثلاثاء_أربعاء_خميس_جمعة_سبت".split("_"),
        weekdaysMin: "ح_ن_ث_ر_خ_ج_س".split("_"),
        months: r,
        monthsShort: r,
        weekStart: 6,
        meridiem: function meridiem(e) {
          return e > 12 ? "م" : "ص";
        },
        relativeTime: {
          future: "بعد %s",
          past: "منذ %s",
          s: "ثانية واحدة",
          m: "دقيقة واحدة",
          mm: "%d دقائق",
          h: "ساعة واحدة",
          hh: "%d ساعات",
          d: "يوم واحد",
          dd: "%d أيام",
          M: "شهر واحد",
          MM: "%d أشهر",
          y: "عام واحد",
          yy: "%d أعوام"
        },
        preparse: function preparse(e) {
          return e.replace(/[١٢٣٤٥٦٧٨٩٠]/g, function (e) {
            return _[e];
          }).replace(/،/g, ",");
        },
        postformat: function postformat(e) {
          return e.replace(/\d/g, function (e) {
            return d[e];
          }).replace(/,/g, "،");
        },
        ordinal: function ordinal(e) {
          return e;
        },
        formats: {
          LT: "HH:mm",
          LTS: "HH:mm:ss",
          L: "D/‏M/‏YYYY",
          LL: "D MMMM YYYY",
          LLL: "D MMMM YYYY HH:mm",
          LLLL: "dddd D MMMM YYYY HH:mm"
        }
      };
    return n["default"].locale(o, null, !0), o;
  });
})(ar);

var arKW = {
  autoComplete: {
    empty: "\u0644\u0627 \u062A\u062A\u0648\u0627\u0641\u0631 \u0628\u064A\u0627\u0646\u0627\u062A"
  },
  pagination: {
    itemsPerPage: "{size} / \u0627\u0644\u0635\u0641\u062D\u0629",
    jumpTo: "\u0627\u0644\u0642\u0641\u0632 \u0625\u0644\u0649",
    page: "",
    total: "{count} \u0639\u0646\u0627\u0635\u0631"
  },
  cascader: {
    empty: "\u0644\u0627 \u062A\u062A\u0648\u0627\u0641\u0631 \u0628\u064A\u0627\u0646\u0627\u062A",
    loadingText: "\u062C\u0627\u0631 \u0627\u0644\u062A\u062D\u0645\u064A\u0644\u2026",
    placeholder: "\u0627\u0644\u0631\u062C\u0627\u0621 \u0627\u0644\u062A\u062D\u062F\u064A\u062F"
  },
  calendar: {
    yearSelection: "{year}",
    monthSelection: "{month}",
    yearRadio: "\u0639\u0627\u0645",
    monthRadio: "\u0634\u0647\u0631",
    hideWeekend: "\u0625\u062E\u0641\u0627\u0621 \u0639\u0637\u0644\u0629 \u0646\u0647\u0627\u064A\u0629 \u0627\u0644\u0623\u0633\u0628\u0648\u0639",
    showWeekend: "\u0639\u0631\u0636 \u0639\u0637\u0644\u0629 \u0646\u0647\u0627\u064A\u0629 \u0627\u0644\u0623\u0633\u0628\u0648\u0639",
    today: "\u0627\u0644\u064A\u0648\u0645",
    thisMonth: "\u0647\u0630\u0627 \u0627\u0644\u0634\u0647\u0631",
    week: "\u0627\u0644\u0627\u062B\u0646\u064A\u0646 \u0627\u0644\u062B\u0644\u0627\u062B\u0627\u0621 \u0627\u0644\u0627\u0631\u0628\u0639\u0627\u0621 \u0627\u0644\u062E\u0645\u064A\u0633 \u0627\u0644\u062C\u0645\u0639\u0629 \u0627\u0644\u0633\u0628\u062A \u0627\u0644\u0627\u062D\u062F",
    cellMonth: "\u064A\u0646\u0627\u064A\u0631 \u060C \u0641\u0628\u0631\u0627\u064A\u0631 \u060C \u0645\u0627\u0631\u0633 \u060C \u0623\u0628\u0631\u064A\u0644 \u060C \u0645\u0627\u064A\u0648 \u060C \u064A\u0648\u0646\u064A\u0648 \u060C \u064A\u0648\u0644\u064A\u0648 \u060C \u0623\u063A\u0633\u0637\u0633 \u060C \u0633\u0628\u062A\u0645\u0628\u0631 \u060C \u0623\u0643\u062A\u0648\u0628\u0631 \u060C \u0646\u0648\u0641\u0645\u0628\u0631 \u060C \u062F\u064A\u0633\u0645\u0628\u0631"
  },
  transfer: {
    title: "{checked} / {total}",
    empty: "\u0644\u0627 \u062A\u062A\u0648\u0627\u0641\u0631 \u0628\u064A\u0627\u0646\u0627\u062A",
    placeholder: "\u0623\u062F\u062E\u0644 \u0627\u0644\u0643\u0644\u0645\u0629 \u0644\u0644\u0628\u062D\u062B"
  },
  timePicker: {
    dayjsLocale: "ar",
    now: "\u0627\u0644\u0622\u0646",
    confirm: "\u0646\u0639\u0645",
    anteMeridiem: "\u0635\u0628\u0627\u062D\u0627",
    postMeridiem: "\u0645\u0633\u0627\u0621\u064B",
    placeholder: "\u0627\u0644\u0631\u062C\u0627\u0621 \u0627\u0644\u062A\u062D\u062F\u064A\u062F"
  },
  dialog: {
    confirm: "\u0646\u0639\u0645",
    cancel: "\u064A\u0644\u063A\u064A"
  },
  drawer: {
    confirm: "\u0646\u0639\u0645",
    cancel: "\u064A\u0644\u063A\u064A"
  },
  popconfirm: {
    confirm: {
      content: "\u0646\u0639\u0645"
    },
    cancel: {
      content: "\u064A\u0644\u063A\u064A"
    }
  },
  table: {
    empty: "\u0644\u0627 \u062A\u062A\u0648\u0627\u0641\u0631 \u0628\u064A\u0627\u0646\u0627\u062A",
    loadingText: "\u062C\u0627\u0631 \u0627\u0644\u062A\u062D\u0645\u064A\u0644\u2026",
    loadingMoreText: "\u0627\u0646\u0642\u0631 \u0644\u062A\u062D\u0645\u064A\u0644 \u0627\u0644\u0645\u0632\u064A\u062F",
    filterInputPlaceholder: "\u0627\u0644\u0631\u062C\u0627\u0621 \u0625\u062F\u062E\u0627\u0644 \u0627\u0644\u0645\u062D\u062A\u0648\u0649 (\u0644\u0627 \u062A\u0648\u062C\u062F \u0642\u064A\u0645\u0629 \u0627\u0641\u062A\u0631\u0627\u0636\u064A\u0629 \u0645\u062A\u0627\u062D\u0629)",
    sortAscendingOperationText: "\u0627\u0646\u0642\u0631 \u0644\u0644\u0641\u0631\u0632 \u062A\u0635\u0627\u0639\u062F\u064A\u064B\u0627",
    sortCancelOperationText: "\u0627\u0646\u0642\u0631 \u0644\u0625\u0644\u063A\u0627\u0621 \u0627\u0644\u0641\u0631\u0632",
    sortDescendingOperationText: "\u0627\u0646\u0642\u0631 \u0644\u0644\u0641\u0631\u0632 \u062A\u0646\u0627\u0632\u0644\u064A\u064B\u0627",
    clearFilterResultButtonText: "\u0635\u0627\u0641\u064A",
    columnConfigButtonText: "\u062A\u0643\u0648\u064A\u0646 \u0627\u0644\u0639\u0645\u0648\u062F",
    columnConfigTitleText: "\u062A\u0643\u0648\u064A\u0646 \u0639\u0645\u0648\u062F \u0627\u0644\u062C\u062F\u0648\u0644",
    columnConfigDescriptionText: "\u0627\u0644\u0631\u062C\u0627\u0621 \u062A\u062D\u062F\u064A\u062F \u0623\u0639\u0645\u062F\u0629 \u0627\u0644\u0628\u064A\u0627\u0646\u0627\u062A \u0627\u0644\u0645\u0631\u0627\u062F \u0639\u0631\u0636\u0647\u0627 \u0641\u064A \u0627\u0644\u062C\u062F\u0648\u0644",
    confirmText: "\u0646\u0639\u0645",
    cancelText: "\u064A\u0644\u063A\u064A",
    resetText: "\u0625\u0639\u0627\u062F\u0629 \u0636\u0628\u0637",
    selectAllText: "\u0627\u062E\u062A\u0631 \u0627\u0644\u0643\u0644",
    searchResultText: "\u062A\u0645 \u0627\u0644\u0639\u062B\u0648\u0631 \u0639\u0644\u0649 \u0628\u062D\u062B '{result}' \u0648{count} \u0645\u0646 \u0627\u0644\u0639\u0646\u0627\u0635\u0631."
  },
  select: {
    empty: "\u0644\u0627 \u062A\u062A\u0648\u0627\u0641\u0631 \u0628\u064A\u0627\u0646\u0627\u062A",
    loadingText: "\u062C\u0627\u0631 \u0627\u0644\u062A\u062D\u0645\u064A\u0644\u2026",
    placeholder: "\u0627\u0644\u0631\u062C\u0627\u0621 \u0627\u0644\u062A\u062D\u062F\u064A\u062F"
  },
  tree: {
    empty: "\u0644\u0627 \u062A\u062A\u0648\u0627\u0641\u0631 \u0628\u064A\u0627\u0646\u0627\u062A"
  },
  treeSelect: {
    empty: "\u0644\u0627 \u062A\u062A\u0648\u0627\u0641\u0631 \u0628\u064A\u0627\u0646\u0627\u062A",
    loadingText: "\u062C\u0627\u0631 \u0627\u0644\u062A\u062D\u0645\u064A\u0644\u2026",
    placeholder: "\u0627\u0644\u0631\u062C\u0627\u0621 \u0627\u0644\u062A\u062D\u062F\u064A\u062F"
  },
  datePicker: {
    dayjsLocale: "ar",
    placeholder: {
      date: "\u062D\u062F\u062F \u062A\u0627\u0631\u064A\u062E",
      month: "\u0627\u062E\u062A\u0631 \u0627\u0644\u0634\u0647\u0631",
      year: "\u0627\u062E\u062A\u0631 \u0627\u0644\u0633\u0646\u0629",
      quarter: "\u0627\u0644\u0631\u062C\u0627\u0621 \u062A\u062D\u062F\u064A\u062F \u0627\u0644\u0631\u0628\u0639",
      week: "\u0627\u0644\u0631\u062C\u0627\u0621 \u062A\u062D\u062F\u064A\u062F \u0627\u0633\u0628\u0648\u0639"
    },
    weekdays: ["\u0627\u0644\u0625\u062B\u0646\u064A\u0646", "\u0627\u0644\u062B\u0644\u0627\u062B\u0627\u0621", "\u0627\u0644\u0623\u0631\u0628\u0639\u0627\u0621", "\u0627\u0644\u062E\u0645\u064A\u0633", "\u0627\u0644\u062C\u0645\u0639\u0629", "\u0627\u0644\u0633\u0628\u062A", "\u0627\u0644\u0623\u062D\u062F"],
    months: ["\u064A\u0646\u0627\u064A\u0631", "\u0641\u0628\u0631\u0627\u064A\u0631", "\u0645\u0627\u0631\u0633", "\u0623\u0628\u0631\u064A\u0644", "\u0645\u0627\u064A\u0648", "\u064A\u0648\u0646\u064A\u0648", "\u064A\u0648\u0644\u064A\u0648", "\u0623\u063A\u0633\u0637\u0633", "\u0633\u0628\u062A\u0645\u0628\u0631", "\u0623\u0643\u062A\u0648\u0628\u0631", "\u0646\u0648\u0641\u0645\u0628\u0631", "\u062F\u064A\u0633\u0645\u0628\u0631"],
    quarters: ["Q1", "Q2", "Q3", "Q4"],
    rangeSeparator: " - ",
    direction: "ltr",
    format: "YYYY-MM-DD",
    dayAriaLabel: "D",
    yearAriaLabel: "Y",
    monthAriaLabel: "M",
    weekAbbreviation: "W",
    confirm: "\u0646\u0639\u0645",
    selectTime: "\u062D\u062F\u062F \u0627\u0644\u0648\u0642\u062A",
    selectDate: "\u062D\u062F\u062F \u062A\u0627\u0631\u064A\u062E",
    nextYear: "\u0627\u0644\u0639\u0627\u0645 \u0627\u0644\u0642\u0627\u062F\u0645",
    preYear: "\u0627\u0644\u0639\u0627\u0645 \u0627\u0644\u0645\u0627\u0636\u064A",
    nextMonth: "\u0627\u0644\u0634\u0647\u0631 \u0627\u0644\u0642\u0627\u062F\u0645",
    preMonth: "\u0627\u0644\u0634\u0647\u0631 \u0627\u0644\u0645\u0627\u0636\u064A",
    preDecade: "\u0627\u0644\u0639\u0642\u062F \u0627\u0644\u0645\u0627\u0636\u064A",
    nextDecade: "\u0627\u0644\u0639\u0642\u062F \u0627\u0644\u0642\u0627\u062F\u0645",
    now: "\u0627\u0644\u0622\u0646"
  },
  upload: {
    sizeLimitMessage: "\u0644\u0627 \u064A\u0645\u0643\u0646 \u0623\u0646 \u064A\u062A\u062C\u0627\u0648\u0632 \u062D\u062C\u0645 \u0627\u0644\u0645\u0644\u0641 {sizeLimit}",
    cancelUploadText: "\u064A\u0644\u063A\u064A",
    triggerUploadText: {
      fileInput: "\u062D\u062F\u062F \u0627\u0644\u0645\u0644\u0641",
      image: "\u0627\u0646\u0642\u0631 \u0644\u062A\u062D\u0645\u064A\u0644 \u0627\u0644\u0635\u0648\u0631\u0629",
      normal: "\u062A\u062D\u0645\u064A\u0644",
      reupload: "\u0623\u0639\u062F \u062A\u062D\u0645\u064A\u0644",
      continueUpload: "\u062A\u062D\u0645\u064A\u0644 \u0627\u0644\u0645\u0632\u064A\u062F",
      "delete": "\u062D\u0630\u0641",
      uploading: "\u062A\u062D\u0645\u064A\u0644"
    },
    dragger: {
      dragDropText: "\u0623\u0633\u0642\u0637\u0647\u0627 \u0647\u0646\u0627",
      draggingText: "\u0627\u0633\u062D\u0628 \u0627\u0644\u0645\u0644\u0641 \u0647\u0646\u0627",
      clickAndDragText: "\u0627\u062E\u062A\u0631 \u0645\u0644\u0641\u064B\u0627 \u0623\u0648 \u0627\u0633\u062D\u0628\u0647 \u0647\u0646\u0627."
    },
    file: {
      fileNameText: "\u0627\u0633\u0645 \u0627\u0644\u0645\u0644\u0641",
      fileSizeText: "\u062D\u062C\u0645",
      fileStatusText: "\u062D\u0627\u0644\u0629",
      fileOperationText: "\u0639\u0645\u0644\u064A\u0629",
      fileOperationDateText: "\u062A\u0627\u0631\u064A\u062E"
    },
    progress: {
      uploadingText: "\u062A\u062D\u0645\u064A\u0644",
      waitingText: "\u062C\u0627\u0631 \u0627\u0644\u062A\u062D\u0645\u064A\u0644",
      failText: "\u0627\u0644\u062A\u062D\u0645\u064A\u0644 \u0641\u0634\u0644",
      successText: "\u062A\u0645 \u0627\u0644\u062A\u062D\u0645\u064A\u0644 \u0628\u0646\u062C\u0627\u062D."
    }
  },
  form: {
    errorMessage: {
      date: "\u0627\u0644\u0631\u062C\u0627\u0621 \u0625\u062F\u062E\u0627\u0644 ${name} \u0627\u0644\u0635\u062D\u064A\u062D",
      url: "\u0627\u0644\u0631\u062C\u0627\u0621 \u0625\u062F\u062E\u0627\u0644 ${name} \u0627\u0644\u0635\u062D\u064A\u062D",
      whitespace: "\u0644\u0627 \u064A\u0645\u0643\u0646 \u0623\u0646 \u064A\u0643\u0648\u0646 ${name} \u0641\u0627\u0631\u063A\u064B\u0627",
      required: "\u0645\u0637\u0644\u0648\u0628 ${name}",
      max: "\u064A\u0645\u0643\u0646 \u0623\u0646 \u064A\u062D\u062A\u0648\u064A ${name} \u0639\u0644\u0649 \u0645\u0627 \u064A\u0635\u0644 \u0625\u0644\u0649 ${validate} \u062D\u0631\u0641\u064B\u0627",
      min: "\u0644\u0627 \u064A\u0645\u0643\u0646 \u0623\u0646 \u064A\u0643\u0648\u0646 ${name} \u0623\u0642\u0644 \u0645\u0646 ${validate} \u062D\u0631\u0641\u064B\u0627",
      len: "\u064A\u062C\u0628 \u0623\u0646 \u064A\u062A\u0643\u0648\u0646 ${name} \u0645\u0646 \u0623\u062D\u0631\u0641 ${validate} \u0628\u0627\u0644\u0636\u0628\u0637",
      "enum": "${name} \u064A\u062C\u0628 \u0623\u0646 \u064A\u0643\u0648\u0646 \u0648\u0627\u062D\u062F\u064B\u0627 \u0645\u0646 ${validate} ",
      idcard: "\u0627\u0644\u0631\u062C\u0627\u0621 \u0625\u062F\u062E\u0627\u0644 ${name} \u0627\u0644\u0635\u062D\u064A\u062D",
      telnumber: "\u0627\u0644\u0631\u062C\u0627\u0621 \u0625\u062F\u062E\u0627\u0644 ${name} \u0627\u0644\u0635\u062D\u064A\u062D",
      pattern: "\u0627\u0644\u0631\u062C\u0627\u0621 \u0625\u062F\u062E\u0627\u0644 ${name} \u0627\u0644\u0635\u062D\u064A\u062D",
      validator: "${name} \u063A\u064A\u0631 \u0635\u0627\u0644\u062D",
      "boolean": "${name} \u0644\u064A\u0633 \u0645\u0646\u0637\u0642\u064A\u064B\u0627",
      number: "\u064A\u062C\u0628 \u0623\u0646 \u064A\u0643\u0648\u0646 ${name} \u0631\u0642\u0645\u064B\u0627"
    }
  },
  input: {
    placeholder: "\u0627\u0644\u0631\u062C\u0627\u0621 \u0625\u062F\u062E\u0627\u0644"
  },
  list: {
    loadingText: "\u062C\u0627\u0631 \u0627\u0644\u062A\u062D\u0645\u064A\u0644\u2026",
    loadingMoreText: "\u0627\u0646\u0642\u0631 \u0644\u062A\u062D\u0645\u064A\u0644 \u0627\u0644\u0645\u0632\u064A\u062F"
  },
  alert: {
    expandText: "\u062A\u0632\u0633\u064A\u0639",
    collapseText: "\u0627\u0646\u0647\u064A\u0627\u0631"
  },
  anchor: {
    copySuccessText: "\u062A\u0645 \u0646\u0633\u062E \u0627\u0644\u0631\u0627\u0628\u0637",
    copyText: "\u0627\u0646\u0633\u062E \u0627\u0644\u0631\u0627\u0628\u0637"
  },
  colorPicker: {
    swatchColorTitle: "\u0627\u0644\u0623\u0644\u0648\u0627\u0646 \u0627\u0644\u0627\u0641\u062A\u0631\u0627\u0636\u064A\u0629",
    recentColorTitle: "\u0645\u0633\u062A\u062E\u062F\u0645 \u062D\u062F\u064A\u062B\u0627",
    clearConfirmText: "\u0647\u0644 \u062A\u0631\u064A\u062F \u0645\u0633\u062D \u0627\u0644\u0623\u0644\u0648\u0627\u0646 \u0627\u0644\u0645\u0633\u062A\u062E\u062F\u0645\u0629 \u0645\u0624\u062E\u0631\u064B\u0627\u061F",
    singleColor: "\u0645\u0648\u062D\u062F",
    gradientColor: "\u0645\u062A\u062F\u0631\u062C"
  },
  image: {
    errorText: "\u063A\u064A\u0631 \u0642\u0627\u062F\u0631 \u0639\u0644\u0649 \u0627\u0644\u062A\u062D\u0645\u064A\u0644",
    loadingText: "\u062C\u0627\u0631 \u0627\u0644\u062A\u062D\u0645\u064A\u0644"
  },
  imageViewer: {
    errorText: "\u063A\u064A\u0631 \u0642\u0627\u062F\u0631 \u0639\u0644\u0649 \u0627\u0644\u062A\u062D\u0645\u064A\u0644",
    mirrorTipText: "\u0645\u0631\u0622\u0629",
    rotateTipText: "\u0627\u0633\u062A\u062F\u0627\u0631\u0629",
    originalSizeTipText: "\u0623\u0635\u0644\u064A"
  },
  typography: {
    expandText: "\u062A\u0648\u0633\u064A\u0639",
    collapseText: "\u0637\u064A",
    copiedText: "\u0627\u0644\u0646\u0633\u062E \u0627\u0643\u062A\u0645\u0644"
  },
  rate: {
    rateText: ["\u0641\u0638\u064A\u0639", "\u062E\u064A\u0628\u0629 \u0623\u0645\u0644", "\u0639\u0627\u062F\u064A", "\u0631\u0627\u0636", "\u0645\u0641\u0627\u062C\u0623\u0629"]
  },
  empty: {
    titleText: {
      maintenance: "\u062A\u062D\u062A \u0627\u0644\u0625\u0646\u0634\u0627\u0621",
      success: "\u0627\u0644\u0646\u062C\u0627\u062D",
      fail: "\u0627\u0644\u0641\u0634\u0644",
      empty: "\u0644\u0627 \u062A\u0648\u062C\u062F \u0628\u064A\u0627\u0646\u0627\u062A \u062D\u062A\u0649 \u0627\u0644\u0622\u0646",
      networkError: "\u062E\u0637\u0623 \u0641\u064A \u0627\u0644\u0634\u0628\u0643\u0629"
    }
  },
  chat: {
    placeholder: "\u0627\u0644\u0631\u062C\u0627\u0621 \u0625\u062F\u062E\u0627\u0644 \u0631\u0633\u0627\u0644\u0629...",
    stopBtnText: "\u0625\u064A\u0642\u0627\u0641",
    refreshTipText: "\u0625\u0639\u0627\u062F\u0629 \u062A\u0648\u0644\u064A\u062F",
    copyTipText: "\u0646\u0633\u062E",
    likeTipText: "\u0625\u0639\u062C\u0627\u0628",
    dislikeTipText: "\u0639\u062F\u0645 \u0625\u0639\u062C\u0627\u0628",
    copyCodeBtnText: "\u0646\u0633\u062E \u0627\u0644\u0643\u0648\u062F",
    copyCodeSuccessText: "\u062A\u0645 \u0627\u0644\u0646\u0633\u062E",
    clearHistoryBtnText: "\u0645\u0633\u062D \u0627\u0644\u0633\u062C\u0644",
    copyTextSuccess: "\u062A\u0645 \u0627\u0644\u0646\u0633\u062E \u0625\u0644\u0649 \u0627\u0644\u062D\u0627\u0641\u0638\u0629 \u0628\u0646\u062C\u0627\u062D",
    copyTextFail: "\u0641\u0634\u0644 \u0627\u0644\u0646\u0633\u062E \u0625\u0644\u0649 \u0627\u0644\u062D\u0627\u0641\u0638\u0629",
    confirmClearHistory: "\u0647\u0644 \u0623\u0646\u062A \u0645\u062A\u0623\u0643\u062F \u0645\u0646 \u0645\u0633\u062D \u062C\u0645\u064A\u0639 \u0627\u0644\u0631\u0633\u0627\u0626\u0644\u061F",
    uploadImageText: "\u0631\u0641\u0639 \u0627\u0644\u0635\u0648\u0631\u0629",
    uploadAttachmentText: "\u0631\u0641\u0639 \u0627\u0644\u0645\u0631\u0641\u0642"
  },
  qrcode: {
    expiredText: "\u0645\u0646\u062A\u0647\u064A \u0627\u0644\u0635\u0644\u0627\u062D\u064A\u0629",
    refreshText: "\u064A\u0646\u0639\u0634",
    scannedText: "\u062A\u0645 \u0645\u0633\u062D\u0647\u0627 \u0636\u0648\u0626\u064A\u064B\u0627"
  }
};

export { arKW as default };
//# sourceMappingURL=ar_KW.js.map
