/**
 * tdesign v1.13.1
 * (c) 2025 tdesign
 * @license MIT
 */

import { _ as _typeof } from '../_chunks/dep-b703e6a4.js';
import { c as commonjsGlobal } from '../_chunks/dep-25abb26d.js';
import dayjs from 'dayjs';

var ko = {exports: {}};

(function (module, exports) {
  !function (e, _) {
    module.exports = _(dayjs) ;
  }(commonjsGlobal, function (e) {

    function _(e) {
      return e && "object" == _typeof(e) && "default" in e ? e : {
        "default": e
      };
    }
    var d = _(e),
      t = {
        name: "ko",
        weekdays: "일요일_월요일_화요일_수요일_목요일_금요일_토요일".split("_"),
        weekdaysShort: "일_월_화_수_목_금_토".split("_"),
        weekdaysMin: "일_월_화_수_목_금_토".split("_"),
        months: "1월_2월_3월_4월_5월_6월_7월_8월_9월_10월_11월_12월".split("_"),
        monthsShort: "1월_2월_3월_4월_5월_6월_7월_8월_9월_10월_11월_12월".split("_"),
        ordinal: function ordinal(e) {
          return e + "일";
        },
        formats: {
          LT: "A h:mm",
          LTS: "A h:mm:ss",
          L: "YYYY.MM.DD.",
          LL: "YYYY년 MMMM D일",
          LLL: "YYYY년 MMMM D일 A h:mm",
          LLLL: "YYYY년 MMMM D일 dddd A h:mm",
          l: "YYYY.MM.DD.",
          ll: "YYYY년 MMMM D일",
          lll: "YYYY년 MMMM D일 A h:mm",
          llll: "YYYY년 MMMM D일 dddd A h:mm"
        },
        meridiem: function meridiem(e) {
          return e < 12 ? "오전" : "오후";
        },
        relativeTime: {
          future: "%s 후",
          past: "%s 전",
          s: "몇 초",
          m: "1분",
          mm: "%d분",
          h: "한 시간",
          hh: "%d시간",
          d: "하루",
          dd: "%d일",
          M: "한 달",
          MM: "%d달",
          y: "일 년",
          yy: "%d년"
        }
      };
    return d["default"].locale(t, null, !0), t;
  });
})(ko);

var koKR = {
  autoComplete: {
    empty: "\uB370\uC774\uD130 \uC5C6\uC74C"
  },
  pagination: {
    itemsPerPage: "{size} /\uD398\uC774\uC9C0",
    jumpTo: "\uAC74\uB108\uB6F0\uB2E4",
    page: "\uD398\uC774\uC9C0",
    total: "\uD754\uD55C {count} \uC544\uC774\uD15C \uB370\uC774\uD130"
  },
  cascader: {
    empty: "\uB370\uC774\uD130 \uC5C6\uC74C",
    loadingText: "\uB85C\uB529 \uC911",
    placeholder: "\uC120\uD0DD\uD574\uC8FC\uC138\uC694"
  },
  calendar: {
    yearSelection: "{year} \uB144\uB3C4",
    monthSelection: "{month} \uB2EC",
    yearRadio: "\uB144\uB3C4",
    monthRadio: "\uB2EC",
    hideWeekend: "\uC8FC\uB9D0\uC744 \uC228\uAE30\uB2E4",
    showWeekend: "\uC8FC\uB9D0 \uC1FC",
    today: "\uC624\uB298",
    thisMonth: "\uC774\uBC88 \uB2EC",
    week: "\uD558\uB098,\uB458,\uC14B,\uB137,\uB2E4\uC12F,\uC5EC\uC12F,\uD558\uB8E8",
    cellMonth: "1\uC6D4,2\uC6D4,3\uC6D4,4\uC6D4,5\uC6D4,6\uC6D4,7\uC6D4,8\uC6D4,9\uC6D4,10\uC6D4,11\uC6D4,12\uC6D4"
  },
  transfer: {
    title: "{checked} / {total} \uC548\uAC74",
    empty: "\uB370\uC774\uD130 \uC5C6\uC74C",
    placeholder: "\uAC80\uC0C9\uD560 \uD0A4\uC6CC\uB4DC\uB97C \uC785\uB825\uD558\uC138\uC694"
  },
  timePicker: {
    dayjsLocale: "ko",
    now: "\uC9C0\uAE08",
    confirm: "\uD655\uC2E0\uD558\uB294",
    anteMeridiem: "\uC544\uCE68",
    postMeridiem: "\uC624\uD6C4",
    placeholder: "\uC120\uBC1C \uAE30\uAC04"
  },
  dialog: {
    confirm: "\uD655\uC778\uD558\uB2E4",
    cancel: "\uCDE8\uC18C"
  },
  drawer: {
    confirm: "\uD655\uC778\uD558\uB2E4",
    cancel: "\uCDE8\uC18C"
  },
  popconfirm: {
    confirm: {
      content: "\uD655\uC2E0\uD558\uB294"
    },
    cancel: {
      content: "\uCDE8\uC18C"
    }
  },
  table: {
    empty: "\uB370\uC774\uD130 \uC5C6\uC74C",
    loadingText: "\uB85C\uB529 \uC911 \uAE30\uB2E4\uB824\uC8FC\uC138\uC694",
    loadingMoreText: "\uB354 \uB85C\uB4DC\uD558\uB824\uBA74 \uD074\uB9AD\uD558\uC138\uC694",
    filterInputPlaceholder: "\uC544\uBB34\uAC70\uB098 \uC785\uB825\uD558\uC138\uC694(\uAE30\uBCF8\uAC12 \uC5C6\uC74C)",
    sortAscendingOperationText: "\uC624\uB984\uCC28\uC21C\uC73C\uB85C \uD074\uB9AD",
    sortCancelOperationText: "\uD074\uB9AD\uD558\uC5EC \uC815\uB82C \uD574\uC81C",
    sortDescendingOperationText: "\uB0B4\uB9BC\uCC28\uC21C\uC73C\uB85C \uD074\uB9AD",
    clearFilterResultButtonText: "\uD074\uB9AC\uC5B4 \uD544\uD130",
    columnConfigButtonText: "\uC5F4 \uAD6C\uC131",
    columnConfigTitleText: "\uD14C\uC774\uBE14 \uC5F4 \uAD6C\uC131",
    columnConfigDescriptionText: "\uD14C\uC774\uBE14\uC5D0 \uD45C\uC2DC\uD560 \uB370\uC774\uD130 \uC5F4\uC744 \uC120\uD0DD\uD558\uC2ED\uC2DC\uC624",
    confirmText: "\uD655\uC778\uD558\uB2E4",
    cancelText: "\uCDE8\uC18C",
    resetText: "\uCD08\uAE30\uD654",
    selectAllText: "\uBAA8\uB450 \uC120\uD0DD",
    searchResultText: "\uAC80\uC0C9\u201C{result}\u201D\uFF0C\uC77C\uC5B4\uB098 {count} \uACB0\uACFC"
  },
  select: {
    empty: "\uB370\uC774\uD130 \uC5C6\uC74C",
    loadingText: "\uB85C\uB529 \uC911",
    placeholder: "\uC120\uD0DD\uD574\uC8FC\uC138\uC694"
  },
  tree: {
    empty: "\uB370\uC774\uD130 \uC5C6\uC74C"
  },
  treeSelect: {
    empty: "\uB370\uC774\uD130 \uC5C6\uC74C",
    loadingText: "\uB85C\uB529 \uC911",
    placeholder: "\uC120\uD0DD\uD574\uC8FC\uC138\uC694"
  },
  datePicker: {
    dayjsLocale: "ko",
    placeholder: {
      date: "\uB0A0\uC9DC\uB97C \uC120\uD0DD\uD558\uC138\uC694Z",
      month: "\uC6D4\uC744 \uC120\uD0DD\uD558\uC138\uC694",
      year: "\uC5F0\uB3C4\uB97C \uC120\uD0DD\uD558\uC138\uC694",
      quarter: "\uBD84\uAE30\uBCC4 \uC120\uD0DD",
      week: "\uC694\uC77C \uC120\uD0DD"
    },
    weekdays: ["\uC6D4", "\uD654", "\uC218", "\uBAA9", "\uAE08", "\uD1A0", "\uC77C"],
    months: ["1 \uC6D4", "2 \uC6D4", "3 \uC6D4", "4 \uC6D4", "5 \uC6D4", "6 \uC6D4", "7 \uC6D4", "8 \uC6D4", "9 \uC6D4", "10 \uC6D4", "11 \uC6D4", "12 \uC6D4"],
    quarters: ["Q1", "Q2", "Q3", "Q4"],
    rangeSeparator: " - ",
    direction: "ltr",
    format: "YYYY-MM-DD",
    dayAriaLabel: "\uB0AE",
    weekAbbreviation: "\uC8FC",
    yearAriaLabel: "\uB144\uB3C4",
    monthAriaLabel: "\uB2EC",
    confirm: "\uD655\uC2E0\uD558\uB294",
    selectTime: "\uC120\uBC1C \uAE30\uAC04",
    selectDate: "\uB0A0\uC9DC \uC120\uD0DD",
    nextYear: "\uB0B4\uB144",
    preYear: "\uC791\uB144",
    nextMonth: "\uB2E4\uC74C \uB2EC",
    preMonth: "\uC9C0\uB09C \uB2EC",
    preDecade: "\uC9C0\uB09C \uC2ED \uB144",
    nextDecade: "\uB2E4\uC74C 10\uB144",
    now: "\uD604\uC7AC\uC758"
  },
  upload: {
    sizeLimitMessage: "\uC774\uBBF8\uC9C0 \uD06C\uAE30\uB294 \uB2E4\uC74C\uC744 \uCD08\uACFC\uD560 \uC218 \uC5C6\uC2B5\uB2C8\uB2E4 {sizeLimit}",
    cancelUploadText: "\uC5C5\uB85C\uB4DC \uCDE8\uC18C",
    triggerUploadText: {
      fileInput: "\uD30C\uC77C \uC120\uD0DD",
      image: "\uC774\uBBF8\uC9C0\uB97C \uC5C5\uB85C\uB4DC\uD558\uB824\uBA74 \uD074\uB9AD\uD558\uC138\uC694",
      normal: "\uC5C5\uB85C\uB4DC\uD558\uB824\uBA74 \uD074\uB9AD",
      reupload: "\uC7AC\uC5C5\uB85C\uB4DC",
      continueUpload: "\uACC4\uC18D \uC5C5\uB85C\uB4DC",
      "delete": "\uC0AD\uC81C",
      uploading: "\uC5C5\uB85C\uB4DC"
    },
    dragger: {
      dragDropText: "\uB9C8\uC6B0\uC2A4\uB97C \uB193\uC73C\uC2ED\uC2DC\uC624",
      draggingText: "\uC774 \uC601\uC5ED\uC73C\uB85C \uB4DC\uB798\uADF8 \uC564 \uB4DC\uB86D",
      clickAndDragText: "\uC704\uC758 \"\uD30C\uC77C \uC120\uD0DD\"\uC744 \uD074\uB9AD\uD558\uAC70\uB098 \uD30C\uC77C\uC744 \uC774 \uC601\uC5ED\uC73C\uB85C \uB04C\uC5B4\uB2E4 \uB193\uC2B5\uB2C8\uB2E4"
    },
    file: {
      fileNameText: "\uD30C\uC77C \uC774\uB984",
      fileSizeText: "\uD30C\uC77C \uD06C\uAE30",
      fileStatusText: "\uC0C1\uD0DC",
      fileOperationText: "\uC791\uB3D9\uD558\uB2E4",
      fileOperationDateText: "\uC5C5\uB85C\uB4DC \uB0A0\uC9DC"
    },
    progress: {
      uploadingText: "\uC5C5\uB85C\uB4DC",
      waitingText: "\uC5C5\uB85C\uB4DC \uBCF4\uB958 \uC911",
      failText: "\uC5C5\uB85C\uB4DC \uC2E4\uD328",
      successText: "\uC131\uACF5\uC801\uC73C\uB85C \uC5C5\uB85C\uB4DC\uB428"
    }
  },
  form: {
    errorMessage: {
      date: "\uC815\uD655\uD55C \uB0B4\uC6A9\uC744 \uC785\uB825\uD574\uC8FC\uC138\uC694${name}",
      url: "\uC815\uD655\uD55C \uB0B4\uC6A9\uC744 \uC785\uB825\uD574\uC8FC\uC138\uC694${name}",
      required: "${name}\uD544\uC218\uC758",
      whitespace: "${name}\uC740 \uBE44\uC5B4 \uC788\uC744 \uC218 \uC5C6\uC2B5\uB2C8\uB2E4",
      max: "${name}\uBB38\uC790 \uAE38\uC774\uB294 \uCD08\uACFC\uD560 \uC218 \uC5C6\uC2B5\uB2C8\uB2E4 ${validate} \uCE90\uB9AD\uD130\uFF0C\uD55C\uC790\uB294 \uB450 \uAE00\uC790\uC640 \uAC19\uB2E4",
      min: "${name}\uBB38\uC790 \uAE38\uC774\uB294 \uB2E4\uC74C\uBCF4\uB2E4 \uC791\uC744 \uC218 \uC5C6\uC2B5\uB2C8\uB2E4 ${validate} \uCE90\uB9AD\uD130\uFF0C\uD55C\uC790\uB294 \uB450 \uAE00\uC790\uC640 \uAC19\uB2E4",
      len: "${name}\uBB38\uC790 \uAE38\uC774\uB294 \uB2E4\uC74C\uACFC \uAC19\uC544\uC57C \uD569\uB2C8\uB2E4. ${validate}",
      "enum": "${name}\uB9CC \uB420 \uC218 \uC788\uC2B5\uB2C8\uB2E4${validate}\uADF8\uB9AC\uACE0 \uB354",
      idcard: "\uC815\uD655\uD55C \uB0B4\uC6A9\uC744 \uC785\uB825\uD574\uC8FC\uC138\uC694${name}",
      telnumber: "\uC815\uD655\uD55C \uB0B4\uC6A9\uC744 \uC785\uB825\uD574\uC8FC\uC138\uC694${name}",
      pattern: "\uC815\uD655\uD55C \uB0B4\uC6A9\uC744 \uC785\uB825\uD574\uC8FC\uC138\uC694${name}",
      validator: "${name}\uBE44\uC900\uC218",
      "boolean": "${name}\uB370\uC774\uD130 \uC720\uD615\uC740 \uBD80\uC6B8\uC774\uC5B4\uC57C \uD569\uB2C8\uB2E4",
      number: "${name}\uC22B\uC790\uC5EC\uC57C \uD569\uB2C8\uB2E4"
    },
    colonText: ":"
  },
  input: {
    placeholder: "\uB4E4\uC5B4 \uC624\uC138\uC694"
  },
  list: {
    loadingText: "\uB85C\uB529 \uC911 \uAE30\uB2E4\uB824\uC8FC\uC138\uC694",
    loadingMoreText: "\uB354 \uB85C\uB4DC\uD558\uB824\uBA74 \uD074\uB9AD\uD558\uC138\uC694"
  },
  alert: {
    expandText: "\uB354 \uD655\uC7A5",
    collapseText: "\uCE58\uC6CC"
  },
  anchor: {
    copySuccessText: "\uB9C1\uD06C \uBCF5\uC0AC \uC131\uACF5",
    copyText: "\uB9C1\uD06C \uBCF5\uC0AC"
  },
  colorPicker: {
    swatchColorTitle: "\uC2DC\uC2A4\uD15C \uAE30\uBCF8 \uC0C9\uC0C1",
    recentColorTitle: "\uCD5C\uADFC \uC0AC\uC6A9\uD55C \uC0C9\uC0C1",
    clearConfirmText: "\uCD5C\uADFC\uC5D0 \uC0AC\uC6A9\uD55C \uC0C9\uC0C1\uC744 \uC9C0\uC6B0\uC2DC\uACA0\uC2B5\uB2C8\uAE4C?",
    singleColor: "\uB2E8\uC0C9",
    gradientColor: "\uADF8\uB77C\uB370\uC774\uC158"
  },
  guide: {
    finishButtonProps: {
      content: "\uC644\uB8CC",
      theme: "primary"
    },
    nextButtonProps: {
      content: "\uB2E4\uC74C \uB2E8\uACC4",
      theme: "primary"
    },
    skipButtonProps: {
      content: "\uAC74\uB108\uB6F0\uAE30",
      theme: "default"
    },
    prevButtonProps: {
      content: "\uB9C8\uC9C0\uB9C9 \uB2E8\uACC4",
      theme: "default"
    }
  },
  image: {
    errorText: "\uC0AC\uC9C4\uC744 \uD45C\uC2DC\uD560 \uC218 \uC5C6\uC2B5\uB2C8\uB2E4.",
    loadingText: "\uC774\uBBF8\uC9C0 \uB85C\uB529"
  },
  imageViewer: {
    errorText: "\uC774\uBBF8\uC9C0\uB97C \uB85C\uB4DC\uD558\uC9C0 \uBABB\uD588\uC2B5\uB2C8\uB2E4. \uC0C8\uB85C\uACE0\uCE68\uD574 \uBCF4\uC138\uC694.",
    mirrorTipText: "\uBBF8\uB7EC \uC774\uBBF8\uC9C0",
    rotateTipText: "\uD68C\uC804\uD558\uB2E4",
    originalSizeTipText: "\uC6D0\uBCF8 \uD06C\uAE30"
  },
  typography: {
    expandText: "\uD3BC\uCE58\uB2E4",
    collapseText: "\uC811\uB2E4",
    copiedText: "\uBCF5\uC0AC \uC131\uACF5"
  },
  rate: {
    rateText: ["\uCD5C\uC545", "\uC2E4\uB9DD", "\uBCF4\uD1B5", "\uB9CC\uC871", "\uB180\uB78C"]
  },
  empty: {
    titleText: {
      maintenance: "\uAC74\uC124 \uC911",
      success: "\uC131\uACF5",
      fail: "\uC2E4\uD328",
      empty: "\uB370\uC774\uD130 \uC5C6\uC74C",
      networkError: "\uB124\uD2B8\uC6CC\uD06C \uC624\uB958"
    }
  },
  descriptions: {
    colonText: ":"
  },
  chat: {
    placeholder: "\uBA54\uC2DC\uC9C0\uB97C \uC785\uB825\uD558\uC138\uC694...",
    stopBtnText: "\uC911\uC9C0",
    refreshTipText: "\uB2E4\uC2DC \uC0DD\uC131",
    copyTipText: "\uBCF5\uC0AC",
    likeTipText: "\uC88B\uC544\uC694",
    dislikeTipText: "\uC2EB\uC5B4\uC694",
    copyCodeBtnText: "\uCF54\uB4DC \uBCF5\uC0AC",
    copyCodeSuccessText: "\uBCF5\uC0AC\uB428",
    clearHistoryBtnText: "\uAE30\uB85D \uC9C0\uC6B0\uAE30",
    copyTextSuccess: "\uD074\uB9BD\uBCF4\uB4DC\uC5D0 \uBCF5\uC0AC\uB418\uC5C8\uC2B5\uB2C8\uB2E4",
    copyTextFail: "\uD074\uB9BD\uBCF4\uB4DC\uC5D0 \uBCF5\uC0AC\uD558\uC9C0 \uBABB\uD588\uC2B5\uB2C8\uB2E4",
    confirmClearHistory: "\uCC44\uD305 \uAE30\uB85D\uC744 \uC9C0\uC6B0\uC2DC\uACA0\uC2B5\uB2C8\uAE4C?",
    loadingText: "\uC0DD\uAC01 \uC911...",
    loadingEndText: "\uAE4A\uC774 \uC0DD\uAC01\uD568",
    uploadImageText: "\uC774\uBBF8\uC9C0 \uC5C5\uB85C\uB4DC",
    uploadAttachmentText: "\uCCA8\uBD80 \uD30C\uC77C \uC5C5\uB85C\uB4DC"
  },
  qrcode: {
    expiredText: "\uB9CC\uB8CC\uB428",
    refreshText: "\uC0C8\uB85C \uACE0\uCE58\uB2E4",
    scannedText: "\uC2A4\uCE94\uB428"
  }
};

export { koKR as default };
//# sourceMappingURL=ko_KR.js.map
