/**
 * tdesign v1.13.1
 * (c) 2025 tdesign
 * @license MIT
 */

import { _ as _typeof } from '../_chunks/dep-b703e6a4.js';
import { c as commonjsGlobal } from '../_chunks/dep-25abb26d.js';
import dayjs from 'dayjs';

var zhTw = {exports: {}};

(function (module, exports) {
  !function (_, e) {
    module.exports = e(dayjs) ;
  }(commonjsGlobal, function (_) {

    function e(_) {
      return _ && "object" == _typeof(_) && "default" in _ ? _ : {
        "default": _
      };
    }
    var t = e(_),
      d = {
        name: "zh-tw",
        weekdays: "星期日_星期一_星期二_星期三_星期四_星期五_星期六".split("_"),
        weekdaysShort: "週日_週一_週二_週三_週四_週五_週六".split("_"),
        weekdaysMin: "日_一_二_三_四_五_六".split("_"),
        months: "一月_二月_三月_四月_五月_六月_七月_八月_九月_十月_十一月_十二月".split("_"),
        monthsShort: "1月_2月_3月_4月_5月_6月_7月_8月_9月_10月_11月_12月".split("_"),
        ordinal: function ordinal(_, e) {
          return "W" === e ? _ + "週" : _ + "日";
        },
        formats: {
          LT: "HH:mm",
          LTS: "HH:mm:ss",
          L: "YYYY/MM/DD",
          LL: "YYYY年M月D日",
          LLL: "YYYY年M月D日 HH:mm",
          LLLL: "YYYY年M月D日dddd HH:mm",
          l: "YYYY/M/D",
          ll: "YYYY年M月D日",
          lll: "YYYY年M月D日 HH:mm",
          llll: "YYYY年M月D日dddd HH:mm"
        },
        relativeTime: {
          future: "%s內",
          past: "%s前",
          s: "幾秒",
          m: "1 分鐘",
          mm: "%d 分鐘",
          h: "1 小時",
          hh: "%d 小時",
          d: "1 天",
          dd: "%d 天",
          M: "1 個月",
          MM: "%d 個月",
          y: "1 年",
          yy: "%d 年"
        },
        meridiem: function meridiem(_, e) {
          var t = 100 * _ + e;
          return t < 600 ? "凌晨" : t < 900 ? "早上" : t < 1100 ? "上午" : t < 1300 ? "中午" : t < 1800 ? "下午" : "晚上";
        }
      };
    return t["default"].locale(d, null, !0), d;
  });
})(zhTw);

var zhTW = {
  autoComplete: {
    empty: "\u66AB\u7121\u6578\u64DA"
  },
  pagination: {
    itemsPerPage: "{size} \u9805/\u9801",
    jumpTo: "\u8DF3\u81F3",
    page: "\u9801",
    total: "\u5171 {count} \u9805\u6578\u64DA"
  },
  cascader: {
    empty: "\u66AB\u7121\u6578\u64DA",
    loadingText: "\u8F09\u5165\u4E2D",
    placeholder: "\u8ACB\u9078\u64C7"
  },
  calendar: {
    yearSelection: "{year} \u5E74",
    monthSelection: "{month} \u6708",
    yearRadio: "\u5E74",
    monthRadio: "\u6708",
    hideWeekend: "\u96B1\u85CF\u9031\u672B",
    showWeekend: "\u986F\u793A\u9031\u672B",
    today: "\u4ECA\u5929",
    thisMonth: "\u672C\u6708",
    week: "\u4E00,\u4E8C,\u4E09,\u56DB,\u4E94,\u516D,\u65E5",
    cellMonth: "1 \u6708,2 \u6708,3 \u6708,4 \u6708,5 \u6708,6 \u6708,7 \u6708,8 \u6708,9 \u6708,10 \u6708,11 \u6708,12 \u6708"
  },
  transfer: {
    title: "{checked} / {total} \u9805",
    empty: "\u66AB\u7121\u6578\u64DA",
    placeholder: "\u8ACB\u8F38\u5165\u95DC\u9375\u8A5E\u641C\u5C0B"
  },
  timePicker: {
    dayjsLocale: "zh-tw",
    now: "\u6B64\u523B",
    confirm: "\u78BA\u8A8D",
    anteMeridiem: "\u4E0A\u5348",
    postMeridiem: "\u4E0B\u5348",
    placeholder: "\u9078\u64C7\u6642\u9593"
  },
  dialog: {
    confirm: "\u78BA\u8A8D",
    cancel: "\u53D6\u6D88"
  },
  drawer: {
    confirm: "\u78BA\u8A8D",
    cancel: "\u53D6\u6D88"
  },
  popconfirm: {
    confirm: {
      content: "\u78BA\u8A8D"
    },
    cancel: {
      content: "\u53D6\u6D88"
    }
  },
  table: {
    empty: "\u66AB\u7121\u6578\u64DA",
    loadingText: "\u6B63\u5728\u8F09\u5165\u4E2D\uFF0C\u8ACB\u7A0D\u5F8C",
    loadingMoreText: "\u9EDE\u64CA\u8F09\u5165\u66F4\u591A",
    filterInputPlaceholder: "\u8ACB\u8F38\u5165\u5185\u5BB9\uFF08\u7121\u9ED8\u8A8D\u503C\uFF09",
    sortAscendingOperationText: "\u9EDE\u64CA\u5347\u5E8F",
    sortCancelOperationText: "\u9EDE\u64CA\u53D6\u6D88\u6392\u5E8F",
    sortDescendingOperationText: "\u9EDE\u64CA\u964D\u5E8F",
    clearFilterResultButtonText: "\u6E05\u7A7A\u7BE9\u9078",
    columnConfigButtonText: "\u884C\u914D\u7F6E",
    columnConfigTitleText: "\u8868\u683C\u884C\u914D\u7F6E",
    columnConfigDescriptionText: "\u8ACB\u9078\u64C7\u9700\u8981\u5728\u8868\u683C\u4E2D\u986F\u793A\u7684\u6578\u64DA\u884C",
    confirmText: "\u78BA\u8A8D",
    cancelText: "\u53D6\u6D88",
    resetText: "\u91CD\u7F6E",
    selectAllText: "\u5168\u9078",
    searchResultText: "\u641C\u5C0B\"{result}\"\uFF0C\u627E\u5230{count}\u9805\u7D50\u679C"
  },
  select: {
    empty: "\u66AB\u7121\u6578\u64DA",
    loadingText: "\u8F09\u5165\u4E2D",
    placeholder: "\u8ACB\u9078\u64C7"
  },
  tree: {
    empty: "\u66AB\u7121\u6578\u64DA"
  },
  treeSelect: {
    empty: "\u66AB\u7121\u6578\u64DA",
    loadingText: "\u8F09\u5165\u4E2D",
    placeholder: "\u8ACB\u9078\u64C7"
  },
  datePicker: {
    dayjsLocale: "zh-tw",
    placeholder: {
      date: "\u8ACB\u9078\u64C7\u65E5\u671F",
      month: "\u8ACB\u9078\u64C7\u6708\u4EFD",
      year: "\u8ACB\u9078\u64C7\u5E74\u4EFD",
      quarter: "\u8ACB\u9078\u64C7\u5B63\u5EA6",
      week: "\u8ACB\u9078\u64C7\u5468"
    },
    weekdays: ["\u4E00", "\u4E8C", "\u4E09", "\u56DB", "\u4E94", "\u516D", "\u65E5"],
    months: ["1\u6708", "2\u6708", "3\u6708", "4\u6708", "5\u6708", "6\u6708", "7\u6708", "8\u6708", "9\u6708", "10\u6708", "11\u6708", "12\u6708"],
    quarters: ["\u4E00\u5B63\u5EA6", "\u4E8C\u5B63\u5EA6", "\u4E09\u5B63\u5EA6", "\u56DB\u5B63\u5EA6"],
    rangeSeparator: " - ",
    direction: "ltr",
    format: "YYYY-MM-DD",
    dayAriaLabel: "\u65E5",
    weekAbbreviation: "\u9031",
    yearAriaLabel: "\u5E74",
    monthAriaLabel: "\u6708",
    confirm: "\u78BA\u8A8D",
    selectTime: "\u9078\u64C7\u6642\u9593",
    selectDate: "\u9078\u64C7\u65E5\u671F",
    nextYear: "\u4E0B\u4E00\u5E74",
    preYear: "\u4E0A\u4E00\u5E74",
    nextMonth: "\u4E0B\u500B\u6708",
    preMonth: "\u4E0A\u500B\u6708",
    preDecade: "\u4E0A\u5341\u5E74",
    nextDecade: "\u4E0B\u5341\u5E74",
    now: "\u7576\u524D"
  },
  upload: {
    sizeLimitMessage: "\u6587\u4EF6\u5927\u5C0F\u4E0D\u80FD\u8D85\u904E {sizeLimit}",
    cancelUploadText: "\u53D6\u6D88\u4E0A\u50B3",
    triggerUploadText: {
      fileInput: "\u9078\u64C7\u6587\u4EF6",
      image: "\u9EDE\u64CA\u4E0A\u50B3\u5716\u7247",
      normal: "\u9EDE\u64CA\u4E0A\u50B3",
      reupload: "\u91CD\u65B0\u9078\u64C7",
      continueUpload: "\u7E7C\u7E8C\u9078\u64C7",
      "delete": "\u522A\u9664",
      uploading: "\u4E0A\u50B3\u4E2D"
    },
    dragger: {
      dragDropText: "\u91CB\u653E\u9F20\u6A19",
      draggingText: "\u62D6\u62FD\u5230\u6B64\u5340\u57DF",
      clickAndDragText: "\u9EDE\u64CA\u4E0A\u65B9\u201C\u9078\u64C7\u6587\u4EF6\u201D\u6216\u5C07\u6587\u4EF6\u62D6\u62FD\u5230\u6B64\u5340\u57DF"
    },
    file: {
      fileNameText: "\u6587\u4EF6\u540D",
      fileSizeText: "\u6587\u4EF6\u5927\u5C0F",
      fileStatusText: "\u72C0\u614B",
      fileOperationText: "\u64CD\u4F5C",
      fileOperationDateText: "\u4E0A\u50B3\u65E5\u671F"
    },
    progress: {
      uploadingText: "\u6B63\u5728\u4E0A\u50B3",
      waitingText: "\u7B49\u5F85\u4E0A\u50B3",
      failText: "\u4E0A\u50B3\u5931\u6557",
      successText: "\u4E0A\u50B3\u6210\u529F"
    }
  },
  form: {
    errorMessage: {
      date: "\u8ACB\u8F38\u5165\u6B63\u78BA\u7684${name}",
      url: "\u8ACB\u8F38\u5165\u6B63\u78BA\u7684${name}",
      whitespace: "${name}\u4E0D\u80FD\u70BA\u7A7A",
      required: "${name}\u5FC5\u586B",
      max: "${name}\u5B57\u7B26\u9577\u5EA6\u4E0D\u80FD\u8D85\u904E ${validate} \u500B\u5B57\u7B26\uFF0C\u4E00\u500B\u4E2D\u6587\u7B49\u65BC\u5169\u500B\u5B57\u7B26",
      min: "${name}\u5B57\u7B26\u9577\u5EA6\u4E0D\u80FD\u5C11\u65BC ${validate} \u500B\u5B57\u7B26\uFF0C\u4E00\u500B\u4E2D\u6587\u7B49\u65BC\u5169\u500B\u5B57\u7B26",
      len: "${name}\u5B57\u7B26\u9577\u5EA6\u5FC5\u9808\u662F ${validate}",
      "enum": "${name}\u53EA\u80FD\u662F${validate}\u7B49",
      idcard: "\u8ACB\u8F38\u5165\u6B63\u78BA\u7684${name}",
      telnumber: "\u8ACB\u8F38\u5165\u6B63\u78BA\u7684${name}",
      pattern: "\u8ACB\u8F38\u5165\u6B63\u78BA\u7684${name}",
      validator: "${name}\u4E0D\u7B26\u5408\u8981\u6C42",
      "boolean": "${name}\u6578\u64DA\u985E\u578B\u5FC5\u9808\u662F\u5E03\u6797\u985E\u578B",
      number: "${name}\u5FC5\u9808\u662F\u6578\u5B57"
    },
    colonText: "\uFF1A"
  },
  input: {
    placeholder: "\u8ACB\u8F38\u5165"
  },
  list: {
    loadingText: "\u6B63\u5728\u8F09\u5165\u4E2D\uFF0C\u8ACB\u7A0D\u5F8C",
    loadingMoreText: "\u9EDE\u64CA\u8F09\u5165\u66F4\u591A"
  },
  alert: {
    expandText: "\u5C55\u958B\u66F4\u591A",
    collapseText: "\u6536\u8D77"
  },
  anchor: {
    copySuccessText: "\u9023\u7D50\u8907\u88FD\u6210\u529F",
    copyText: "\u8907\u88FD\u9023\u7D50"
  },
  colorPicker: {
    swatchColorTitle: "\u7CFB\u7D71\u9810\u8A2D\u9854\u8272",
    recentColorTitle: "\u6700\u8FD1\u4F7F\u7528\u7684\u9854\u8272",
    clearConfirmText: "\u78BA\u5B9A\u6E05\u7A7A\u6700\u8FD1\u4F7F\u7528\u7684\u9854\u8272\u55CE\uFF1F",
    singleColor: "\u55AE\u8272",
    gradientColor: "\u6F38\u8B8A"
  },
  guide: {
    finishButtonProps: {
      content: "\u5B8C\u6210",
      theme: "primary"
    },
    nextButtonProps: {
      content: "\u4E0B\u4E00\u6B65",
      theme: "primary"
    },
    skipButtonProps: {
      content: "\u8DF3\u904E",
      theme: "default"
    },
    prevButtonProps: {
      content: "\u4E0A\u4E00\u6B65",
      theme: "default"
    }
  },
  image: {
    errorText: "\u5716\u7247\u7121\u6CD5\u986F\u793A",
    loadingText: "\u5716\u7247\u8F09\u5165\u4E2D"
  },
  imageViewer: {
    errorText: "\u5716\u7247\u8F09\u5165\u5931\u6557\uFF0C\u53EF\u5617\u8A66\u91CD\u65B0\u8F09\u5165",
    mirrorTipText: "\u93E1\u50CF",
    rotateTipText: "\u65CB\u8F49",
    originalSizeTipText: "\u539F\u59CB\u5927\u5C0F"
  },
  typography: {
    expandText: "\u5C55\u958B",
    collapseText: "\u6536\u8D77",
    copiedText: "\u5FA9\u88FD\u6210\u529F"
  },
  rate: {
    rateText: ["\u6975\u5DEE", "\u5931\u671B", "\u4E00\u822C", "\u6EFF\u610F", "\u9A5A\u559C"]
  },
  empty: {
    titleText: {
      maintenance: "\u5EFA\u8A2D\u4E2D",
      success: "\u6210\u529F",
      fail: "\u5931\u6557",
      empty: "\u66AB\u7121\u6578\u64DA",
      networkError: "\u7DB2\u7D61\u932F\u8AA4"
    }
  },
  descriptions: {
    colonText: "\uFF1A"
  },
  chat: {
    placeholder: "\u8ACB\u8F38\u5165\u8A0A\u606F...",
    stopBtnText: "\u4E2D\u6B62",
    refreshTipText: "\u91CD\u65B0\u751F\u6210",
    copyTipText: "\u8907\u88FD",
    likeTipText: "\u8B9A",
    dislikeTipText: "\u8E29",
    copyCodeBtnText: "\u8907\u88FD\u7A0B\u5F0F\u78BC",
    copyCodeSuccessText: "\u5DF2\u8907\u88FD",
    clearHistoryBtnText: "\u6E05\u7A7A\u6B77\u53F2\u8A18\u9304",
    copyTextSuccess: "\u5DF2\u6210\u529F\u8907\u88FD\u5230\u526A\u8CBC\u7C3F",
    copyTextFail: "\u8907\u88FD\u5230\u526A\u8CBC\u7C3F\u5931\u6557",
    confirmClearHistory: "\u78BA\u5B9A\u8981\u6E05\u7A7A\u6240\u6709\u7684\u6D88\u606F\u55CE\uFF1F",
    loadingText: "\u601D\u8003\u4E2D...",
    loadingEndText: "\u5DF2\u6DF1\u5EA6\u601D\u8003",
    uploadImageText: "\u4E0A\u50B3\u5716\u7247",
    uploadAttachmentText: "\u4E0A\u50B3\u9644\u4EF6"
  },
  qrcode: {
    expiredText: "\u4E8C\u7DAD\u78BC\u904E\u671F",
    refreshText: "\u9EDE\u64CA\u5237\u65B0",
    scannedText: "\u5DF2\u6383\u63CF"
  }
};

export { zhTW as default };
//# sourceMappingURL=zh_TW.js.map
