/**
 * tdesign v1.13.1
 * (c) 2025 tdesign
 * @license MIT
 */

import { _ as _toConsumableArray } from '../_chunks/dep-80f26a18.js';
import { _ as _typeof } from '../_chunks/dep-b703e6a4.js';
import { l as listMap, f as fetchListInstance } from '../_chunks/dep-09d0a451.js';
import { setGlobalConfig, getConfig } from './config.js';
import '../_chunks/dep-8780bcdf.js';
import '../_chunks/dep-4d3bcd6b.js';
import 'react';
import 'classnames';
import 'tdesign-icons-react';
import '../_chunks/dep-5965bf34.js';
import '../_util/react-render.js';
import '../_chunks/dep-52d831fb.js';
import 'react-dom';
import '../hooks/useConfig.js';
import '../config-provider/ConfigContext.js';
import 'lodash-es';
import '../_chunks/dep-ee1d6f73.js';
import '../_chunks/dep-25abb26d.js';
import 'dayjs';
import '../_util/noop.js';
import '../_util/parseTNode.js';
import '../_chunks/dep-d564deee.js';
import '../hooks/useGlobalIcon.js';
import './defaultProps.js';
import '../hooks/useDefaultProps.js';
import '../config-provider/ConfigProvider.js';
import '../common/PluginContainer.js';

var renderNotification = function renderNotification(theme, options) {
  if (_typeof(options) !== "object") return;
  var configs = getConfig(options);
  var placement = configs.placement;
  var attach = function () {
    var containerId = "tdesign-notification-".concat(placement);
    var container = document.querySelector("#".concat(containerId));
    if (container && container instanceof HTMLElement) {
      return container;
    }
    var element = document.createElement("div");
    element.setAttribute("id", containerId);
    if (options.attach && typeof options.attach === "string") {
      var container2 = document.querySelector(options.attach);
      if (container2 instanceof HTMLElement) return container2.appendChild(element);
    }
    if (options.attach instanceof HTMLElement) return options.attach.appendChild(element);
    document.body.appendChild(element);
    return element;
  }();
  return fetchListInstance(placement, attach, configs.zIndex).then(function (listInstance) {
    return listInstance.push(theme, configs);
  });
};
var NotificationPlugin = function NotificationPlugin(theme, props) {
  return renderNotification(theme, props);
};
NotificationPlugin.info = function (options) {
  return renderNotification("info", options);
};
NotificationPlugin.success = function (options) {
  return renderNotification("success", options);
};
NotificationPlugin.warning = function (options) {
  return renderNotification("warning", options);
};
NotificationPlugin.error = function (options) {
  return renderNotification("error", options);
};
NotificationPlugin.close = function (promise) {
  return promise.then(function (instance) {
    return instance.close();
  });
};
NotificationPlugin.closeAll = function () {
  return _toConsumableArray(listMap.values()).forEach(function (list) {
    return list.removeAll();
  });
};
NotificationPlugin.config = function (options) {
  return setGlobalConfig(options);
};

export { NotificationPlugin };
//# sourceMappingURL=NotificationPlugin.js.map
