/**
 * tdesign v1.13.1
 * (c) 2025 tdesign
 * @license MIT
 */

import useConfig from '../hooks/useConfig.js';
import 'react';
import '../config-provider/ConfigContext.js';
import '../_chunks/dep-4d3bcd6b.js';
import '../_chunks/dep-b703e6a4.js';
import 'lodash-es';
import '../_chunks/dep-ee1d6f73.js';
import '../_chunks/dep-25abb26d.js';
import 'dayjs';

var useTabClass = function useTabClass() {
  var _useConfig = useConfig(),
    classPrefix = _useConfig.classPrefix;
  var tdTabsClassPrefix = "".concat(classPrefix, "-tabs");
  var tdTabPanelClassPrefix = "".concat(classPrefix, "-tab-panel");
  var tdClassGenerator = function tdClassGenerator(append) {
    return "".concat(classPrefix, "-").concat(append);
  };
  var tdTabsClassGenerator = function tdTabsClassGenerator(append) {
    return "".concat(tdTabsClassPrefix, "__").concat(append);
  };
  var tdTabPanelClassGenerator = function tdTabPanelClassGenerator(append) {
    return "".concat(tdTabPanelClassPrefix, "__").concat(append);
  };
  var tdSizeClassGenerator = function tdSizeClassGenerator(size) {
    return "".concat(classPrefix, "-size-").concat(size === "large" ? "l" : "m");
  };
  return {
    tdTabsClassPrefix: tdTabsClassPrefix,
    tdTabPanelClassPrefix: tdTabPanelClassPrefix,
    tdClassGenerator: tdClassGenerator,
    tdTabsClassGenerator: tdTabsClassGenerator,
    tdTabPanelClassGenerator: tdTabPanelClassGenerator,
    tdSizeClassGenerator: tdSizeClassGenerator
  };
};

export { useTabClass };
//# sourceMappingURL=useTabClass.js.map
