/**
 * 当标签数量过多时，输入框显示不下，则需要滚动查看，以下为滚动逻辑
 * 如果标签过多时的处理方式，是标签省略，则不需要此功能
 */
import { WheelEvent } from 'react';
import { TdTagInputProps } from './type';
export default function useTagScroll(props: TdTagInputProps): {
    initScroll: (element: HTMLDivElement) => void;
    clearScroll: () => void;
    tagInputRef: import("react").MutableRefObject<{
        currentElement: HTMLDivElement;
    }>;
    scrollElement: HTMLDivElement;
    scrollDistance: number;
    scrollTo: (distance: number) => void;
    scrollToRight: () => void;
    scrollToLeft: () => void;
    updateScrollElement: (element: HTMLDivElement) => void;
    updateScrollDistance: () => void;
    onWheel: ({ e }: {
        e: WheelEvent<HTMLDivElement>;
    }) => void;
    scrollToRightOnEnter: () => void;
    scrollToLeftOnLeave: () => void;
};
