import { RefObject, DragEvent } from 'react';
import { TreeNode } from '@tdesign/common-js/tree-v1/tree-node';
import { DropPosition } from '../interface';
import type { TdTreeProps } from '../type';
export default function useDraggable(props: {
    nodeRef: RefObject<HTMLElement | undefined>;
    node: TreeNode;
    allowDrop?: TdTreeProps['allowDrop'];
}): {
    setDragStatus: (status: "dragStart" | "dragOver" | "dragLeave" | "dragEnd" | "drop", e: DragEvent<HTMLDivElement>) => void;
    isDragOver: boolean;
    isDragging: boolean;
    dropPosition: DropPosition;
};
